Hadoop Change Log

Trunk (Unreleased)

  INCOMPATIBLE CHANGES

    HADOOP-8124. Remove the deprecated FSDataOutputStream constructor,
    FSDataOutputStream.sync() and Syncable.sync().  (szetszwo)

    HADOOP-10474 Move o.a.h.record to hadoop-streaming. (wheat9)

    HADOOP-9902. Shell script rewrite (aw)

    HADOOP-10950. rework heap management vars (John Smith via aw)

    HADOOP-6857. FsShell should report raw disk usage including replication
    factor. (Byron Wong via shv)

    HADOOP-11657. Align the output of `hadoop fs -du` to be more Unix-like.
    (aajisaka)

    HADOOP-11553. Formalize the shell API (aw)

    HADOOP-11731. Rework the changelog and releasenotes (aw)

    HADOOP-11627. Remove io.native.lib.available.
    (Brahma Reddy Battula via aajisaka)

  NEW FEATURES

    HADOOP-6590. Add a username check for hadoop sub-commands (John Smith via
    aw)

    HADOOP-11353. Add support for .hadooprc (aw)

    HADOOP-9044. add FindClass main class to provide classpath checking
    of installations (Steve Loughran via aw)

    HADOOP-11485. Pluggable shell integration (aw)

    HADOOP-8934. Shell command ls should include sort options (Jonathan Allen
    via aw)

    HADOOP-11554. Expose HadoopKerberosName as a hadoop subcommand (aw)

    HADOOP-11565. Add --slaves shell option (aw)

    HADOOP-9642. Configuration to resolve environment variables via
    ${env.VARIABLE} references (Kengo Seki via aw)

  IMPROVEMENTS

    HADOOP-8017. Configure hadoop-main pom to get rid of M2E plugin execution
    not covered (Eric Charles via bobby)

    HADOOP-8015. ChRootFileSystem should extend FilterFileSystem 
    (Daryn Sharp via bobby)

    HADOOP-7595. Upgrade dependency to Avro 1.5.3. (Alejandro Abdelnur via atm)

    HADOOP-8078. Add capability to turn on security in unit tests. (Jaimin 
    Jetly via jitendra)

    HADOOP-7757. Test file reference count is at least 3x actual value (Jon
    Eagles via bobby)

    HADOOP-8147. test-patch should run tests with -fn to avoid masking test
    failures (Robert Evans via tgraves)

    HADOOP-8290. Remove remaining references to hadoop.native.lib (harsh)

    HADOOP-8308. Support cross-project Jenkins builds. (tomwhite)

    HADOOP-8297. Writable javadocs don't carry default constructor (harsh)

    HADOOP-8360. empty-configuration.xml fails xml validation
    (Radim Kolar via harsh)

    HADOOP-7659. fs -getmerge isn't guaranteed to work well over non-HDFS
    filesystems (harsh)

    HADOOP-8434. Add tests for Configuration setter methods.
    (Madhukara Phatak via suresh)

    HADOOP-8523. test-patch.sh doesn't validate patches before building
    (Jack Dintruff via jeagles)

    HADOOP-8719. Workaround for kerberos-related log errors upon running any
    hadoop command on OSX. (Jianbin Wei via harsh)

    HADOOP-8588. SerializationFactory shouldn't throw a
    NullPointerException if the serializations list is empty.
    (Sho Shimauchi via harsh)

    HADOOP-7930. Kerberos relogin interval in UserGroupInformation
    should be configurable (Robert Kanter via harsh)

    HADOOP-8838. Colorize the test-patch output sent to JIRA (Harsh J via
    bobby)

    HADOOP-8840. Fix the test-patch colorizer to cover all sorts of +1 lines.
    (Harsh J via bobby)

    HADOOP-8864. Addendum to HADOOP-8840: Add a coloring case for +0 results
    too. (harsh)

    HADOOP-8910. Add examples to GlobExpander#expand method. (suresh)

    HADOOP-8920. Add more javadoc to metrics2 related classes. (suresh)

    HADOOP-8776. Provide an option in test-patch that can enable/disable
    compiling native code. (Chris Nauroth via suresh)

    HADOOP-6616. Improve documentation for rack awareness. (Adam Faris via 
    jghoman)

    HADOOP-9075. FileContext#FSLinkResolver should be made static.
    (Arpit Agarwal via suresh)

    HADOOP-9277. Improve javadoc for FileContext. (Andrew Wang via suresh)

    HADOOP-9258 Add stricter tests to FileSystemContractTestBase (stevel)

    HADOOP-9486. Promoted Windows and Shell related utils from YARN to Hadoop
    Common. (Chris Nauroth via vinodkv)

    HADOOP-8844. Add a plaintext fs -text test-case.
    (Akira AJISAKA via harsh)

    HADOOP-9432 Add support for markdown .md files in site documentation 
    (stevel)

    HADOOP-9186.  test-patch.sh should report build failure to JIRA.
    (Binglin Chang via Colin Patrick McCabe)

    HADOOP-9833 move slf4j to version 1.7.5 (Kousuke Saruta via stevel)

    HADOOP-10325. Improve jenkins javadoc warnings from test-patch.sh (cmccabe)

    HADOOP-10342. Add a new method to UGI to use a Kerberos login subject to
    build a new UGI. (Larry McCay via omalley)

    HADOOP-10485. Remove dead classes in hadoop-streaming. (wheat9)

    HADOOP-11013. CLASSPATH handling should be consolidated, debuggable (aw)

    HADOOP-11041. VersionInfo specifies subversion (Tsuyoshi OZAWA via aw)

    HADOOP-11092. hadoop shell commands should print usage if not given a
    a class (aw)

    HADOOP-11231. Remove dead code in ServletUtil. (Li Lu via wheat9)

    HADOOP-11025. hadoop-daemons.sh should just call hdfs directly (Masatake
    Iwasaki via aw)

    HADOOP-11150. hadoop command should show the reason on failure by 
    invalid COMMAND or CLASSNAME (Masatake Iwasaki via aw)

    HADOOP-11208. Replace "daemon" with better name in script subcommands (aw)

    HADOOP-10926. Improve smart-apply-patch.sh to apply binary diffs (cmccabe)

    HADOOP-11081. Document hadoop properties expected to be set by the shell 
    code in *-env.sh (aw)

    HADOOP-11352 Clean up test-patch.sh to disable "+1 contrib tests"
    (Akira AJISAKA via stevel)

    HADOOP-10788. Rewrite kms to use new shell framework (John Smith via aw)

    HADOOP-11058. Missing HADOOP_CONF_DIR generates strange results
    (Masatake Iwasaki via aw)

    HADOOP-11460. Deprecate shell vars (John Smith via aw)

    HADOOP-11346. Rewrite sls/rumen to use new shell framework (John Smith
    via aw)

    HADOOP-6964. Allow compact property description in xml (Kengo Seki
    via aw)

    HADOOP-11575. Daemon log documentation is misleading
    (Naganarasimha G R via aw)

    HADOOP-11596. Allow smart-apply-patch.sh to add new files in binary git
    patches (raviprak)

    HADOOP-11593. Convert site documentation from apt to markdown (stragglers)
    (Masatake Iwasaki via aw)

    HADOOP-11673. Skip using JUnit Assume in TestCodec. (Brahma Reddy Battula
    via cdouglas)

    HADOOP-10115. Exclude duplicate jars in hadoop package under different
    component's lib (Vinayakumar B via aw)

    HADOOP-11524. hadoop_do_classpath_subcommand throws a shellcheck warning.
    (cnauroth)

    HADOOP-11781. fix race conditions and add URL support to
    smart-apply-patch.sh (Raymie Stata via aw)

    HADOOP-11850. Typos in hadoop-common java docs. (Surendra Singh Lilhore
    via jghoman)

    HADOOP-11852. Disable symlinks in trunk. (Andrew Wang)

    HADOOP-11857. Fix CommandFormat#commandFormat java doc annotation.
    (J.Andreina via jghoman)

    HADOOP-11813. releasedocmaker.py should use today's date instead of
    unreleased (Darrell Taylor via aw)

    HADOOP-11590. Update sbin commands and documentation to use new --slaves
    option (aw)

    HADOOP-10993. Dump java command line to *.out file
    (Kengo Seki via vinayakumarb)

  BUG FIXES

    HADOOP-11473. test-patch says "-1 overall" even when all checks are +1
    (Jason Lowe via raviprak)

    HADOOP-9451. Fault single-layer config if node group topology is enabled.
    (Junping Du via llu)

    HADOOP-8419. Fixed GzipCode NPE reset for IBM JDK. (Yu Li via eyang)

    HADOOP-8177. MBeans shouldn't try to register when it fails to create 
    MBeanName. (Devaraj K via umamahesh)

    HADOOP-8018.  Hudson auto test for HDFS has started throwing javadoc
    (Jon Eagles via bobby)

    HADOOP-7610. Fix for hadoop debian package (Eric Yang via gkesavan)

    HADOOP-7641. Add Apache License to template config files.
    (Eric Yang via atm)

    HADOOP-7621. alfredo config should be in a file not readable by users
    (Alejandro Abdelnur via atm)
    
    HADOOP-7669  Fix newly introduced release audit warning. 
    (Uma Maheswara Rao G via stevel)
    
    HADOOP-6220. HttpServer wraps InterruptedExceptions by IOExceptions 
    if interrupted in startup (stevel)

    HADOOP-7703. Improved exception handling of shutting down web server.
    (Devaraj K via Eric Yang)

    HADOOP-7704. Reduce number of object created by JMXJsonServlet.
    (Devaraj K via Eric Yang)

    HADOOP-7769. TestJMXJsonServlet is failing. (tomwhite)

    HADOOP-7770. ViewFS getFileChecksum throws FileNotFoundException for files in 
    /tmp and /user. (Ravi Prakash via jitendra)

    HADOOP-8141. Add method to SecurityUtil to init krb5 cipher suites.
    (todd)

    HADOOP-7788. Add simple HealthMonitor class to watch an HAService (todd)

    HADOOP-8312. testpatch.sh should provide a simpler way to see which
    warnings changed (bobby)

    HADOOP-8339. jenkins complaining about 16 javadoc warnings 
    (Tom White and Robert Evans via tgraves)

    HADOOP-8354. test-patch findbugs may fail if a dependent module is changed
    (Tom White and Robert Evans)

    HADOOP-8375. test-patch should stop immediately once it has found
    compilation errors (bobby)

    HADOOP-8395. Text shell command unnecessarily demands that a
    SequenceFile's key class be WritableComparable (harsh)

    HADOOP-8413. test-patch.sh gives out the wrong links for
    newPatchFindbugsWarnings (Colin Patrick McCabe via bobby)

    HADOOP-6871. When the value of a configuration key is set to its
    unresolved form, it causes the IllegalStateException in
    Configuration.get() stating that substitution depth is too large.
    (Arvind Prabhakar via harsh)

    HADOOP-8548. test-patch.sh shows an incorrect link in Jekins builds
    (Kihwal Lee via bobby)

    HADOOP-8110. Fix trash checkpoint collisions (Jason Lowe via daryn)

    HADOOP-8584. test-patch.sh should not immediately exit when no
    tests are added or modified. (Colin Patrick McCabe via eli)

    HADOOP-8521. Port StreamInputFormat to new Map Reduce API (madhukara
    phatak via bobby)

    HADOOP-8593. Add missed @Override annotations in Metric/Metrics2 package.
    (Brandon Li via suresh)

    HADOOP-8623. hadoop jar command should respect HADOOP_OPTS.
    (Steven Willis via suresh)

    HADOOP-8684. Deadlock between WritableComparator and WritableComparable.
    (Jing Zhao via suresh)

    HADOOP-8786. HttpServer continues to start even if AuthenticationFilter
    fails to init (todd)

    HADOOP-8767. Secondary namenode is started on slave nodes instead of
    master nodes. (Giovanni Delussu via suresh)

    HADOOP-8818. Use equals instead == in MD5MD5CRC32FileChecksum
    and TFileDumper. (Brandon Li via suresh)

    HADOOP-8821. Fix findbugs warning related to concatenating string in a 
    for loop in Configuration#dumpDeprecatedKeys(). (suresh)

    HADOOP-7256. Resource leak during failure scenario of closing
    of resources. (Ramkrishna S. Vasudevan via harsh)

    HADOOP-8151. Error handling in snappy decompressor throws invalid
    exceptions. (Matt Foley via harsh)

    HADOOP-8813. Add InterfaceAudience and InterfaceStability annotations
    to RPC Server and Client classes. (Brandon Li via suresh)

    HADOOP-8436. NPE In getLocalPathForWrite ( path, conf ) when the
    required context item is not configured
    (Brahma Reddy Battula via harsh)

    HADOOP-8386. hadoop script doesn't work if 'cd' prints to stdout
    (default behavior in some bash setups (esp. Ubuntu))
    (Chiristopher Berner and Andy Isaacson via harsh)

    HADOOP-8839. test-patch's -1 on @author tag presence doesn't cause
    a -1 to the overall result (harsh)

    HADOOP-8918. test-patch.sh is parsing modified files wrong.
    (Raja Aluri via suresh)

    HADOOP-8974. TestDFVariations fails on Windows. (Chris Nauroth via suresh)

    HADOOP-9037. Bug in test-patch.sh and precommit build process (Kihwal Lee
    via jlowe)

    HADOOP-9121. InodeTree.java has redundant check for vName while 
    throwing exception. (Arup Malakar via suresh)

    HADOOP-9131. Turn off TestLocalFileSystem#testListStatusWithColons on
    Windows. (Chris Nauroth via suresh)

    HADOOP-9139. improve killKdc.sh (Ivan A. Veselovsky via bobby)

    HADOOP-9202. test-patch.sh fails during mvn eclipse:eclipse if patch adds
    a new module to the build (Chris Nauroth via bobby)

    HADOOP-9249. hadoop-maven-plugins version-info goal causes build failure
    when running with Clover. (Chris Nauroth via suresh)

    HADOOP-9393. TestRPC fails with JDK7. (Andrew Wang via atm)

    HADOOP-9394. Port findHangingTest.sh from HBase to Hadoop. (Andrew Wang
    via atm)

    HADOOP-9431 TestSecurityUtil#testLocalHostNameForNullOrWild on systems where hostname
    contains capital letters  (Chris Nauroth via sanjay)

    HADOOP-9261 S3n filesystem can move a directory under itself -and so lose data
    (fixed in HADOOP-9258) (stevel)

    HADOOP-9265 S3 blockstore filesystem breaks part of the Filesystem contract
    (fixed in HADOOP-9258) (stevel)

    HADOOP-9433 TestLocalFileSystem#testHasFileDescriptor leaks file handle
    (Chris Nauroth via sanjay)

    HADOOP-9583. test-patch gives +1 despite build failure when running tests.
    (jlowe via kihwal)

    HADOOP-9847. TestGlobPath symlink tests fail to cleanup properly.
    (cmccabe via wang)

    HADOOP-9740. Fix FsShell '-text' command to be able to read Avro
    files stored in HDFS and other filesystems. (Allan Yan via cutting)

    HADOOP-10044 Improve the javadoc of rpc code (sanjay Radia)

    HADOOP-10625. Trim configuration names when putting/getting them
    to properties. (Wangda Tan via xgong)

    HADOOP-10831. UserProvider is not thread safe. (Benoy Antony via umamahesh)

    HADOOP-10834. Typo in CredentialShell usage. (Benoy Antony via umamahesh)

    HADOOP-11002. shell escapes are incompatible with previous releases (aw)

    HADOOP-10996. Stop violence in the *_HOME (aw)

    HADOOP-11033. shell scripts ignore JAVA_HOME on OS X. (aw)

    HADOOP-11052. hadoop_verify_secure_prereq's results aren't checked 
    in bin/hdfs (aw)

    HADOOP-11055. non-daemon pid files are missing (aw)

    HADOOP-11022. User replaced functions get lost 2-3 levels deep (e.g., 
    sbin) (aw)

    HADOOP-11284. Fix variable name mismatches in hadoop-functions.sh (Masatake
    Iwasaki via aw)

    HADOOP-11298. slaves.sh and stop-all.sh are missing slashes (aw)

    HADOOP-11296. hadoop-daemons.sh throws 'host1: bash: host3: 
    command not found...' (vinayakumarb)

    HADOOP-11380. Restore Rack Awareness documenation (aw)

    HADOOP-11397. Can't override HADOOP_IDENT_STRING (Kengo Seki via aw)

    HADOOP-10908. Common needs updates for shell rewrite (aw)

    HADOOP-11559. Add links to RackAwareness and InterfaceClassification
    to site index (Masatake Iwasaki via aw)

    HADOOP-11581. Multithreaded correctness Warnings
    #org.apache.hadoop.fs.shell.Ls (Brahma Reddy Battula via aw)

    HADOOP-11580. Remove SingleNodeSetup.md from trunk (aajisaka)

    HADOOP-11583. Fix syntax error in SecureMode.md (Masatake Iwasaki via aw)

    HADOOP-11437. Remove the version and author information from distcp's
    README file (Brahma Reddy Battula via aw)

    HADOOP-11585. Fix formatting in Tracing.md (Masatake Iwasaki via aw)

    HADOOP-11625. Minor fixes to command manual & SLA doc (aw)

    HADOOP-11637. bash location hard-coded in shell scripts (aw)

    HADOOP-10774. Update KerberosTestUtils for hadoop-auth tests when using
    IBM Java (sangamesh via aw)

    HADOOP-11653. shellprofiles should require .sh extension
    (Brahma Reddy Battula via aw)

    HADOOP-11668. hadoop-daemons.sh bw compat broke with --slaves change
    (Vinayakumar B via aw)

    HADOOP-11703. git should ignore .DS_Store files on Mac OS X (Abin Shahab
    via aw)

    HADOOP-11797. releasedocmaker.py needs to put ASF headers on output (aw)

    HADOOP-11865. Incorrect path mentioned in document for accessing script
    files (J.Andreina via aw)

    HADOOP-11775. Fix Javadoc typos in hadoop-openstack module (Yanjun Wang
    via aw)

  OPTIMIZATIONS

    HADOOP-7761. Improve the performance of raw comparisons. (todd)

    HADOOP-8589. ViewFs tests fail when tests and home dirs are nested (sanjay Radia)

Release 2.8.0 - UNRELEASED

  INCOMPATIBLE CHANGES

    HADOOP-11746. rewrite test-patch.sh (aw)

  NEW FEATURES

    HADOOP-11226. Add a configuration to set ipc.Client's traffic class with
    IPTOS_LOWDELAY|IPTOS_RELIABILITY. (Gopal V via ozawa)

    HADOOP-9477. Add posixGroups support for LDAP groups mapping service.
    (Dapeng Sun via Yongjun Zhang)

    HADOOP-11843. Make setting up the build environment easier.
    (Niels Basjes via cnauroth)

  IMPROVEMENTS

    HADOOP-6842. "hadoop fs -text" does not give a useful text representation
    of MapWritable objects (Akira Ajisaka via bobby)

    HADOOP-11719. [Fsshell] Remove bin/hadoop reference from
    GenericOptionsParser default help text.
    (Brahma Reddy Battula via harsh)

    HADOOP-11692. Improve authentication failure WARN message to avoid user
    confusion. (Yongjun Zhang)

    HADOOP-11659. o.a.h.fs.FileSystem.Cache#remove should use a single hash map
    lookup. (Brahma Reddy Battula via aajisaka)

    HADOOP-11709. Time.NANOSECONDS_PER_MILLISECOND - use class-level final
    constant instead of method variable (Ajith S via ozawa)

    HADOOP-11447. Add a more meaningful toString method to SampleStat and 
    MutableStat. (kasha)

    HADOOP-11737. mockito's version in hadoop-nfs’ pom.xml shouldn't be
    specified. (Kengo Seki via ozawa)

    HADOOP-11741. Add LOG.isDebugEnabled() guard for some LOG.debug().
    (Walter Su via ozawa)

    HADOOP-11660. Add support for hardware crc of HDFS checksums on ARM aarch64
    architecture (Edward Nevill via Colin P. McCabe)

    HADOOP-9805. Refactor RawLocalFileSystem#rename for improved testability.
    (Jean-Pierre Matsumoto via cnauroth)

    HADOOP-11717. Support JWT tokens for web single sign on to the Hadoop
    servers. (Larry McCay via omalley)

    HADOOP-11814. Reformat hadoop-annotations, o.a.h.classification.tools.
    (Li Lu via wheat9)

    HADOOP-7713. dfs -count -q should label output column (Jonathan Allen
    via aw)

    HADOOP-11819. HttpServerFunctionalTest#prepareTestWebapp should create web
    app directory if it does not exist. (Rohith via vinayakumarb)

    HADOOP-11827. Speed-up distcp buildListing() using threadpool
    (Zoran Dimitrijevic via raviprak)

    HADOOP-10597. RPC Server signals backoff to clients when all request
    queues are full. (Ming Ma via Arpit Agarwal)

    HADOOP-11357. Print information of the build enviornment in test-patch.sh
    (aw)

    HADOOP-11328. ZKFailoverController does not log Exception when doRun raises
    errors. (Tianyin Xu via ozawa)

    HADOOP-11120. hadoop fs -rmr gives wrong advice. (Juliet Hougland via wang)

    HADOOP-11911. test-patch should allow configuration of default branch
    (Sean Busbey via aw)

    HADOOP-11917. test-patch.sh should work with ${BASEDIR}/patchprocess
    setups (aw)

    HADOOP-11942. Add links to SLGUserGuide to site index.
    (Masatake Iwasaki via xyao)

    HADOOP-11906. test-patch.sh should use 'file' command for patch
    determinism (Sean Busbey via aw)

    HADOOP-11950. Add cli option to test-patch to set the project-under-test
    (Sean Busbey via aw)

    HADOOP-11948. test-patch's issue matching regex should be configurable.
    (Sean Busbey via aw)

    HADOOP-9723. Improve error message when hadoop archive output path already
    exists. (Jean-Baptiste Onofré and Yongjun Zhang via aajisak)

    HADOOP-11713. ViewFileSystem should support snapshot methods.
    (Rakesh R via cnauroth)

  OPTIMIZATIONS

    HADOOP-11785. Reduce the number of listStatus operation in distcp
    buildListing (Zoran Dimitrijevic via Colin P. McCabe)

    HADOOP-11812. Implement listLocatedStatus for ViewFileSystem to speed up
    split calculation (gera)

  BUG FIXES
    HADOOP-11802: DomainSocketWatcher thread terminates sometimes after there
    is an I/O error during requestShortCircuitShm (cmccabe)

    HADOOP-10027. *Compressor_deflateBytesDirect passes instance instead of
    jclass to GetStaticObjectField. (Hui Zheng via cnauroth)

    HADOOP-11724. DistCp throws NPE when the target directory is root.
    (Lei Eddy Xu via Yongjun Zhang) 

    HADOOP-11760. Fix typo of javadoc in DistCp. (Brahma Reddy Battula via
    ozawa).

    HADOOP-11800. Clean up some test methods in TestCodec.java.
    (Brahma Reddy Battula via aajisaka)

    HADOOP-11811. Fix typos in hadoop-project/pom.xml and TestAccessControlList.
    (Brahma Reddy Battula via ozawa)

    HADOOP-11704. DelegationTokenAuthenticationFilter must pass ipaddress
    instead of hostname to ProxyUsers#authorize (Anubhav Dhoot via asuresh)

    HADOOP-11846 TestCertificateUtil.testCorruptPEM failing on Jenkins JDK8.
    (Larry McCay via stevel)

    HADOOP-11859. PseudoAuthenticationHandler fails with httpcomponents v4.4.
    (Eugene Koifman via jitendra)

    HADOOP-11848. Incorrect arguments to sizeof in DomainSocket.c (Malcolm
    Kavalsky via Colin P. McCabe)

    HADOOP-11861. test-patch.sh rewrite addendum patch.
    (Allen Wittenauer via cnauroth)

    HADOOP-11864. JWTRedirectAuthenticationHandler breaks java8 javadocs.
    (Larry McCay via stevel)

    HADOOP-11876. Refactor code to make it more readable, minor
    maybePrintStats bug (Zoran Dimitrijevic via raviprak)

    HADOOP-11870. [JDK8] AuthenticationFilter, CertificateUtil,
    SignerSecretProviders, KeyAuthorizationKeyProvider Javadoc issues (rkanter)

    HADOOP-11881. test-patch.sh javac result is wildly wrong (Kengo Seki via
    aw)

    HADOOP-11821. Fix findbugs warnings in hadoop-sls.
    (Brahma Reddy Battula via aajisaka)

    HADOOP-11866. increase readability and reliability of checkstyle,
    shellcheck, and whitespace reports (aw)

    HADOOP-11491. HarFs incorrectly declared as requiring an authority.
    (Brahma Reddy Battula via gera)

    HADOOP-11889. Make checkstyle runnable from root project
    (Gera Shegalov via jeagles)

    HADOOP-11900. Add failIfNoTests=false to hadoop-build-tools pom. (gera)

    HADOOP-11916. TestStringUtils#testLowerAndUpperStrings failed on MAC
    due to a JVM bug. (Ming Ma via ozawa)

    HADOOP-11904. test-patch.sh goes into an infinite loop on non-maven
    builds (aw)

    HADOOP-11926. test-patch.sh mv does wrong math (aw)

    HADOOP-11912. Extra configuration key used in TraceUtils should respect
    prefix (Masatake Iwasaki via Colin P. McCabe)

    HADOOP-10387. Misspelling of threshold in log4j.properties for tests in
    hadoop-common-project. (Brahma Reddy Battula via aajisaka)

    HADOOP-11936. Dockerfile references a removed image (aw)

    HADOOP-11922. Misspelling of threshold in log4j.properties for tests
    in hadoop-tools (Gabor Liptak via vinayakumarb)

    HADOOP-11877. SnappyDecompressor's Logger class name is wrong
    (surendra singh lilhore via vinayakumarb)

    HADOOP-10356. Corrections in winutils/chmod.c. (Rene Nyffenegger via
    Arpit Agarwal)

    HADOOP-7165. listLocatedStatus(path, filter) is not redefined in FilterFs
    (Hairong Kuang via jlowe)

    HADOOP-9729. The example code of org.apache.hadoop.util.Tool is incorrect
    (hellojinjie via jlowe)

    HADOOP-11928. Test-patch check for @author tags incorrectly flags
    removal of @author tags (Kengo Seki via aw)

    HADOOP-11951. test-patch should give better info about failures to handle
    dev-support updates without resetrepo option (Sean Busbey via aw)

    HADOOP-11947. test-patch should return early from determine-issue when
    run in jenkins mode. (Sean Busbey via aw)

    HADOOP-11962. Sasl message with MD5 challenge text shouldn't be LOG out
    even in debug level. (Junping Du via wheat9)

    HADOOP-11361. Fix a race condition in MetricsSourceAdapter.updateJmxCache.
    (Brahma Reddy Battula via ozawa)

    HADOOP-8174. Remove confusing comment in Path#isAbsolute()
    (Suresh Srinivas via vinayakumarb)

Release 2.7.1 - UNRELEASED

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-11868. Invalid user logins trigger large backtraces in server log
    (Chang Li via jlowe)

    HADOOP-11730. Regression: s3n read failure recovery broken.
    (Takenori Sato via stevel)

    HADOOP-11802. DomainSocketWatcher thread terminates sometimes after there
    is an I/O error during requestShortCircuitShm (cmccabe)

    HADOOP-11891. OsSecureRandom should lazily fill its reservoir (asuresh)

    HADOOP-9658. SnappyCodec#checkNativeCodeLoaded may unexpectedly fail when
    native code is not loaded. (Zhijie Shen via ozawa)

    HADOOP-11663. Remove description about Java 6 from docs.
    (Masatake Iwasaki via aajisaka)

    HADOOP-11966. Variable cygwin is undefined in hadoop-config.sh when executed
    through hadoop-daemon.sh. (cnauroth)

Release 2.7.0 - 2015-04-20

  INCOMPATIBLE CHANGES

    HADOOP-10530 Make hadoop build on Java7+ only (stevel)

  NEW FEATURES

    HADOOP-10987. Provide an iterator-based listing API for FileSystem (kihwal)

    HADOOP-7984. Add hadoop --loglevel option to change log level.
    (Akira AJISAKA via cnauroth)

    HADOOP-9629. Support Windows Azure Storage - Blob as a file system in Hadoop.
    (Dexter Bradshaw, Mostafa Elhemali, Xi Fang, Johannes Klein, David Lao,
    Mike Liddell, Chuan Liu, Lengning Liu, Ivan Mitic, Michael Rys,
    Alexander Stojanovic, Brian Swan, and Min Wei via cnauroth)

    HADOOP-10728. Metrics system for Windows Azure Storage Filesystem.
    (Dexter Bradshaw, Mostafa Elhemali, Xi Fang, Johannes Klein, David Lao,
    Mike Liddell, Chuan Liu, Lengning Liu, Ivan Mitic, Michael Rys,
    Alexander Stojanovich, Brian Swan, and Min Wei via cnauroth)

    HADOOP-8989. hadoop fs -find feature (Jonathan Allen via aw)

    HADOOP-11490. Expose truncate API via FileSystem and shell command.
    (Milan Desai via shv)

    HADOOP-11045. Introducing a tool to detect flaky tests of hadoop jenkins testing
    job. (Yongjun Zhang and Todd Lipcon via ozawa)

    HADOOP-11510. Expose truncate API via FileContext. (yliu)

    HADOOP-11569. Provide Merge API for MapFile to merge multiple similar MapFiles
    to one MapFile. (Vinayakumar B via ozawa)

  IMPROVEMENTS

    HADOOP-11483. HardLink.java should use the jdk7 createLink method (aajisaka)

    HADOOP-11156. DelegateToFileSystem should implement
    getFsStatus(final Path f). (Zhihai Xu via wang)

    HADOOP-11172. Improve error message in Shell#runCommand on OutOfMemoryError.
    (Yongjun Zhang via wang)

    HADOOP-10748. HttpServer2 should not load JspServlet. (wheat9)

    HADOOP-10847. Remove the usage of sun.security.x509.* in testing code.
    (Pascal Oliva via wheat9)

    HADOOP-10563. Remove the dependency of jsp in trunk. (wheat9)

    HADOOP-10786. Fix UGI#reloginFromKeytab on Java 8. (Stephen Chu via wheat9)

    HADOOP-11291. Log the cause of SASL connection failures.
    (Stephen Chu via cnauroth)

    HADOOP-11173. Improve error messages for some KeyShell commands. (wang)

    HADOOP-11257: Update "hadoop jar" documentation to warn against using it
    for launching yarn jars (iwasakims via cmccabe)

    HADOOP-11341. KMS support for whitelist key ACLs. (Arun Suresh via wang)

    HADOOP-11301. [optionally] update jmx cache to drop old metrics
    (Maysam Yabandeh via stack)

    HADOOP-11356. Removed deprecated o.a.h.fs.permission.AccessControlException.
    (Li Lu via wheat9)

    HADOOP-11313. Adding a document about NativeLibraryChecker.
    (Tsuyoshi OZAWA via cnauroth)

    HADOOP-11287. Simplify UGI#reloginFromKeytab for Java 7+.
    (Li Lu via wheat9)

    HADOOP-10476) Bumping the findbugs version to 3.0.0. (wheat9)

    HADOOP-11410. Make the rpath of libhadoop.so configurable (cmccabe)

    HADOOP-11416. Move ChunkedArrayList into hadoop-common (cmccabe)

    HADOOP-10840. Fix OutOfMemoryError caused by metrics system in Azure File
    System. (Shanyu Zhao via cnauroth)

    HADOOP-11248. Add hadoop configuration to disable Azure Filesystem metrics
    collection. (Shanyu Zhao via cnauroth)

    HADOOP-11421. Add IOUtils#listDirectory (cmccabe)

    HADOOP-11427. ChunkedArrayList: fix removal via iterator and implement get
    (cmccabe)

    HADOOP-11430. Add GenericTestUtils#disableLog, GenericTestUtils#setLogLevel
    (cmccabe)

    HADOOP-11422. Check CryptoCodec is AES-CTR for Crypto input/output stream
    (Yi Liu via Colin P. McCabe)

    HADOOP-11213. Typos in html pages: SecureMode and EncryptedShuffle. 
    (Wei Yan via kasha)

    HADOOP-11395. Add site documentation for Azure Storage FileSystem
    integration. (Chris Nauroth via Arpit Agarwal)

    HDFS-7555. Remove the support of unmanaged connectors in HttpServer2.
    (wheat9)

    HADOOP-11399. Java Configuration file and .xml files should be
    automatically cross-compared (rchiang via rkanter)

    HADOOP-11455. KMS and Credential CLI should request confirmation for
    deletion by default. (Charles Lamb via yliu)

    HADOOP-11390 Metrics 2 ganglia provider to include hostname in
    unresolved address problems. (Varun Saxena via stevel)

    HADOOP-11032. Replace use of Guava's Stopwatch with Hadoop's StopWatch
    (ozawa)

    HADOOP-11464. Reinstate support for launching Hadoop processes on Windows
    using Cygwin. (cnauroth)

    HADOOP-9992. Modify the NN loadGenerator to optionally run as a MapReduce job
    (Akshay Radia via brandonli)

    HADOOP-11465. Fix findbugs warnings in hadoop-gridmix. (Varun Saxena via
    Arpit Agarwal)

    HADOOP-11481. ClassCastException while using a key created by keytool to
    create encryption zone. (Charles Lamb via Colin P. Mccabe)

    HADOOP-8757. Metrics should disallow names with invalid characters
    (rchiang via rkanter)

    HADOOP-11261 Set custom endpoint for S3A. (Thomas Demoor via stevel)

    HADOOP-11171 Enable using a proxy server to connect to S3a.
    (Thomas Demoor via stevel)

    HADOOP-11489 Dropping dependency on io.netty from hadoop-nfs' pom.xml
    (Ted Yu via ozawa)

    HADOOP-11419 Improve hadoop-maven-plugins. (Herve Boutemy via stevel)

    HADOOP-11450. Cleanup DistCpV1 not to use deprecated methods and fix
    javadocs. (Varun Saxena via ozawa)

    HADOOP-4297. Enable Java assertions when running tests.
    (Tsz Wo Nicholas Sze via wheat9)

    HADOOP-10626. Limit Returning Attributes for LDAP search. (Jason Hubbard
    via atm)

    HADOOP-11317. Increment SLF4J version to 1.7.10. (Tim Robertson via ozawa)

    HADOOP-10525. Remove DRFA.MaxBackupIndex config from log4j.properties
    (aajisaka)

    HADOOP-10574. Bump the maven plugin versions too -moving the numbers into
    properties. (aajisaka)

    HADOOP-11441. Hadoop-azure: Change few methods scope to public.
    (Shashank Khandelwal via cnauroth)

    HADOOP-9137. Support connection limiting in IPC server (kihwal)

    HADOOP-11498. Bump the version of HTrace to 3.1.0-incubating (Masatake
    Iwasaki via Colin P. McCabe)

    HADOOP-11442. hadoop-azure: Create test jar.
    (Shashank Khandelwal via cnauroth)

    HADOOP-11544. Remove unused configuration keys for tracing. (Masatake
    Iwasaki via aajisaka)

    HADOOP-11492. Bump up curator version to 2.7.1. (Arun Suresh and
    Karthik Kambatla via kasha)

    HADOOP-11463 Replace method-local TransferManager object with
    S3AFileSystem#transfers. (Ted Yu via stevel)

    HADOOP-11520. Clean incomplete multi-part uploads in S3A tests.
    (Thomas Demoor via stevel)

    HADOOP-11579. Documentation for truncate. (shv)

    HADOOP-10140. Specification of HADOOP_CONF_DIR via the environment in
    hadoop_config.cmd. (Kiran Kumar M R via cnauroth)

    HADOOP-11543. Improve help message for hadoop/yarn command. (Brahma 
    Reddy Battula via ozawa).

    HADOOP-11586. Update use of Iterator to Iterable in
    AbstractMetricsContext.java. (Ray Chiang via aajisaka)

    HADOOP-9869. Configuration.getSocketAddr()/getEnum() should use
    getTrimmed(). (Tsuyoshi Ozawa via aajisaka)

    HADOOP-11589. NetUtils.createSocketAddr should trim the input URI.
    (Rakesh R via ozawa)

    HADOOP-11600. Fix up source codes to be compiled with Guava 17.0. (ozawa)

    HADOOP-11522. Update S3A Documentation. (Thomas Demoor via stevel)

    HADOOP-11521. Make connection timeout configurable in s3a.
    (Thomas Demoor via stevel)

    HADOOP-11440. Use "test.build.data" instead of "build.test.dir" for testing
    in ClientBaseWithFixes. (Kengo Seki via aajisaka)

    HADOOP-11607. Reduce log spew in S3AFileSystem. (Lei (Eddy) Xu via stevel)

    HADOOP-11495. Convert site documentation from apt to markdown
    (Masatake Iwasaki via aw)

    HADOOP-11632. Cleanup Find.java to remove SupressWarnings annotations.
    (Akira Ajisaka via ozawa)

    HADOOP-10976. moving the source code of hadoop-tools docs to the
    directory under hadoop-tools (Masatake Iwasaki via aw)

    HADOOP-11658. Externalize io.compression.codecs property.
    (Kai Zheng via aajisaka)

    HADOOP-11648. Set DomainSocketWatcher thread name explicitly.
    (Liang Xie via ozawa)

    HADOOP-11642. Upgrade azure sdk version from 0.6.0 to 2.0.0.
    (Shashank Khandelwal and Ivan Mitic via cnauroth)

    HADOOP-11714. Add more trace log4j messages to SpanReceiverHost (cmccabe)

    HADOOP-8059. Add javadoc to InterfaceAudience and InterfaceStability.
    (Brandon Li via suresh)

    HADOOP-9329. document native build dependencies in BUILDING.txt (Vijay Bhat
    via Colin P. McCabe)

    HADOOP-10670. Allow AuthenticationFilters to load secret from signature
    secret files. (Kai Zheng via wheat9)

    HADOOP-11801. Update BUILDING.txt for Ubuntu. (Gabor Liptak via
    Arpit Agarwal)

    HADOOP-9737. JarFinder#getJar should delete the jar file upon destruction
    of the JVM (jbonofre via rkanter)

  OPTIMIZATIONS

    HADOOP-11323. WritableComparator#compare keeps reference to byte array.
    (Wilfred Spiegelenburg via wang)

    HADOOP-11238. Update the NameNode's Group Cache in the background when
    possible (Chris Li via Colin P. McCabe)

    HADOOP-10809. hadoop-azure: page blob support. (Dexter Bradshaw,
    Mostafa Elhemali, Eric Hanson, and Mike Liddell via cnauroth)

    HADOOP-11188. hadoop-azure: automatically expand page blobs when they become
    full. (Eric Hanson via cnauroth)

    HADOOP-11506. Configuration variable expansion regex expensive for long
    values. (Gera Shegalov via gera)

    HADOOP-11620. Add support for load balancing across a group of KMS for HA.
    (Arun Suresh via wang)

    HADOOP-11183. Memory-based S3AOutputstream. (Thomas Demoor via stevel)

  BUG FIXES

    HADOOP-11512. Use getTrimmedStrings when reading serialization keys
    (Ryan P via harsh)

    HADOOP-11488. Difference in default connection timeout for S3A FS
    (Daisuke Kobayashi via harsh)

    HADOOP-11256. Some site docs have inconsistent appearance (Masatake 
    Iwasaki via aw)

    HADOOP-11318. Update the document for hadoop fs -stat (aajisaka)

    HADOOP 11400. GraphiteSink does not reconnect to Graphite after 'broken pipe' 
    (Kamil Gorlo via raviprak)

    HADOOP-11236. NFS: Fix javadoc warning in RpcProgram.java (Abhiraj Butala via harsh)

    HADOOP-11166. Remove ulimit from test-patch.sh. (wang)

    HDFS-7227. Fix findbugs warning about NP_DEREFERENCE_OF_READLINE_VALUE in
    SpanReceiverHost (cmccabe)

    HADOOP-11186. documentation should talk about
    hadoop.htrace.spanreceiver.classes, not hadoop.trace.spanreceiver.classes (cmccabe)

    HADOOP-11165. TestUTF8 fails when run against java 8.
    (Stephen Chu via cnauroth)

    HADOOP-10717. HttpServer2 should load jsp DTD from local jars instead of
    going remote. (Dapeng Sun via wheat9)

    HADOOP-11268. Update BUILDING.txt to remove the workaround for tools.jar.
    (Li Lu via wheat9)

    HADOOP-11230. Add missing dependency of bouncycastle for kms, httpfs, hdfs, MR
    and YARN. (Robert Kanter via wheat9)

    HADOOP-11269. Add java 8 profile for hadoop-annotations. (Li Lu via wheat9)

    HADOOP-11271. Use Time.monotonicNow() in Shell.java instead of Time.now()
    (vinayakumarb)

    HADOOP-11266. Remove no longer supported activation properties for packaging
    from pom. (Masatake Iwasaki via wheat9)

    HADOOP-11267. TestSecurityUtil fails when run with JDK8 because of empty
    principal names. (Stephen Chu via wheat9)

    HADOOP-10714. AmazonS3Client.deleteObjects() need to be limited to 1000
    entries per call. (Juan Yu via atm)

    HADOOP-11272. Allow ZKSignerSecretProvider and
    ZKDelegationTokenSecretManager to use the same curator client. (Arun Suresh via atm)

    HADOOP-11187 NameNode - KMS communication fails after a long period of
    inactivity. (Arun Suresh via atm)

    HADOOP-11289. Fix typo in RpcUtil log message. (Charles Lamb via wheat9)

    HADOOP-11294. Nfs3FileAttributes should not change the values of rdev,
    nlink and size in the constructor. (Brandon Li via wheat9)

    HADOOP-11157. ZKDelegationTokenSecretManager never shuts down
    listenerThreadPool. (Arun Suresh via atm)

    HADOOP-11311. Restrict uppercase key names from being created with JCEKS.
    (wang)

    HADOOP-11309. System class pattern package.Foo should match
    package.Foo$Bar, too (Gera Shegalov via jlowe)

    HADOOP-11312. Fix unit tests to not use uppercase key names. (wang)

    HADOOP-11201. Hadoop Archives should support globs resolving to files.
    (Gera Shegalov via cnauroth)

    HADOOP-11322. key based ACL check in KMS always check KeyOpType.MANAGEMENT
    even actual KeyOpType is not MANAGEMENT. (Dian Fu via yliu)

    HADOOP-11300. KMS startup scripts must not display the keystore /
    truststore passwords. (Arun Suresh via wang)

    HADOOP-11333. Fix deadlock in DomainSocketWatcher when the notification
    pipe is full (zhaoyunjiong via cmccabe)

    HADOOP-11337. KeyAuthorizationKeyProvider access checks need to be done
    atomically. (Dian Fu via wang)

    HADOOP-11344. KMS kms-config.sh sets a default value for the keystore
    password even in non-ssl setup. (Arun Suresh via wang)

    HADOOP-11342. KMS key ACL should ignore ALL operation for default key ACL
    and whitelist key ACL. (Dian Fu via wang)

    HADOOP-11332. KerberosAuthenticator#doSpnegoSequence should check if
    kerberos TGT is available in the subject. (Dian Fu via atm)

    HADOOP-11348. Remove unused variable from CMake error message for finding
    openssl (Dian Fu via Colin P. McCabe)

    HADOOP-11355. When accessing data in HDFS and the key has been deleted,
    a Null Pointer Exception is shown. (Arun Suresh via wang)

    HADOOP-11343. Overflow is not properly handled in caclulating final iv for
    AES CTR. (Jerry Chen via wang)

    HADOOP-11354. ThrottledInputStream doesn't perform effective throttling.
    (Ted Yu via jing9)

    HADOOP-11329. Add JAVA_LIBRARY_PATH to KMS startup options. (Arun Suresh via wang)

    HADOOP-11363 Hadoop maven surefire-plugin uses must set heap size. (stevel)

    HADOOP-10134 [JDK8] Fix Javadoc errors caused by incorrect or illegal tags in doc
    comments. (apurtell via stevel)

    HADOOP-11367. Fix warnings from findbugs 3.0 in hadoop-streaming. (Li Lu via wheat9)

    HADOOP-11369. Fix new findbugs warnings in hadoop-mapreduce-client,
    non-core directories. (Li Lu via wheat9)

    HADOOP-11368. Fix SSLFactory truststore reloader thread leak in
    KMSClientProvider. (Arun Suresh via wang)

    HADOOP-11372. Fix new findbugs warnings in mapreduce-examples.
    (Li Lu via wheat9)

    HADOOP-11273. TestMiniKdc failure: login options not compatible with IBM
    JDK. (Gao Zhong Liang via wheat9)

    HADOOP-11379. Fix new findbugs warnings in hadoop-auth*. (Li Lu via wheat9)

    HADOOP-11378. Fix new findbugs warnings in hadoop-kms. (Li Lu via wheat9)

    HADOOP-11349. RawLocalFileSystem leaks file descriptor while creating a
    file if creat succeeds but chmod fails. (Varun Saxena via Colin P. McCabe)

    HADOOP-11381. Fix findbugs warnings in hadoop-distcp, hadoop-aws,
    hadoop-azure, and hadoop-openstack. (Li Lu via wheat9)

    HADOOP-10482. Fix various findbugs warnings in hadoop-common. (wheat9)

    HADOOP-11388. Remove deprecated o.a.h.metrics.file.FileContext.
    (Li Lu via wheat9)

    HADOOP-11386. Replace \n by %n in format hadoop-common format strings.
    (Li Lu via wheat9)

    HADOOP-11211. mapreduce.job.classloader.system.classes semantics should be
    be order-independent. (Yitong Zhou via gera)

    HADOOP-11389. Clean up byte to string encoding issues in hadoop-common.
    (wheat9)

    HADOOP-11394. hadoop-aws documentation missing. (cnauroth)

    HADOOP-11396. Provide navigation in the site documentation linking to the
    Hadoop Compatible File Systems. (cnauroth)

    HADOOP-11412 POMs mention "The Apache Software License" rather than
    "Apache License". (Herve Boutemy via stevel)

    HADOOP-11321. copyToLocal cannot save a file to an SMB share unless the user
    has Full Control permissions. (cnauroth)

    HADOOP-11420. Use latest maven-site-plugin and replace link to svn with
    link to git. (Herve Boutemy via wheat9)

    HADOOP-10689. InputStream is not closed in
    AzureNativeFileSystemStore#retrieve(). (Chen He via cnauroth)

    HADOOP-10690. Lack of synchronization on access to InputStream in
    NativeAzureFileSystem#NativeAzureFsInputStream#close().
    (Chen He via cnauroth)

    HADOOP-11358. Tests for encryption/decryption with IV calculation
    overflow. (yliu)

    HADOOP-11125. Remove redundant tests in TestOsSecureRandom.
    (Masanori Oyama via wheat9)

    HADOOP-11385. Prevent cross site scripting attack on JMXJSONServlet.
    (wheat9)

    HADOOP-11409. FileContext.getFileContext can stack overflow if default fs
    misconfigured (Gera Shegalov via jlowe)

    HADOOP-11428. Remove obsolete reference to Cygwin in BUILDING.txt.
    (Arpit Agarwal via wheat9)

    HADOOP-11431. clean up redundant maven-site-plugin configuration.
    (Herve Boutemy via wheat9)

    HADOOP-11429. Findbugs warnings in hadoop extras.
    (Varun Saxena via wheat9)

    HADOOP-11414. FileBasedIPList#readLines() can leak file descriptors.
    (ozawa)

    HADOOP-11283. SequenceFile.Writer can leak file descriptors in
    DistCpV1#setup(). (Varun Saxena via ozawa)

    HADOOP-11448. Fix findbugs warnings in FileBasedIPList. (ozawa)

    HADOOP-11039. ByteBufferReadable API doc is inconsistent with the
    implementations. (Yi Liu via Colin P. McCabe)

    HADOOP-11446. S3AOutputStream should use shared thread pool to
    avoid OutOfMemoryError. (Ted Yu via stevel)	

    HADOOP-11459. Fix recent findbugs in ActiveStandbyElector, NetUtils
    and ShellBasedIdMapping (vinayakumarb)

    HADOOP-11445. Bzip2Codec: Data block is skipped when position of newly
    created stream is equal to start of split (Ankit Kamboj via jlowe)

    HADOOP-11462. TestSocketIOWithTimeout needs change for PowerPC platform.
    (Ayappan via cnauroth)

    HADOOP-11350. The size of header buffer of HttpServer is too small when
    HTTPS is enabled. (Benoy Antony via wheat9)

    HADOOP-10542 Potential null pointer dereference in Jets3tFileSystemStore
    retrieveBlock(). (Ted Yu via stevel)	

    HADOOP-10668. TestZKFailoverControllerStress#testExpireBackAndForth
    occasionally fails. (Ming Ma via cnauroth)

    HADOOP-11327. BloomFilter#not() omits the last bit, resulting in an
    incorrect filter (Eric Payne via jlowe)

    HADOOP-11209. Configuration#updatingResource/finalParameters are not
    thread-safe. (Varun Saxena via ozawa)

    HADOOP-11500. InputStream is left unclosed in ApplicationClassLoader.
    (Ted Yu via ozawa)

    HADOOP-11008. Remove duplicated description about proxy-user in site 
    documents (Masatake Iwasaki via aw)

    HADOOP-11493. Fix some typos in kms-acls.xml description.
    (Charles Lamb via aajisaka)

    HADOOP-11507 Hadoop RPC Authentication problem with different user locale.
    (Talat UYARER via stevel)

    HADOOP-11482. Use correct UGI when KMSClientProvider is called by a proxy
    user. Contributed by Arun Suresh.

    HADOOP-11499. Check of executorThreadsStarted in
    ValueQueue#submitRefillTask() evades lock acquisition (Ted Yu via jlowe)

    HADOOP-6221 RPC Client operations cannot be interrupted. (stevel)

    HADOOP-11509. Change parsing sequence in GenericOptionsParser to parse -D
    parameters before -files. (xgong)

    HADOOP-11469. KMS should skip default.key.acl and whitelist.key.acl when
    loading key acl. (Dian Fu via yliu)

    HADOOP-11316. "mvn package -Pdist,docs -DskipTests -Dtar" fails because
    of non-ascii characters. (ozawa)

    HADOOP-9907. Webapp http://hostname:port/metrics link is not working.
    (aajisaka)

    HADOOP-11403. Avoid using sys_errlist on Solaris, which lacks support for it
    (Malcolm Kavalsky via Colin P. McCabe)

    HADOOP-11523. StorageException complaining " no lease ID" when updating
    FolderLastModifiedTime in WASB. (Duo Xu via cnauroth)

    HADOOP-11432. Fix SymlinkBaseTest#testCreateLinkUsingPartQualPath2.
    (Liang Xie via gera)

    HADOOP-10181. GangliaContext does not work with multicast ganglia setup.
    (Andrew Johnson via cnauroth)

    HADOOP-11529. Fix findbugs warnings in hadoop-archives.
    (Masatake Iwasaki via wheat9)

    HADOOP-11546. Checkstyle failing: Unable to instantiate 
    DoubleCheckedLockingCheck. (ozawa)

    HADOOP-11548. checknative should display a nicer error message when openssl
    support is not compiled in. (Anu Engineer via cnauroth)

    HADOOP-11547. hadoop-common native compilation fails on Windows due to
    missing support for __attribute__ declaration. (cnauroth)

    HADOOP-11549. flaky test detection tool failed to handle special control
    characters in test result. (Yongjun Zhang via aajisaka)

    HADOOP-10062. race condition in MetricsSystemImpl#publishMetricsNow that 
    causes incorrect results. (Sangjin Lee via junping_du)

    HADOOP-11526. Memory leak in Bzip2Compressor and Bzip2Decompressor.
    (Anu Engineer via cnauroth)

    HADOOP-11535 TableMapping related tests failed due to 'successful'
    resolving of invalid test hostname. (Kai Zheng via stevel)

    HADOOP-10953. NetworkTopology#add calls NetworkTopology#toString without
    holding the netlock (Liang Xie via Colin P. McCabe)

    HADOOP-11587. TestMapFile#testMainMethodMapFile creates test files in
    hadoop-common project root. (Xiaoyu Yao via wheat9)

    HADOOP-11467. KerberosAuthenticator can connect to a non-secure cluster.
    (yzhangal via rkanter)

    HADOOP-11000. HAServiceProtocol's health state is incorrectly transitioned
    to SERVICE_NOT_RESPONDING (Ming Ma via vinayakumarb)

    HADOOP-11570. S3AInputStream.close() downloads the remaining bytes of
    the object from S3. (Dan Hecht via stevel).

    HADOOP-11295. RPC Server Reader thread can't shutdown if RPCCallQueue is
    full. (Ming Ma via kihwal)

    HADOOP-11599. Client#getTimeout should use IPC_CLIENT_PING_DEFAULT when 
    IPC_CLIENT_PING_KEY is not configured. (zhihai xu via ozawa)

    HADOOP-11545. ArrayIndexOutOfBoundsException is thrown with "hadoop
    credential list -provider". (Brahma Reddy Battula via aajisaka)

    HADOOP-11595. Add default implementation for AbstractFileSystem#truncate.
    (yliu)

    HADOOP-9087. Queue size metric for metric sinks isn't actually maintained
    (Akira AJISAKA via jlowe)

    HADOOP-11604. Prevent ConcurrentModificationException while closing domain
    sockets during shutdown of DomainSocketWatcher thread. (cnauroth)

    HADOOP-11612. Workaround for Curator's ChildReaper requiring Guava 15+.
    (rkanter)

    HADOOP-11584 s3a file block size set to 0 in getFileStatus.
    (Brahma Reddy Battula via stevel)

    HADOOP-10478. Fix new findbugs warnings in hadoop-maven-plugins.
    (Li Lu via wheat9)

    HADOOP-8642. Document that io.native.lib.available only controls native bz2
    and zlib compression codecs. (aajisaka)

    HADOOP-11619. FTPFileSystem should override getDefaultPort.
    (Brahma Reddy Battula via gera)

    HADOOP-11480. Typo in hadoop-aws/index.md uses wrong scheme for
    test.fs.s3.name. (Ted Yu via aajisaka)

    HADOOP-11629. WASB filesystem should not start BandwidthGaugeUpdater if
    fs.azure.skip.metrics set to true. (Shanyu Zhao via cnauroth)

    HADOOP-9922. hadoop windows native build will fail in 32 bit machine.
    (Kiran Kumar M R via cnauroth)

    HADOOP-11634. Description of webhdfs' principal/keytab should switch places
    each other. (Brahma Reddy Battula via ozawa)

    HADOOP-11615. Update ServiceLevelAuth.md for YARN.
    (Brahma Reddy Battula via aajisaka)

    HADOOP-11605. FilterFileSystem#create with ChecksumOpt should propagate it
    to wrapped FS. (gera)

    HADOOP-11674. oneByteBuf in CryptoInputStream and CryptoOutputStream
    should be non static. (Sean Busbey via yliu)

    HADOOP-11670. Regression: s3a auth setup broken. (Adam Budde via stevel)

    HADOOP-11602. Fix toUpperCase/toLowerCase to use Locale.ENGLISH. (ozawa)

    HADOOP-11686. MiniKDC cannot change ORG_NAME or ORG_DOMAIN.
    (Duo Zhang via wheat9)

    HADOOP-11618. DelegateToFileSystem erroneously uses default FS's port in
    constructor. (Brahma Reddy Battula via gera)

    HADOOP-11693. Azure Storage FileSystem rename operations are throttled too
    aggressively to complete HBase WAL archiving. (Duo Xu via cnauroth)

    HADOOP-11710. Make CryptoOutputStream behave like DFSOutputStream wrt
    synchronization. (Sean Busbey via yliu)

    HADOOP-11558. Fix dead links to doc of hadoop-tools. (Jean-Pierre 
    Matsumoto via ozawa)

    HADOOP-11638. OpensslSecureRandom.c pthreads_thread_id should support FreeBSD
    and Solaris in addition to Linux. (Kiran Kumar M R via cnauroth)

    HADOOP-11720. [JDK8] Fix javadoc errors caused by incorrect or illegal
    tags in hadoop-tools. (Akira AJISAKA via ozawa)

    HADOOP-11722. Some Instances of Services using
    ZKDelegationTokenSecretManager go down when old token cannot be deleted.
    (Arun Suresh via atm)

    HADOOP-10703. HttpServer2 creates multiple authentication filters.
    (Benoy Antony via wheat9)

    HADOOP-11729. Fix link to cgroups doc in site.xml. (Masatake Iwasaki via
    ozawa)

    HADOOP-11609. Correct credential commands info in
    CommandsManual.html#credential. (Varun Saxena via ozawa)

    HADOOP-11014. Potential resource leak in JavaKeyStoreProvider due to
    unclosed stream. (ozawa)

    HADOOP-11738. Fix a link of Protocol Buffers 2.5 for download in BUILDING.txt.
    (ozawa)

    HADOOP-11748. The secrets of auth cookies should not be specified in
    configuration in clear text. (Li Lu and Haohui Mai via wheat9)

    HADOOP-11691. X86 build of libwinutils is broken.
    (Kiran Kumar M R via cnauroth)

    HADOOP-11639. Clean up Windows native code compilation warnings related to
    Windows Secure Container Executor. (Remus Rusanu via cnauroth)

    HADOOP-11761. Fix findbugs warnings in org.apache.hadoop.security
    .authentication. (Li Lu via wheat9)

    HADOOP-11754. RM fails to start in non-secure mode due to authentication
    filter failure. (wheat9)

    HADOOP-11787. OpensslSecureRandom.c pthread_threadid_np usage signature is
    wrong on 32-bit Mac. (Kiran Kumar M R via cnauroth)
    
    HADOOP-11757. NFS gateway should shutdown when it can't start UDP or TCP
    server (brandonli)

    HADOOP-11377. Added Null.java without which jdiff completely flops. (Tsuyoshi
    Ozawa via vinodkv)

    HADOOP-11776. Fixed the broken JDiff support in Hadoop 2. (Li Lu via vinodkv)

    HADOOP-11796. Skip TestShellBasedIdMapping.testStaticMapUpdate on Windows.
    (Xiaoyu Yao via cnauroth)

    HADOOP-11815. HttpServer2 should destroy SignerSecretProvider when it
    stops. (Rohith via wheat9)

    HADOOP-11837. AuthenticationFilter should destroy SignerSecretProvider in
    Tomcat deployments. (Bowen Zhang via wheat9)

Release 2.6.1 - UNRELEASED

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-11466. FastByteComparisons: do not use UNSAFE_COMPARER on the SPARC
    architecture because it is slower there (Suman Somasundar via Colin P.
    McCabe)

Release 2.6.0 - 2014-11-18

  INCOMPATIBLE CHANGES

  NEW FEATURES

    HADOOP-10433. Key Management Server based on KeyProvider API. (tucu)

    HADOOP-10893. isolated classloader on the client side (Sangjin Lee via
    jlowe)

    HADOOP-10400. Incorporate new S3A FileSystem implementation. (Jordan
    Mendelson and Dave Wang via atm)

  IMPROVEMENTS

    HADOOP-10808. Remove unused native code for munlock. (cnauroth)

    HADOOP-10815. Implement Windows equivalent of mlock. (cnauroth)

    HADOOP-7664. Remove warmings when overriding final parameter configuration
    if the override value is same as the final parameter value.
    (Ravi Prakash via suresh)

    HADOOP-10673. Update rpc metrics when the call throws an exception. (Ming Ma
    via jing9)

    HADOOP-10845. Add common tests for ACLs in combination with viewfs.
    (Stephen Chu via cnauroth)

    HADOOP-10839. Add unregisterSource() to MetricsSystem API.
    (Shanyu Zhao via cnauroth)

    HADOOP-10607. Create an API to separate credentials/password storage
    from applications (Larry McCay via omalley)

    HADOOP-10732. Fix locking in credential update. (Ted Yu via omalley)

    HADOOP-10733. Fix potential null dereference in CredShell. (Ted Yu via
    omalley)

    HADOOP-10610. Upgrade S3n s3.fs.buffer.dir to support multi directories.
    (Ted Malaska via atm)

    HADOOP-10817. ProxyUsers configuration should support configurable 
    prefixes. (tucu)

    HADOOP-10755. Support negative caching of user-group mapping.
    (Lei Xu via wang)

    HADOOP-10855. Allow Text to be read with a known Length. (todd)

    HADOOP-10887. Add XAttrs to ViewFs and make XAttrs + ViewFileSystem
    internal dir behavior consistent. (Stephen Chu via wang)

    HADOOP-10882. Move DirectBufferPool into common util. (todd)

    HADOOP-8069. Enable TCP_NODELAY by default for IPC. (Todd Lipcon via
    Arpit Agarwal)

    HADOOP-10902. Deletion of directories with snapshots will not output
    reason for trash move failure. (Stephen Chu via wang)

    HADOOP-10900. CredentialShell args should use single-dash style. (wang)

    HADOOP-10903. Enhance hadoop classpath command to expand wildcards or write
    classpath into jar manifest. (cnauroth)

    HADOOP-10791. AuthenticationFilter should support externalizing the 
    secret for signing and provide rotation support. (rkanter via tucu)

    HADOOP-10771. Refactor HTTP delegation support out of httpfs to common. 
    (tucu)

    HADOOP-10835. Implement HTTP proxyuser support in HTTP authentication 
    client/server libraries. (tucu)

    HADOOP-10820. Throw an exception in GenericOptionsParser when passed
    an empty Path. (Alex Holmes and Zhihai Xu via wang)

    HADOOP-10281. Create a scheduler, which assigns schedulables a priority
    level. (Chris Li via Arpit Agarwal)

    HADOOP-8944. Shell command fs -count should include human readable option 
    (Jonathan Allen via aw)

    HADOOP-10231. Add some components in Native Libraries document (Akira 
    AJISAKA via aw)

    HADOOP-10650. Add ability to specify a reverse ACL (black list) of users
    and groups. (Benoy Antony via Arpit Agarwal)

    HADOOP-10335. An ip whilelist based implementation to resolve Sasl
    properties per connection. (Benoy Antony via Arpit Agarwal)

    HADOOP-10975. org.apache.hadoop.util.DataChecksum should support calculating
    checksums in native code (James Thomas via Colin Patrick McCabe)

    HADOOP-10201. Add listing to KeyProvider API. (Larry McCay via omalley)

    HADOOP-10177. Create CLI tools for managing keys. (Larry McCay via omalley)

    HADOOP-10432. Refactor SSLFactory to expose static method to determine
    HostnameVerifier. (tucu)

    HADOOP-10429. KeyStores should have methods to generate the materials
    themselves, KeyShell should use them. (tucu)

    HADOOP-10427. KeyProvider implementations should be thread safe. (tucu)

    HADOOP-10428. JavaKeyStoreProvider should accept keystore password via
    configuration falling back to ENV VAR. (tucu)

    HADOOP-10430. KeyProvider Metadata should have an optional description,
    there should be a method to retrieve the metadata from all keys. (tucu)

    HADOOP-10431. Change visibility of KeyStore.Options getter methods to
    public. (tucu)

    HADOOP-10534. KeyProvider getKeysMetadata should take a list of names
    rather than returning all keys. (omalley)

    HADOOP-10719. Add generateEncryptedKey and decryptEncryptedKey
    methods to KeyProvider. (asuresh via tucu)

    HADOOP-10817. ProxyUsers configuration should support configurable
    prefixes. (tucu)

    HADOOP-10881. Clarify usage of encryption and encrypted encryption
    key in KeyProviderCryptoExtension. (wang)

    HADOOP-10770. KMS add delegation token support. (tucu)

    HADOOP-10698. KMS, add proxyuser support. (tucu)

    HADOOP-8896. Javadoc points to Wrong Reader and Writer classes 
    in SequenceFile (Ray Chiang via aw)

    HADOOP-10998. Fix bash tab completion code to work (Jim Hester via aw)

    HADOOP-10880. Move HTTP delegation tokens out of URL querystring to 
    a header. (tucu)

    HADOOP-11005. Fix HTTP content type for ReconfigurationServlet.
    (Lei Xu via wang)

    HADOOP-10814. Update Tomcat version used by HttpFS and KMS to latest
    6.x version. (rkanter via tucu)

    HADOOP-10994. KeyProviderCryptoExtension should use CryptoCodec for 
    generation/decryption of keys. (tucu)

    HADOOP-11021. Configurable replication factor in the hadoop archive
    command. (Zhe Zhang via wang)

    HADOOP-11030. Define a variable jackson.version instead of using constant 
    at multiple places. (Juan Yu via kasha)

    HADOOP-10990. Add missed NFSv3 request and response classes (brandonli)

    HADOOP-10863. KMS should have a blacklist for decrypting EEKs. 
    (asuresh via tucu)

    HADOOP-11054. Add a KeyProvider instantiation based on a URI. (tucu)

    HADOOP-11015. Http server/client utils to propagate and recreate 
    Exceptions from server to client. (tucu)

    HADOOP-11060. Create a CryptoCodec test that verifies interoperability 
    between the JCE and OpenSSL implementations. (hitliuyi via tucu)

    HADOOP-11070. Create MiniKMS for testing. (tucu)

    HADOOP-11057. checknative command to probe for winutils.exe on windows.
    (Xiaoyu Yao via cnauroth)

    HADOOP-10758. KMS: add ACLs on per key basis. (tucu)

    HADOOP-9540. Expose the InMemoryS3 and S3N FilesystemStores implementations
    for Unit testing. (Hari via stevel)

    HADOOP-10373 create tools/hadoop-amazon for aws/EMR support (stevel)

    HADOOP-11074. Move s3-related FS connector code to hadoop-aws (David S.
    Wang via Colin Patrick McCabe)

    HADOOP-11091. Eliminate old configuration parameter names from s3a (David
    S. Wang via Colin Patrick McCabe)

    HADOOP-10868. AuthenticationFilter should support externalizing the 
    secret for signing and provide rotation support. (rkanter via tucu)

    HADOOP-10922. User documentation for CredentialShell. (Larry McCay via wang)

    HADOOP-11016. KMS should support signing cookies with zookeeper secret
    manager. (tucu)

    HADOOP-11106. Document considerations of HAR and Encryption. (clamb via wang)

    HADOOP-10970. Cleanup KMS configuration keys. (wang)

    HADOOP-11017. KMS delegation token secret manager should be able to use 
    zookeeper as store. (asuresh via tucu)

    HADOOP-11009. Add Timestamp Preservation to DistCp (Gary Steelman via aw)

    HADOOP-11101. How about inputstream close statement from catch block to
    finally block in FileContext#copy() ( skrho via vinayakumarb )

    HADOOP-8808. Update FsShell documentation to mention deprecation of some of
    the commands, and mention alternatives (Akira AJISAKA via aw)

    HADOOP-10954. Adding site documents of hadoop-tools (Masatake Iwasaki 
    via aw)

    HADOOP-10731. Remove @date JavaDoc comment in ProgramDriver class (Henry 
    Saputra via aw)

    HADOOP-11153. Make number of KMS threads configurable. (wang)

    HADOOP-11007. Reinstate building of ant tasks support. (jlowe via kihwal)

    HADOOP-11178. Fix findbugs exclude file. (Arun Suresh via wang)

    HADOOP-11174. Delegation token for KMS should only be got once if it
    already exists. (Yi Liu via wang)

    HADOOP-11184. Update Hadoop's lz4 to version r123. (cmccabe)

    HADOOP-11181. Generalized o.a.h.s.t.d.DelegationTokenManager to handle all
    sub-classes of AbstractDelegationTokenIdentifier. (zjshen)

    HADOOP-11207. Enhanced common DelegationTokenAuthenticationHandler to support
    proxy-users on Delegation-token management operations. (Zhijie Shen via
    vinodkv)

    HADOOP-11216. Improve Openssl library finding. (cmccabe via yliu)

    HADOOP-11254. Changed visibility of AccessControlList to be public for
    consumption by ecosystem. (Zhijie Shen via vinodkv)

    HADOOP-11286. Copied LimitInputStream from guava-0.14 to hadoop to avoid
    issues with newer versions of guava in applications. (Christopher Tubbs
    via acmurthy)

  OPTIMIZATIONS

    HADOOP-10838. Byte array native checksumming. (James Thomas via todd)

    HADOOP-10696. Add optional attributes to KeyProvider Options and Metadata.
    (tucu)

    HADOOP-10695. KMSClientProvider should respect a configurable timeout.
    (yoderme via tucu)

    HADOOP-10757. KeyProvider KeyVersion should provide the key name.
    (asuresh via tucu)

    HADOOP-10769. Create KeyProvider extension to handle delegation tokens.
    (Arun Suresh via atm)

    HADOOP-10812. Delegate KeyProviderExtension#toString to underlying
    KeyProvider. (wang)

    HADOOP-10736. Add key attributes to the key shell. (Mike Yoder via wang)

    HADOOP-10824. Refactor KMSACLs to avoid locking. (Benoy Antony via umamahesh)

    HADOOP-10841. EncryptedKeyVersion should have a key name property.
    (asuresh via tucu)

    HADOOP-10842. CryptoExtension generateEncryptedKey method should
    receive the key name. (asuresh via tucu)

    HADOOP-10750. KMSKeyProviderCache should be in hadoop-common.
    (asuresh via tucu)

    HADOOP-10720. KMS: Implement generateEncryptedKey and decryptEncryptedKey
    in the REST API. (asuresh via tucu)

    HADOOP-10891. Add EncryptedKeyVersion factory method to
    KeyProviderCryptoExtension. (wang)

    HADOOP-10756. KMS audit log should consolidate successful similar requests.
    (asuresh via tucu)

    HADOOP-10793. KeyShell args should use single-dash style. (wang)

    HADOOP-10936. Change default KeyProvider bitlength to 128. (wang)

    HADOOP-10224. JavaKeyStoreProvider has to protect against corrupting
    underlying store. (asuresh via tucu)

    HADOOP-10282. Create a FairCallQueue: a multi-level call queue which
    schedules incoming calls and multiplexes outgoing calls. (Chris Li via
    Arpit Agarwal)

    HADOOP-10833. Remove unused cache in UserProvider. (Benoy Antony)

    HADOOP-11112. TestKMSWithZK does not use KEY_PROVIDER_URI. (tucu via wang)

    HADOOP-11111 MiniKDC to use locale EN_US for case conversions. (stevel)

    HADOOP-10681. Remove unnecessary synchronization from Snappy & Zlib
    codecs. (Gopal Vijayaraghavan via acmurthy)

    HADOOP-11194. Ignore .keep files. (kasha)

    HADOOP-11195. Move Id-Name mapping in NFS to the hadoop-common area for
    better maintenance (Yongjun Zhang via brandonli)

    HADOOP-11247. Fix a couple javac warnings in NFS. (Brandon Li via wheat9)

  BUG FIXES

    HADOOP-11182. GraphiteSink emits wrong timestamps (Sascha Coenen via raviprak)

    HADOOP-10781. Unportable getgrouplist() usage breaks FreeBSD (Dmitry
    Sivachenko via Colin Patrick McCabe)

    HADOOP-10507. FsShell setfacl can throw ArrayIndexOutOfBoundsException when
    no perm is specified. (Stephen Chu and Sathish Gurram via cnauroth)

    HADOOP-10780. hadoop_user_info_alloc fails on FreeBSD due to incorrect
    sysconf use (Dmitry Sivachenko via Colin Patrick McCabe)

    HADOOP-10810. Clean up native code compilation warnings. (cnauroth)

    HADOOP-9921. daemon scripts should remove pid file on stop call after stop
    or process is found not running ( vinayakumarb )

    HADOOP-10591.  Compression codecs must used pooled direct buffers or
    deallocate direct buffers when stream is closed (cmccabe)

    HADOOP-10857.  Native Libraries Guide doen't mention a dependency on
    openssl-development package (ozawa via cmccabe)

    HADOOP-10866. RawLocalFileSystem fails to read symlink targets via the stat
    command when the format of the stat command uses non-curly quotes (yzhang
    via cmccabe)

    HADOOP-10830. Missing lock in JavaKeyStoreProvider.createCredentialEntry.
    (Benoy Antony via umamahesh)

    HADOOP-10928. Incorrect usage on `hadoop credential list`.
    (Josh Elser via wang)

    HADOOP-10927. Fix CredentialShell help behavior and error codes.
    (Josh Elser via wang)

    HADOOP-10933. FileBasedKeyStoresFactory Should use Configuration.getPassword 
    for SSL Passwords. (lmccay via tucu)

    HADOOP-10759. Remove hardcoded JAVA_HEAP_MAX. (Sam Liu via Eric Yang)

    HADOOP-10905. LdapGroupsMapping Should use configuration.getPassword for SSL
    and LDAP Passwords. (lmccay via brandonli)

    HADOOP-10931 compile error on tools/hadoop-openstack (xukun via stevel)

    HADOOP-10929. Typo in Configuration.getPasswordFromCredentialProviders
    (lmccay via brandonli)

    HADOOP-10402. Configuration.getValByRegex does not substitute for
    variables. (Robert Kanter via kasha)

    HADOOP-10851. NetgroupCache does not remove group memberships. (Benoy
    Antony via Arpit Agarwal)

    HADOOP-10962. Flags for posix_fadvise are not valid in some architectures
    (David Villegas via Colin Patrick McCabe)

    HADOOP-10966. Hadoop Common native compilation broken in windows.
    (David Villegas via Arpit Agarwal)

    HADOOP-10843. TestGridmixRecord unit tests failure on PowerPC (Jinghui Wang
    via Colin Patrick McCabe)

    HADOOP-10121. Fix javadoc spelling for HadoopArchives#writeTopLevelDirs
    (Akira AJISAKA via aw)

    HADOOP-10964. Small fix for NetworkTopologyWithNodeGroup#sortByDistance.
    (Yi Liu via wang)

    HADOOP-10059. RPC authentication and authorization metrics overflow to
    negative values on busy clusters (Tsuyoshi OZAWA and Akira AJISAKA
    via jlowe)

    HADOOP-10973. Native Libraries Guide contains format error. (Peter Klavins
    via Arpit Agarwal)

    HADOOP-10972. Native Libraries Guide contains mis-spelt build line (Peter
    Klavins via aw)

    HADOOP-10873. Fix dead link in Configuration javadoc (Akira AJISAKA 
    via aw)

    HADOOP-10968. hadoop native build fails to detect java_libarch on
    ppc64le (Dinar Valeev via Colin Patrick McCabe)

    HADOOP-10141. Create KeyProvider API to separate encryption key storage
    from the applications. (omalley)

    HADOOP-10237. JavaKeyStoreProvider needs to set keystore permissions
    correctly. (Larry McCay via omalley)

    HADOOP-10244. TestKeyShell improperly tests the results of delete (Larry
    McCay via omalley)

    HADOOP-10583. bin/hadoop key throws NPE with no args and assorted other fixups. (clamb via tucu)

    HADOOP-10586. KeyShell doesn't allow setting Options via CLI. (clamb via tucu)

    HADOOP-10645. TestKMS fails because race condition writing acl files. (tucu)

    HADOOP-10611. KMS, keyVersion name should not be assumed to be
    keyName@versionNumber. (tucu)

    HADOOP-10816. KeyShell returns -1 on error to the shell, should be 1.
    (Mike Yoder via wang)

    HADOOP-10826. Iteration on KeyProviderFactory.serviceLoader is
    thread-unsafe. (benoyantony viat tucu)

    HADOOP-10920. site plugin couldn't parse hadoop-kms index.apt.vm.
    (Akira Ajisaka via wang)

    HADOOP-10937. Need to set version name correctly before decrypting EEK.
    (Arun Suresh via wang)

    HADOOP-10918. JMXJsonServlet fails when used within Tomcat. (tucu)

    HADOOP-10939. Fix TestKeyProviderFactory testcases to use default 128 bit
    length keys. (Arun Suresh via wang)

    HADOOP-10862. Miscellaneous trivial corrections to KMS classes.
    (asuresh via tucu)

    HADOOP-10967. Improve DefaultCryptoExtension#generateEncryptedKey
    performance. (hitliuyi via tucu)

    HADOOP-10488. TestKeyProviderFactory fails randomly. (tucu)

    HADOOP-10989. Work around buggy getgrouplist() implementations on Linux that
    return 0 on failure. (cnauroth)

    HADOOP-8815. RandomDatum needs to override hashCode().
    (Brandon Li via suresh)

    HADOOP-11056. OsSecureRandom.setConf() might leak file descriptors (yzhang
    via cmccabe)

    HADOOP-11040. Return value of read(ByteBuffer buf) in CryptoInputStream is
    incorrect in some cases. (Yi Liu via wang)

    HADOOP-11140. hadoop-aws only need test-scoped dependency on
    hadoop-common's tests jar. (Juan Yu via wang)

    HADOOP-1110. JavaKeystoreProvider should not report a key as created if it
    was not flushed to the backing file.

    HADOOP-11130. NFS updateMaps OS check is reversed (brandonli)

    HADOOP-11113. Namenode not able to reconnect to KMS after KMS restart.
    (Arun Suresh via wang)

    HADOOP-11160. Fix typo in nfs3 server duplicate entry reporting.
    (Charles Lamb via wheat9)

    HADOOP-11151. Automatically refresh auth token and retry on auth failure.
    (Arun Suresh via wang)

    HADOOP-11168. Remove duplicated entry "dfs.webhdfs.enabled" in the useri
    doc. (Yi Liu via wheat9)

    HADOOP-11169. Fix DelegationTokenAuthenticatedURL to pass the connection
    Configurator to the authenticator. (Arun Suresh via wang)

    HADOOP-10404. Some accesses to DomainSocketWatcher#closed are not protected
    by the lock (cmccabe)

    HADOOP-11161. Expose close method in KeyProvider to give clients of
    Provider implementations a hook to release resources. (Arun Suresh via atm)

    HADOOP-11133. Should trim the content of keystore password file for JavaKeyStoreProvider
    (Yi Liu via umamahesh)

    HADOOP-11193. Fix uninitialized variables in NativeIO.c
    (Xiaoyu Yao via wheat9)

    HADOOP-11176. KMSClientProvider authentication fails when both currentUgi
    and loginUgi are a proxied user. (Arun Suresh via atm)

    HADOOP-11198. Fix typo in javadoc for FileSystem#listStatus().
    (Li Lu via wheat9)

    HADOOP-11253. Hadoop streaming test TestStreamXmlMultipleRecords fails on
    Windows. (Varun Vasudev via wheat9)

    BREAKDOWN OF HDFS-6134 AND HADOOP-10150 SUBTASKS AND RELATED JIRAS
  
      HADOOP-10734. Implement high-performance secure random number sources.
      (Yi Liu via Colin Patrick McCabe)
  
      HADOOP-10603. Crypto input and output streams implementing Hadoop stream
      interfaces. (Yi Liu and Charles Lamb)
  
      HADOOP-10628. Javadoc and few code style improvement for Crypto
      input and output streams. (Yi Liu via clamb)
  
      HADOOP-10632. Minor improvements to Crypto input and output streams. 
      (Yi Liu)
  
      HADOOP-10635. Add a method to CryptoCodec to generate SRNs for IV. (Yi Liu)
  
      HADOOP-10653. Add a new constructor for CryptoInputStream that 
      receives current position of wrapped stream. (Yi Liu)
  
      HADOOP-10662. NullPointerException in CryptoInputStream while wrapped
      stream is not ByteBufferReadable. Add tests using normal stream. (Yi Liu)
  
      HADOOP-10713. Refactor CryptoCodec#generateSecureRandom to take a byte[]. 
      (wang via yliu)
  
      HADOOP-10693. Implementation of AES-CTR CryptoCodec using JNI to OpenSSL. 
      (Yi Liu via cmccabe)
  
      HADOOP-10803. Update OpensslCipher#getInstance to accept CipherSuite#name
      format. (Yi Liu)
  
      HADOOP-10735. Fall back AesCtrCryptoCodec implementation from OpenSSL to
      JCE if non native support. (Yi Liu)
  
      HADOOP-10870. Failed to load OpenSSL cipher error logs on systems with old
      openssl versions (cmccabe)
  
      HADOOP-10853. Refactor get instance of CryptoCodec and support create via
      algorithm/mode/padding. (Yi Liu)
  
      HADOOP-10919. Copy command should preserve raw.* namespace
      extended attributes. (clamb)
  
      HDFS-6873. Constants in CommandWithDestination should be static. (clamb)
  
      HADOOP-10871. incorrect prototype in OpensslSecureRandom.c (cmccabe)
  
      HADOOP-10886. CryptoCodec#getCodecclasses throws NPE when configurations not 
      loaded. (umamahesh)      
    --

    HADOOP-10911. hadoop.auth cookie after HADOOP-10710 still not proper
    according to RFC2109. (gchanan via tucu)

    HADOOP-11036. Add build directory to .gitignore (Tsuyoshi OZAWA via aw)

    HADOOP-11012. hadoop fs -text of zero-length file causes EOFException
    (Eric Payne via jlowe)

    HADOOP-11063. KMS cannot deploy on Windows, because class names are too long.
    (cnauroth)

    HADOOP-11067. warning message 'ssl.client.truststore.location has not
    been set' gets printed for hftp command. (Xiaoyu Yao via Arpit Agarwal)

    HADOOP-11069. KMSClientProvider should use getAuthenticationMethod() to
    determine if in proxyuser mode or not. (tucu)

    HADOOP-11073. Credential Provider related Unit Tests Failure on Windows.
    (Xiaoyu Yao via cnauroth)

    HADOOP-11071. KMSClientProvider should drain the local generated EEK cache
    on key rollover. (tucu)

    HADOOP-10925. Compilation fails in native link0 function on Windows.
    (cnauroth)

    HADOOP-11077. NPE if hosts not specified in ProxyUsers. (gchanan via tucu)

    HADOOP-9989. Bug introduced in HADOOP-9374, which parses the -tokenCacheFile 
    as binary file but set it to the configuration as JSON file. (zxu via tucu)

    HADOOP-11085. Excessive logging by org.apache.hadoop.util.Progress when
    value is NaN (Mit Desai via jlowe)

    HADOOP-11083. After refactoring of HTTP proxyuser to common, doAs param is 
    case sensitive. (tucu)

    HADOOP-11088. Unittest TestKeyShell, TestCredShell and TestKMS assume UNIX
    path separator for JECKS key store path. (Xiaoyu Yao via cnauroth)

    HADOOP-11096. KMS: KeyAuthorizationKeyProvider should verify the keyversion
    belongs to the keyname on decrypt. (tucu)

    HADOOP-11097. kms docs say proxyusers, not proxyuser for config params.
    (clamb via tucu)

    HADOOP-11062. CryptoCodec testcases requiring OpenSSL should be run 
    only if -Pnative is used. (asuresh via tucu)

    HADOOP-11099. KMS return HTTP UNAUTHORIZED 401 on ACL failure. (tucu)

    HADOOP-11105. MetricsSystemImpl could leak memory in registered callbacks.
    (Chuan Liu via cnauroth)

    HADOOP-10982. KMS: Support for multiple Kerberos principals. (tucu)

    HADOOP-11109. Site build is broken. (Jian He via atm)

    HADOOP-10946. Fix a bunch of typos in log messages (Ray Chiang via aw)

    HADOOP-10131. NetWorkTopology#countNumOfAvailableNodes() is returning
    wrong value if excluded nodes passed are not part of the cluster tree
    (vinayakumarb)

    HADOOP-11064. UnsatisifedLinkError with hadoop 2.4 JARs on hadoop-2.6 due to
    NativeCRC32 method changes. (cnauroth)

    HADOOP-11048. user/custom LogManager fails to load if the client
    classloader is enabled (Sangjin Lee via jlowe)

    HADOOP-10552. Fix usage and example at FileSystemShell.apt.vm (Kenji 
    Kikushima via aw)

    HADOOP-11143 NetUtils.wrapException loses inner stack trace on BindException
    (stevel)

    HADOOP-11049. javax package system class default is too broad (Sangjin Lee
    via jlowe)

    HADOOP-11154. Update BUILDING.txt to state that CMake 3.0 or newer is
    required on Mac. (cnauroth)

    HADOOP-11145. TestFairCallQueue fails. (Akira AJISAKA via cnauroth)

    HADOOP-11117 UGI HadoopLoginModule doesn't catch & wrap all
    kerberos-related exceptions (stevel)

    HADOOP-11163. MetricsSystemImpl may miss a registered source.
    (Chuan Liu via cnauroth)

    HADOOP-11179. Java untar should handle the case that the file entry comes
    without its parent directory entry. (Craig Welch via zjshen)

    HADOOP-11175. Fix several issues of hadoop security configuration in user
    doc. (Yi Liu via cnauroth)

    HADOOP-11122. Fix findbugs in ZK DelegationTokenSecretManagers.
    (Arun Suresh via kasha)

    HADOOP-11228. Winutils task: unsecure path should not call
    AddNodeManagerAndUserACEsToObject. (Remus Rusanu via jianhe)

    HADOOP-11170. ZKDelegationTokenSecretManager fails to renewToken created by 
    a peer. (Arun Suresh and Gregory Chanan via kasha)

    HADOOP-11217. Disable SSLv3 in KMS. (Robert Kanter via kasha)

    HADOOP-11068. Match hadoop.auth cookie format to jetty output.
    (Gregory Chanan via cnauroth)

    HADOOP-11250. fix endmacro of set_find_shared_library_without_version in
    CMakeLists (Yi Liu via Colin P. McCabe)

    HADOOP-11221. IdentityHashStore assumes System.identityHashCode() is
    non-negative. (Jinghui Wang via szetszwo)

    HADOOP-11241. Fixed intermittent TestNMSimulator failure due to timing issue.
    (Varun Vasudev via zjshen)

    HADOOP-11265. Credential and Key Shell Commands not available on Windows.
    (Larry McCay via cnauroth)

    HADOOP-11280. TestWinUtils#testChmod fails after removal of
    NO_PROPAGATE_INHERIT_ACE. (cnauroth)

    HADOOP-11282. Skip NFS TestShellBasedIdMapping tests that are irrelevant on
    Windows. (cnauroth)

    HADOOP-9576. Changed NetUtils#wrapException to throw EOFException instead
    of wrapping it as IOException. (Steve Loughran via jianhe)


Release 2.5.2 - 2014-11-19

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS
  
  OPTIMIZATIONS

  BUG FIXES

    HADOOP-11243. SSLFactory shouldn't allow SSLv3. (Wei Yan via kasha)

    HADOOP-11260. Patch up Jetty to disable SSLv3. (Mike Yoder via kasha)

    HADOOP-11307. create-release script should run git clean first (kasha)

Release 2.5.1 - 2014-09-05

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS
  
    HADOOP-10956. Fix create-release script to include docs and necessary txt
    files. (kasha)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-11001. Fix test-patch to work with the git repo. (kasha)

    HADOOP-11065. Rat check should exclude "**/build/**". (kasha)

Release 2.5.0 - 2014-08-11

  INCOMPATIBLE CHANGES

  NEW FEATURES

    HADOOP-10498. Add support for proxy server. (daryn)

    HADOOP-9704. Write metrics sink plugin for Hadoop/Graphite (Chu Tong, Alex Newman and Babak Behzad via raviprak)

    HADOOP-8943. Support multiple group mapping providers. (Kai Zheng via brandonli)

    HADOOP-9361 Strictly define the expected behavior of filesystem APIs and
    write tests to verify compliance (stevel)

  IMPROVEMENTS

    HADOOP-10451. Remove unused field and imports from SaslRpcServer.
    (Benoy Antony via jing9)

    HADOOP-10345. Sanitize the the inputs (groups and hosts) for the proxyuser
    configuration. (Benoy Antony via jing9)

    HADOOP-10454. Provide FileContext version of har file system. (Kihwal Lee
    via jeagles)

    HADOOP-10104. Update jackson to 1.9.13 (Akira Ajisaka via stevel)

    HADOOP-10503. Move junit up to v 4.11. (cnauroth)

    HADOOP-10535. Make the retry numbers in ActiveStandbyElector configurable.
    (jing9)

    HADOOP-10322. Add ability to read principal names from a keytab.
    (Benoy Antony and Daryn Sharp via kihwal)

    HADOOP-10549. MAX_SUBST and varPat should be final in Configuration.java.
    (Gera Shegalov via cnauroth)

    HADOOP-10471. Reduce the visibility of constants in ProxyUsers.
    (Benoy Antony via wheat9)

    HADOOP-10556. Add toLowerCase support to auth_to_local rules 
    for service name. (tucu)

    HADOOP-10467. Enable proxyuser specification to support list of users in
    addition to list of groups (Benoy Antony via Arpit Agarwal)

    HADOOP-10158. SPNEGO should work with multiple interfaces/SPNs.
    (daryn via kihwal)

    HADOOP-10566. Refactor proxyservers out of ProxyUsers.
    (Benoy Antony via suresh)

    HADOOP-10572. Example NFS mount command must pass noacl as it isn't
    supported by the server yet. (Harsh J via brandonli)

    HADOOP-10609. .gitignore should ignore .orig and .rej files. (kasha)

    HADOOP-10614. CBZip2InputStream is not threadsafe (Xiangrui Meng via
    Sandy Ryza)

    HADOOP-10618. Remove SingleNodeSetup.apt.vm. (Akira Ajisaka via
    Arpit Agarwal)

    HADOOP-9968. Makes ProxyUsers to work with NetGroups (Benoy Antony via 
    ddas)

    HADOOP-10448. Support pluggable mechanism to specify proxy user settings.
    (Benoy Antony via Arpit Agarwal)

    HADOOP-9555. HA functionality that uses ZooKeeper may experience inadvertent
    TCP RST and miss session expiration event due to bug in client connection
    management. (cnauroth)

    HADOOP-10376. Refactor refresh*Protocols into a single generic
    refreshConfigProtocol. (Chris Li via Arpit Agarwal)

    HADOOP-6350. Documenting Hadoop metrics. (Akira Ajisaka via Arpit Agarwal)

    HADOOP-10691. Improve the readability of 'hadoop fs -help'.
    (Lei Xu via wang)

    HADOOP-10688. Expose thread-level FileSystem StatisticsData (Sandy Ryza)

    HADOOP-10657. Have RetryInvocationHandler log failover attempt at INFO
    level. (Ming Ma via jing9)

    HADOOP-10666. Remove Copyright /d/d/d/d Apache Software Foundation from
    the source files license header. (Henry Saputra via wang)

    HADOOP-10557. FsShell -cp -pa option for preserving extended ACLs.
    (Akira Ajisaka via cnauroth)

    HADOOP-10279. Create multiplexer, a requirement for the fair queue.
    (Chris Li via Arpit Agarwal)

    HADOOP-10659. Refactor AccessControlList to reuse utility functions
    and to improve performance. (Benoy Antony via Arpit Agarwal)

    HADOOP-10665. Make Hadoop Authentication Handler loads case in-sensitive
    (Benoy Antony via vinayakumarb)

    HADOOP-10652. Refactor Proxyusers to use AccessControlList. (Benoy
    Antony via Arpit Agarwal)

    HADOOP-10747. Support configurable retries on SASL connection failures in
    RPC client. (cnauroth)

    HADOOP-10754. Reenable several HA ZooKeeper-related tests on Windows.
    (cnauroth)

    HADOOP-10565. Support IP ranges (CIDR) in proxyuser.hosts. (Benoy Antony
    via Arpit Agarwal)

    HADOOP-10649. Allow overriding the default ACL for service authorization
    (Benoy Antony via Arpit Agarwal)

    HADOOP-10767. Clean up unused code in Ls shell command. (cnauroth)

    HADOOP-9651 Filesystems to throw FileAlreadyExistsException in
    createFile(path, overwrite=false) when the file exists (stevel)
    
    HADOOP-9495 Define behaviour of Seekable.seek(), write tests,
    fix all hadoop implementations for compliance

    HADOOP-10312 Shell.ExitCodeException to have more useful toString (stevel)

    HADOOP-10782. Fix typo in DataChecksum class. (Jingguo Yao via suresh)

    HADOOP-10896. Update compatibility doc to capture visibility of 
    un-annotated classes/ methods. (kasha)

  OPTIMIZATIONS

    HADOOP-10674. Improve PureJavaCrc32 performance and use java.util.zip.CRC32
    for Java 7 and above. (szetszwo)

  BUG FIXES 

    HADOOP-10378. Typo in help printed by hdfs dfs -help.
    (Mit Desai via suresh)

    HADOOP-10418. SaslRpcClient should not assume that remote principals are in
    the default_realm. (atm)

    HADOOP-10426. Declare CreateOpts.getOpt(..) with generic type argument,
    removes unused FileContext.getFileStatus(..) and fixes various javac
    warnings.  (szetszwo)

    HADOOP-10414. Incorrect property name for RefreshUserMappingProtocol in
    hadoop-policy.xml. (Joey Echeverria via atm)

    HADOOP-10459. distcp V2 doesn't preserve root dir's attributes when -p is
    specified. (Yongjun Zhang via atm)

    HADOOP-10462. DF#getFilesystem is not parsing the command output. 
    (Akira AJISAKA via umamahesh)

    HADOOP-10468. TestMetricsSystemImpl.testMultiThreadedPublish fails
    intermediately. (wheat9)

    HADOOP-10475. ConcurrentModificationException in
    AbstractDelegationTokenSelector.selectToken(). (jing9)

    HADOOP-10350. BUILDING.txt should mention openssl dependency required
    for hadoop-pipes (Vinayakumar B)

    HADOOP-10495. TestFileUtil fails on Windows due to bad permission
    assertions. (cnauroth)

    HADOOP-10496. Metrics system FileSink can leak file descriptor. (cnauroth)

    HADOOP-10500. TestDoAsEffectiveUser fails on JDK7 due to failure to reset
    proxy user configuration. (cnauroth)

    HADOOP-10499. Remove unused parameter from ProxyUsers.authorize().
    (Benoy Antony via cnauroth)

    HADOOP-9919. Update hadoop-metrics2.properties examples to Yarn.
    (Akira AJISAKA via suresh)

    HADOOP-10526. Chance for Stream leakage in CompressorStream. (Rushabh 
    Shah via kihwal)

    HADOOP-10251. Both NameNodes could be in STANDBY State if SNN network is unstable
    (Vinayakumar B via umamahesh)

    HADOOP-10531. hadoop-config.sh - bug in --hosts argument.
    (Sebastien Barrier via wang)

    HADOOP-10539. Provide backward compatibility for ProxyUsers.authorize()
    call. (Benoy Antony via cnauroth)

    HADOOP-10540. Datanode upgrade in Windows fails with hardlink error.
    (Chris Nauroth and Arpit Agarwal)

    HADOOP-10508. RefreshCallQueue fails when authorization is enabled.
    (Chris Li via wheat9)

    HADOOP-10547. Give SaslPropertiesResolver.getDefaultProperties() public
    scope. (Benoy Antony via Arpit Agarwal)

    HADOOP-10543. RemoteException's unwrapRemoteException method failed for
    PathIOException. (Yongjun Zhang via atm)

    HADOOP-10568. Add s3 server-side encryption. (David S. Wang via atm)

    HADOOP-10541. InputStream in MiniKdc#initKDCServer for minikdc.ldiff is not
    closed. (Swarnim Kulkarni via cnauroth)

    HADOOP-10517. InputStream is not closed in two methods of JarFinder.
    (Ted Yu via cnauroth)

    HADOOP-10581. TestUserGroupInformation#testGetServerSideGroups fails
    because groups stored in Set and ArrayList are compared. 
    (Mit Desai via kihwal)

    HADOOP-10585. Retry polices ignore interrupted exceptions (Daryn Sharp via
    jeagles)

    HADOOP-10401. ShellBasedUnixGroupsMapping#getGroups does not always return
    primary group first (Akira AJISAKA via Colin Patrick McCabe)

    HADOOP-10489. UserGroupInformation#getTokens and UserGroupInformation
    #addToken can lead to ConcurrentModificationException (Robert Kanter via atm)

    HADOOP-10602. Documentation has broken "Go Back" hyperlinks.
    (Akira AJISAKA via cnauroth)

    HADOOP-10639. FileBasedKeyStoresFactory initialization is not using default
    for SSL_REQUIRE_CLIENT_CERT_KEY. (tucu)

    HADOOP-10638. Updating hadoop-daemon.sh to work as expected when nfs is
    started as a privileged user. (Manikandan Narayanaswamy via atm)

    HADOOP-10630. Possible race condition in RetryInvocationHandler. (jing9)

    HADOOP-10658. SSLFactory expects truststores being configured. (tucu via atm)

    HADOOP-10647. String Format Exception in SwiftNativeFileSystemStore.java.
    (Gene Kim via stevel)

    HADOOP-9099. NetUtils.normalizeHostName fails on domains where
    UnknownHost resolves to an IP address. (Ivan Mitic via suresh)

    HADOOP-10664. TestNetUtils.testNormalizeHostName fails. (atm)

    HADOOP-10656. The password keystore file is not picked by LDAP group mapping
    (brandonli)

    HADOOP-10622. Shell.runCommand can deadlock (Gera Shegalov via jlowe)

    HADOOP-10686. Writables are not always configured. 
    (Abraham Elmahrek via kasha)

    HADOOP-10678. SecurityUtil has unnecessary synchronization on collection
    used for only tests. (Benoy Antony via cnauroth)

    HADOOP-10683. Users authenticated with KERBEROS are recorded as being
    authenticated with SIMPLE. (Benoy Antony via cnauroth)

    HADOOP-10702. KerberosAuthenticationHandler does not log the principal names
    correctly. (Benoy Antony via cnauroth)

    HADOOP-10699. Fix build native library on mac osx (Binglin Chang via
    jlowe)

    HADOOP-10660. GraphiteSink should implement Closeable (Chen He and Ted Yu via raviprak)

    HADOOP-10716. Cannot use more than 1 har filesystem.
    (Rushabh Shah via cnauroth)

    HADOOP-9559. When metrics system is restarted MBean names get incorrectly
    flagged as dupes. (Mostafa Elhemali and Mike Liddell via cnauroth)

    HADOOP-10746. TestSocketIOWithTimeout#testSocketIOWithTimeout fails on
    Power PC. (Jinghui Wang via Arpit Agarwal)

    HADOOP-9705. FsShell cp -p does not preserve directory attibutes.
    (Akira AJISAKA via cnauroth)

    HADOOP-10739. Renaming a file into a directory containing the same
    filename results in a confusing I/O error (chang li via jlowe)

    HADOOP-10533 S3 input stream NPEs in MapReduce join (stevel)

    HADOOP-10419 BufferedFSInputStream NPEs on getPos() on a closed stream
    (stevel)

    HADOOP-10801 dead link in site.xml (Akira AJISAKA via stevel)

    HADOOP-10590. ServiceAuthorizationManager is not threadsafe. (Benoy Antony via vinayakumarb)

    HADOOP-10711. Cleanup some extra dependencies from hadoop-auth. (rkanter via tucu)

    HADOOP-10479. Fix new findbugs warnings in hadoop-minikdc.
    (Swarnim Kulkarni via wheat9)

    HADOOP-10715. Remove public GraphiteSink#setWriter (Babak Behzad via raviprak)

    HADOOP-10710. hadoop.auth cookie is not properly constructed according to 
    RFC2109. (Juan Yu via tucu)

    HADOOP-10864. Tool documentenation is broken. (Akira Ajisaka
    via Arpit Agarwal)

    HADOOP-10872. TestPathData fails intermittently with "Mkdirs failed
    to create d1". (Yongjun Zhang via Arpit Agarwal)

    HADOOP-10890. TestDFVariations.testMount fails intermittently. (Yongjun
    Zhang via Arpit Agarwal)

    HADOOP-10894. Fix dead link in ToolRunner documentation. (Akira Ajisaka
    via Arpit Agarwal)

    HADOOP-10910. Increase findbugs maxHeap size. (wang)

  BREAKDOWN OF HADOOP-10514 SUBTASKS AND RELATED JIRAS

    HADOOP-10520. Extended attributes definition and FileSystem APIs for
    extended attributes. (Yi Liu via wang)

    HADOOP-10546. Javadoc and other small fixes for extended attributes in
    hadoop-common. (Charles Lamb via wang)

    HADOOP-10521. FsShell commands for extended attributes. (Yi Liu via wang)

    HADOOP-10548. Improve FsShell xattr error handling and other fixes. (Charles Lamb via umamahesh)

    HADOOP-10567. Shift XAttr value encoding code out for reuse. (Yi Liu via umamahesh)

    HADOOP-10621. Remove CRLF for xattr value base64 encoding for better display.(Yi Liu via umamahesh)

    HADOOP-10575. Small fixes for XAttrCommands and test. (Yi Liu via umamahesh)

    HADOOP-10561. Copy command with preserve option should handle Xattrs.
    (Yi Liu via cnauroth)

Release 2.4.1 - 2014-06-23 

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-10466. Lower the log level in UserGroupInformation.  (Nicolas
    Liochon via szetszwo)

  OPTIMIZATIONS

  BUG FIXES 

    HADOOP-10455. When there is an exception, ipc.Server should first check
    whether it is an terse exception.  (szetszwo)

    HADOOP-10456. Bug in Configuration.java exposed by Spark
    (ConcurrentModificationException).  (Nishkam Ravi via cnauroth)

    HADOOP-10473. TestCallQueueManager should interrupt before counting calls.
    (szetszwo)

    HADOOP-10490. TestMapFile and TestBloomMapFile leak file descriptors.
    (cnauroth)

    HADOOP-10522. JniBasedUnixGroupMapping mishandles errors. (kihwal)

    HADOOP-10527. Fix incorrect return code and allow more retries on EINTR.
    (kihwal)

    HADOOP-10612. NFS failed to refresh the user group id mapping table (brandonli)

    HADOOP-10562. Namenode exits on exception without printing stack trace
    in AbstractDelegationTokenSecretManager. (Suresh Srinivas via Arpit
    Agarwal)

Release 2.4.0 - 2014-04-07 

  INCOMPATIBLE CHANGES

    HADOOP-8691. FsShell can print "Found xxx items" unnecessarily often.
    (Daryn Sharp via wheat9)

  NEW FEATURES

    HADOOP-10184. Hadoop Common changes required to support HDFS ACLs. (See
    breakdown of tasks below for features and contributors)

  IMPROVEMENTS

    HADOOP-10139. Update and improve the Single Cluster Setup document.
    (Akira Ajisaka via Arpit Agarwal)

    HADOOP-10295. Allow distcp to automatically identify the checksum type of 
    source files and use it for the target. (jing9 and Laurent Goujon)

    HADOOP-10333. Fix grammatical error in overview.html document.
    (René Nyffenegger via suresh)

    HADOOP-10343. Change info to debug log in LossyRetryInvocationHandler. (arpit)

    HADOOP-10348. Deprecate hadoop.ssl.configuration in branch-2, and remove
    it in trunk. (Haohui Mai via jing9)

    HADOOP-9454. Support multipart uploads for s3native. (Jordan Mendelson and
    Akira AJISAKA via atm)

    HADOOP-10374. InterfaceAudience annotations should have
    RetentionPolicy.RUNTIME (Enis Soztutar via Arpit Agarwal)

    HADOOP-10278. Refactor to make CallQueue pluggable. (Chris Li via
    Arpit Agarwal)

    HADOOP-10285. Admin interface to swap callqueue at runtime. (Chris Li via
    Arpit Agarwal)

    HADOOP-10314. The ls command help still shows outdated 0.16 format.
    (Rushabh S Shah via kihwal)

    HADOOP-10379. Protect authentication cookies with the HttpOnly and Secure
    flags. (wheat9)

    HADOOP-10211. Enable RPC protocol to negotiate SASL-QOP values between
    clients and servers. (Benoy Antony via Arpit Agarwal)

    HADOOP-10386. Log proxy hostname in various exceptions being thrown in a HA
    setup. (wheat9)

    HADOOP-3679. Fixup assert ordering in unit tests to yield meaningful error
    messages. (Jay Vyas via cdouglas)

    HADOOP-10221. Add a plugin to specify SaslProperties for RPC protocol
    based on connection properties. (Benoy Antony and Daryn Sharp via
    Arpit Agarwal)

    HADOOP-10015. UserGroupInformation prints out excessive warnings.
    (Nicolas Liochon via szetszwo)

    HADOOP-10423. Clarify compatibility policy document for combination of 
    new client and old server. (Chris Nauroth via kasha)

    HADOOP-10280. Make Schedulables return a configurable identity of user
    or group. (Chris Li via Arpit Agarwal)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-10320. Javadoc in InterfaceStability.java lacks final </ul>.
    (René Nyffenegger via cnauroth)
    
    HADOOP-10085. CompositeService should allow adding services while being 
    inited. (Steve Loughran via kasha)

    HADOOP-10327. Trunk windows build broken after HDFS-5746.
    (Vinay via cnauroth)

    HADOOP-10330. TestFrameDecoder fails if it cannot bind port 12345.
    (Arpit Agarwal)

    HADOOP-10326. M/R jobs can not access S3 if Kerberos is enabled. (bc Wong
    via atm)

    HADOOP-10338. Cannot get the FileStatus of the root inode from the new
    Globber (cmccabe)

    HADOOP-10249. LdapGroupsMapping should trim ldap password read from file.
    (Dilli Armugam via suresh)

    HADOOP-10346. Deadlock while logging tokens (jlowe)

    HADOOP-10328. loadGenerator exit code is not reliable.
    (Haohui Mai via cnauroth)

    HADOOP-10355. Fix TestLoadGenerator#testLoadGenerator. (Haohui Mai via jing9)

    HADOOP-10070. RPC client doesn't use per-connection conf to determine
    server's expected Kerberos principal name. (atm)

    HADOOP-10368. InputStream is not closed in VersionInfo ctor.
    (Tsuyoshi OZAWA via szetszwo)

    HADOOP-10353. FsUrlStreamHandlerFactory is not thread safe.
    (Tudor Scurtu via cnauroth)

    HADOOP-10393. Fix the javac warnings in hadoop-auth.  (szetszwo)

    HADOOP-10395. TestCallQueueManager is flaky. (Arpit Agarwal)

    HADOOP-10394. TestAuthenticationFilter is flaky. (Arpit Agarwal)
    
    HADOOP-10337 ConcurrentModificationException from
    MetricsDynamicMBeanBase.createMBeanInfo() (Liang Xie via stack)

    HADOOP-10407. Fix the javac warnings in org.apache.hadoop.ipc package.
    (szetszwo)

    HADOOP-10191. Missing executable permission on viewfs internal dirs.
    (Gera Shegalov via cnauroth)

    HADOOP-10422. Remove redundant logging of RPC retry attempts. (cnauroth)

    HADOOP-10425. LocalFileSystem.getContentSummary should not count crc files.
    (szetszwo)

    HADOOP-10440. HarFsInputStream.read(byte[]) updates position incorrectly.
    (guodongdong via szetszwo)

    HADOOP-10437. Fix the javac warnings in the conf and the util package.
    (szetszwo)

    HADOOP-10441. Namenode metric "rpc.RetryCache/NameNodeRetryCache.CacheHit"
    can't be correctly processed by Ganglia. (jing9)

    HADOOP-10449. Fix the javac warnings in the security package.  (szetszwo)

    HADOOP-10450. Build zlib native code bindings in hadoop.dll for Windows.
    (cnauroth)

    HADOOP-10301. AuthenticationFilter should return Forbidden for failed
    authentication. (Daryn Sharp via jing9)

    HADOOP-9525. Add tests that validate winutils chmod behavior on folders
    (ivanmi)

  BREAKDOWN OF HADOOP-10184 SUBTASKS AND RELATED JIRAS

    HADOOP-10185. FileSystem API for ACLs. (cnauroth)

    HADOOP-10186. Remove AclReadFlag and AclWriteFlag in FileSystem API.
    (Haohui Mai via cnauroth)

    HADOOP-10187. FsShell CLI: add getfacl and setfacl with minimal support for
    getting and setting ACLs. (Vinay via cnauroth)

    HADOOP-10192. FileSystem#getAclStatus has incorrect JavaDocs. (cnauroth)

    HADOOP-10220. Add ACL indicator bit to FsPermission. (cnauroth)

    HADOOP-10241. Clean up output of FsShell getfacl. (Chris Nauroth via wheat9)

    HADOOP-10213. Fix bugs parsing ACL spec in FsShell setfacl.
    (Vinay via cnauroth)

    HADOOP-10277. setfacl -x fails to parse ACL spec if trying to remove the
    mask entry. (Vinay via cnauroth)

    HADOOP-10270. getfacl does not display effective permissions of masked
    entries. (cnauroth)

    HADOOP-10344. Fix TestAclCommands after merging HADOOP-10338 patch.
    (cnauroth)

    HADOOP-10352. Recursive setfacl erroneously attempts to apply default ACL to
    files. (cnauroth)

    HADOOP-10354. TestWebHDFS fails after merge of HDFS-4685 to trunk. (cnauroth)

    HADOOP-10361. Correct alignment in CLI output for ACLs. (cnauroth)

    HADOOP-10399. FileContext API for ACLs. (Vinayakumar B via cnauroth)

    HADOOP-10442. Group look-up can cause segmentation fault when certain
    JNI-based mapping module is used. (Kihwal Lee via jeagles)

Release 2.3.1 - UNRELEASED

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES 

Release 2.3.0 - 2014-02-18

  INCOMPATIBLE CHANGES

  NEW FEATURES

    HADOOP-8545. Filesystem Implementation for OpenStack Swift
    (Dmitry Mezhensky, David Dobbins, Stevel via stevel)

  IMPROVEMENTS

    HADOOP-10046. Print a log message when SSL is enabled.
    (David S. Wang via wang)

    HADOOP-10079. log a warning message if group resolution takes too long.
    (cmccabe)

    HADOOP-9623 Update jets3t dependency to 0.9.0.  (Amandeep Khurana via Colin
    Patrick McCabe)

    HADOOP-10132. RPC#stopProxy() should log the class of proxy when IllegalArgumentException 
    is encountered (Ted yu via umamahesh)

    HADOOP-10248. Property name should be included in the exception where property value 
    is null (Akira AJISAKA via umamahesh)

    HADOOP-10086. User document for authentication in secure cluster.
    (Masatake Iwasaki via Arpit Agarwal)

    HADOOP-10274 Lower the logging level from ERROR to WARN for UGI.doAs method
    (Takeshi Miao via stack)

    HADOOP-9784. Add a builder for HttpServer. (Junping Du via llu)

    HADOOP 9871. Fix intermittent findbugs warnings in DefaultMetricsSystem.
    (Junping Du via llu)

    HADOOP-9319. Update bundled LZ4 source to r99. (Binglin Chang via llu)

    HADOOP-9241. DU refresh interval is not configurable (harsh)

    HADOOP-9417.  Support for symlink resolution in LocalFileSystem /
    RawLocalFileSystem.  (Andrew Wang via Colin Patrick McCabe)

    HADOOP-9703.  org.apache.hadoop.ipc.Client leaks threads on stop.
    (Tsuyoshi OZAWA vi Colin Patrick McCabe)

    HADOOP-9618.  Add thread which detects GC pauses.
    (Todd Lipcon via Colin Patrick McCabe)

    HADOOP-9435.  Support building the JNI code against the IBM JVM.
    (Tian Hong Wang via Colin Patrick McCabe)

    HADOOP-9848. Create a MiniKDC for use with security testing. 
    (ywskycn via tucu)

    HADOOP-9860. Remove class HackedKeytab and HackedKeytabEncoder from 
    hadoop-minikdc once jira DIRSERVER-1882 solved. (ywskycn via tucu)

    HADOOP-9866. convert hadoop-auth testcases requiring kerberos to 
    use minikdc. (ywskycn via tucu)

    HADOOP-9487 Deprecation warnings in Configuration should go to their
    own log or otherwise be suppressible (Chu Tong via stevel)

    HADOOP-9889. Refresh the Krb5 configuration when creating a new kdc in
    Hadoop-MiniKDC (Wei Yan via Sandy Ryza)

    HADOOP-9915.  o.a.h.fs.Stat support on Mac OS X  (Binglin Chang via Colin
    Patrick McCabe)

    HADOOP-9998.  Provide methods to clear only part of the DNSToSwitchMapping.
    (Junping Du via Colin Patrick McCabe)

    HADOOP-10006. Compilation failure in trunk for
    o.a.h.fs.swift.util.JSONUtil (Junping Du via stevel)

    HADOOP-9063. enhance unit-test coverage of class
    org.apache.hadoop.fs.FileUtil (Ivan A. Veselovsky via jlowe)

    HADOOP-9254. Cover packages org.apache.hadoop.util.bloom,
    org.apache.hadoop.util.hash (Vadim Bondarev via jlowe)

    HADOOP-9225. Cover package org.apache.hadoop.compress.Snappy (Vadim
    Bondarev, Andrey Klochkov and Nathan Roberts via jlowe)

    HADOOP-9199. Cover package org.apache.hadoop.io with unit tests (Andrey
    Klochkov via jeagles)

    HADOOP-9470. eliminate duplicate FQN tests in different Hadoop modules
    (Ivan A. Veselovsky via daryn)

    HADOOP-9494. Excluded auto-generated and examples code from clover reports
    (Andrey Klochkov via jeagles)

    HADOOP-9897. Add method to get path start position without drive specifier in
    o.a.h.fs.Path. (Binglin Chang via cnauroth)

    HADOOP-9078. enhance unit-test coverage of class
    org.apache.hadoop.fs.FileContext (Ivan A. Veselovsky via jeagles)

    HDFS-5276. FileSystem.Statistics should use thread-local counters to avoid
    multi-threaded performance issues on read/write.  (Colin Patrick McCabe)

    HADOOP-9291. enhance unit-test coverage of package o.a.h.metrics2 (Ivan A.
    Veselovsky via jeagles)

    HADOOP-10064. Upgrade to maven antrun plugin version 1.7 (Arpit Agarwal via
    jeagles)

    HADOOP-9594. Update apache commons math dependency (Timothy St. Clair via
    stevel)

    HADOOP-10095. In CodecPool, synchronize pool and codecList separately in
    order to reduce lock contention.  (Nicolas Liochon via szetszwo)

    HADOOP-10067. Missing POM dependency on jsr305 (Robert Rati via stevel)

    HADOOP-10103. update commons-lang to 2.6 (Akira AJISAKA via stevel)

    HADOOP-10111. Allow DU to be initialized with an initial value (Kihwal Lee
    via jeagles)

    HADOOP-10126. LightWeightGSet log message is confusing. (Vinay via suresh)

    HADOOP-10127. Add ipc.client.connect.retry.interval to control the frequency
    of connection retries (Karthik Kambatla via Sandy Ryza)

    HADOOP-10102. Update commons IO from 2.1 to 2.4 (Akira Ajisaka via stevel)

    HADOOP-10168. fix javadoc of ReflectionUtils#copy. (Thejas Nair via suresh)

    HADOOP-10164. Allow UGI to login with a known Subject (bobby)

    HADOOP-10169. Remove the unnecessary synchronized in JvmMetrics class.
    (Liang Xie via jing9) 

    HADOOP-10198. DomainSocket: add support for socketpair.
    (Colin Patrick McCabe via wang)

    HADOOP-10208. Remove duplicate initialization in StringUtils.getStringCollection.
    (Benoy Antony via jing9)

    HADOOP-9420. Add percentile or max metric for rpcQueueTime, processing time.
    (Liang Xie via wang)

    HADOOP-10143 replace WritableFactories's hashmap with ConcurrentHashMap
    (Liang Xie via stack)

    HADOOP-9652. Allow RawLocalFs#getFileLinkStatus to fill in the link owner
    and mode if requested. (Andrew Wang via Colin Patrick McCabe)

    HADOOP-10305. Add "rpc.metrics.quantile.enable" and
    "rpc.metrics.percentiles.intervals" to core-default.xml.
    (Akira Ajisaka via wang)

    HADOOP-10317. Rename branch-2.3 release version from 2.4.0-SNAPSHOT
    to 2.3.0-SNAPSHOT. (wang)

    HADOOP-10313. Script and jenkins job to produce Hadoop release artifacts. 
    (tucu)

  OPTIMIZATIONS

    HADOOP-10142. Avoid groups lookup for unprivileged users such as "dr.who"
    (vinay via cmccabe)

    HADOOP-9748. Reduce blocking on UGI.ensureInitialized (daryn)

    HADOOP-10047. Add a direct-buffer based apis for compression. (Gopal V
    via acmurthy)

    HADOOP-10172. Cache SASL server factories (daryn)

    HADOOP-10173. Remove UGI from DIGEST-MD5 SASL server creation (daryn via
    kihwal)

    HADOOP-10228. FsPermission#fromShort() should cache FsAction.values().
    (Haohui Mai via cnauroth)

  BUG FIXES

    HADOOP-10028. Malformed ssl-server.xml.example. (Haohui Mai via jing9)

    HADOOP-10030. FsShell -put/copyFromLocal should support Windows local path.
    (Chuan Liu via cnauroth)

    HADOOP-10031. FsShell -get/copyToLocal/moveFromLocal should support Windows
    local path. (Chuan Liu via cnauroth)

    HADOOP-10039. Add Hive to the list of projects using 
    AbstractDelegationTokenSecretManager. (Haohui Mai via jing9)

    HADOOP-10040. hadoop.cmd in UNIX format and would not run by default on
    Windows. (cnauroth)

    HADOOP-10055. FileSystemShell.apt.vm doc has typo "numRepicas".
    (Akira Ajisaka via cnauroth)

    HADOOP-10072. TestNfsExports#testMultiMatchers fails due to non-deterministic
    timing around cache expiry check. (cnauroth)

    HADOOP-9898. Set SO_KEEPALIVE on all our sockets. (todd via wang)

    HADOOP-9478. Fix race conditions during the initialization of Configuration
    related to deprecatedKeyMap (cmccabe)

    HADOOP-9660. [WINDOWS] Powershell / cmd parses -Dkey=value from command line
    as [-Dkey, value] which breaks GenericsOptionParser.
    (Enis Soztutar via cnauroth)

    HADOOP-10078. KerberosAuthenticator always does SPNEGO. (rkanter via tucu)

    HADOOP-10110. hadoop-auth has a build break due to missing dependency.
    (Chuan Liu via arp)

    HADOOP-9114. After defined the dfs.checksum.type as the NULL, write file and hflush will 
    through java.lang.ArrayIndexOutOfBoundsException (Sathish via umamahesh)

    HADOOP-10130. RawLocalFS::LocalFSFileInputStream.pread does not track
    FS::Statistics (Binglin Chang via Colin Patrick McCabe)

    HDFS-5560. Trash configuration log statements prints incorrect units.
    (Josh Elser via Andrew Wang)

    HADOOP-10081. Client.setupIOStreams can leak socket resources on exception
    or error (Tsuyoshi OZAWA via jlowe)

    HADOOP-10087. UserGroupInformation.getGroupNames() fails to return primary
    group first when JniBasedUnixGroupsMappingWithFallback is used (cmccabe)

    HADOOP-10175. Har files system authority should preserve userinfo.
    (Chuan Liu via cnauroth)

    HADOOP-10090. Jobtracker metrics not updated properly after execution
    of a mapreduce job. (ivanmi)

    HADOOP-10193. hadoop-auth's PseudoAuthenticationHandler can consume getInputStream. 
    (gchanan via tucu)

    HADOOP-10178. Configuration deprecation always emit "deprecated" warnings
    when a new key is used. (Shanyu Zhao via cnauroth)

    HADOOP-10234. "hadoop.cmd jar" does not propagate exit code. (cnauroth)

    HADOOP-10240. Windows build instructions incorrectly state requirement of
    protoc 2.4.1 instead of 2.5.0. (cnauroth)

    HADOOP-10167. Mark hadoop-common source as UTF-8 in Maven pom files / refactoring
    (Mikhail Antonov via cos)

    HADOOP-9982. Fix dead links in hadoop site docs. (Akira Ajisaka via Arpit
    Agarwal)

    HADOOP-10212. Incorrect compile command in Native Library document.
    (Akira Ajisaka via Arpit Agarwal)

    HADOOP-9830. Fix typo at http://hadoop.apache.org/docs/current/
    (Kousuke Saruta via Arpit Agarwal)

    HADOOP-10255. Rename HttpServer to HttpServer2 to retain older 
    HttpServer in branch-2 for compatibility. (Haohui Mai via suresh)

    HADOOP-10291. TestSecurityUtil#testSocketAddrWithIP fails due to test
    order dependency. (Mit Desai via Arpit Agarwal)

    HADOOP-9964. Fix deadlocks in TestHttpServer by synchronize
    ReflectionUtils.printThreadInfo. (Junping Du via llu)

    HADOOP-9582. Non-existent file to "hadoop fs -conf" doesn't throw error
    (Ashwin Shankar via jlowe)

    HADOOP-9817. FileSystem#globStatus and FileContext#globStatus need to work
    with symlinks. (Colin Patrick McCabe via Andrew Wang)

    HADOOP-9875.  TestDoAsEffectiveUser can fail on JDK 7.  (Aaron T. Myers via
    Colin Patrick McCabe)

    HADOOP-9865.  FileContext#globStatus has a regression with respect to
    relative path.  (Chuan Lin via Colin Patrick McCabe)

    HADOOP-9909. org.apache.hadoop.fs.Stat should permit other LANG.
    (Shinichi Yamashita via Andrew Wang)

    HADOOP-9908. Fix NPE when versioninfo properties file is missing (todd)

    HADOOP-9350. Hadoop not building against Java7 on OSX
    (Robert Kanter via stevel)

    HADOOP-9929. Insufficient permissions for a path reported as file not found.
    (Contributed by Colin Patrick McCabe)

    HADOOP-9791. Add a test case covering long paths for new FileUtil access
    check methods (ivanmi)

    HADOOP-9981. globStatus should minimize its listStatus and getFileStatus
    calls.  (Contributed by Colin Patrick McCabe)

    HADOOP-9016. HarFsInputStream.skip(long) must never return negative value.
    (Ivan A. Veselovsky via jeagles)

    HADOOP-10088. copy-nativedistlibs.sh needs to quote snappy lib dir.
    (Raja Aluri via cnauroth)

    HADOOP-10093. hadoop-env.cmd sets HADOOP_CLIENT_OPTS with a max heap size
    that is too small. (Shanyu Zhao via cnauroth)

    HADOOP-10094. NPE in GenericOptionsParser#preProcessForWindows().
    (Enis Soztutar via cnauroth)

    HADOOP-10100. MiniKDC shouldn't use apacheds-all artifact. (rkanter via tucu)

    HADOOP-10107. Server.getNumOpenConnections may throw NPE. (Kihwal Lee via
    jing9)

    HADOOP-10135 writes to swift fs over partition size leave temp files and
    empty output file (David Dobbins via stevel)

    HADOOP-10129. Distcp may succeed when it fails (daryn)

    HADOOP-10058. TestMetricsSystemImpl#testInitFirstVerifyStopInvokedImmediately
    fails on trunk (Chen He via jeagles)

    HADOOP-8753. LocalDirAllocator throws "ArithmeticException: / by zero" when
    there is no available space on configured local dir. (Benoy Antony via hitesh)

    HADOOP-10106. Incorrect thread name in RPC log messages. (Ming Ma via jing9)

    HADOOP-9611 mvn-rpmbuild against google-guice > 3.0 yields missing cglib
    dependency (Timothy St. Clair via stevel)

    HADOOP-10171. TestRPC fails intermittently on jkd7 (Mit Desai via jeagles)

    HADOOP-10147  HDFS-5678 Upgrade to commons-logging 1.1.3 to avoid potential
    deadlock in MiniDFSCluster (stevel)

    HADOOP-10207. TestUserGroupInformation#testLogin is flaky (jxiang via cmccabe)

    HADOOP-10214. Fix multithreaded correctness warnings in ActiveStandbyElector
    (Liang Xie via kasha)

    HADOOP-10223. MiniKdc#main() should close the FileReader it creates. 
    (Ted Yu via tucu)

    HADOOP-10236. Fix typo in o.a.h.ipc.Client#checkResponse. (Akira Ajisaka
    via suresh)

    HADOOP-10146. Workaround JDK7 Process fd close bug (daryn)

    HADOOP-10125. no need to process RPC request if the client connection
    has been dropped (Ming Ma via brandonli)

    HADOOP-10235. Hadoop tarball has 2 versions of stax-api JARs. (tucu)

    HADOOP-10252. HttpServer can't start if hostname is not specified. (Jimmy
    Xiang via atm)

    HADOOP-10203. Connection leak in
    Jets3tNativeFileSystemStore#retrieveMetadata. (Andrei Savu via atm)

    HADOOP-10250. VersionUtil returns wrong value when comparing two versions.
    (Yongjun Zhang via atm)

    HADOOP-10288. Explicit reference to Log4JLogger breaks non-log4j users
    (todd)

    HADOOP-10310. SaslRpcServer should be initialized even when no secret
    manager present. (atm)

    HADOOP-10311. Cleanup vendor names from the code base. (tucu)

    HADOOP-10273. Fix 'mvn site'. (Arpit Agarwal)

Release 2.2.0 - 2013-10-13

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-9948. Add a config value to CLITestHelper to skip tests on Windows.
    (Chuan Liu via cnauroth)

    HADOOP-9976. Different versions of avro and avro-maven-plugin (Karthik
    Kambatla via Sandy Ryza)

    HADOOP-9758.  Provide configuration option for FileSystem/FileContext
    symlink resolution.  (Andrew Wang via Colin Patrick McCabe)

    HADOOP-8315. Support SASL-authenticated ZooKeeper in ActiveStandbyElector
    (todd)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9776. HarFileSystem.listStatus() returns invalid authority if port
    number is empty. (Shanyu Zhao via ivanmi)

    HADOOP-9761.  ViewFileSystem#rename fails when using DistributedFileSystem.
    (Andrew Wang via Colin Patrick McCabe)

    HADOOP-10003. HarFileSystem.listLocatedStatus() fails.
    (Jason Dere and suresh via suresh)

    HADOOP-10017. Fix NPE in DFSClient#getDelegationToken when doing Distcp 
    from a secured cluster to an insecured cluster. (Haohui Mai via jing9)

Release 2.1.1-beta - 2013-09-23

  INCOMPATIBLE CHANGES

    HADOOP-9944. Fix RpcRequestHeaderProto.callId to be sint32 rather than
    uint32 since ipc.Client.CONNECTION_CONTEXT_CALL_ID is signed (i.e. -3) 
    (acmurthy)

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-9910. proxy server start and stop documentation wrong
    (Andre Kelpe via harsh)

    HADOOP-9446. Support Kerberos SPNEGO for IBM JDK. (Yu Gao via llu)
 
    HADOOP-9787. ShutdownHelper util to shutdown threads and threadpools.
    (Karthik Kambatla via Sandy Ryza)

    HADOOP-9803. Add a generic type parameter to RetryInvocationHandler.
    (szetszwo)

    HADOOP-9821. ClientId should have getMsb/getLsb methods. 
    (Tsuyoshi OZAWA via jing9)

    HADOOP-9672. Upgrade Avro dependency to 1.7.4. (sandy via kihwal)

    HADOOP-9789. Support server advertised kerberos principals (daryn)

    HADOOP-8814. Replace string equals "" by String#isEmpty().
    (Brandon Li via suresh)

    HADOOP-9802. Support Snappy codec on Windows. (cnauroth)

    HADOOP-9879. Move the version info of zookeeper dependencies to
    hadoop-project/pom (Karthik Kambatla via Sandy Ryza)
    
    HADOOP-9886. Turn warning message in RetryInvocationHandler to debug (arpit)

    HADOOP-9906. Move HAZKUtil to o.a.h.util.ZKUtil and make inner-classes
    public (Karthik Kambatla via Sandy Ryza)

    HADOOP-9918. Add addIfService to CompositeService (Karthik Kambatla via
    Sandy Ryza)

    HADOOP-9945. HAServiceState should have a state for stopped services.
    (Karthik Kambatla via atm)

    HADOOP-9962. in order to avoid dependency divergence within Hadoop itself 
    lets enable DependencyConvergence. (rvs via tucu)

    HADOOP-9669. Reduce the number of byte array creations and copies in
    XDR data manipulation. (Haohui Mai via brandonli)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9916. Fix race in ipc.Client retry. (Binglin Chang via llu)

    HADOOP-9768. chown and chgrp reject users and groups with spaces on platforms
    where spaces are otherwise acceptable. (cnauroth)

    HADOOP-9801. Configuration#writeXml uses platform defaulting encoding, which
    may mishandle multi-byte characters. (cnauroth)

    HADOOP-9806 PortmapInterface should check if the procedure is out-of-range
    (brandonli)

    HADOOP-9527. Add symlink support to LocalFileSystem on Windows.
    (Arpit Agarwal via cnauroth)

    HADOOP-9831. Make checknative shell command accessible on Windows. (cnauroth)

    HADOOP-9675. use svn:eol-style native for html to prevent line ending
    issues (Colin Patrick McCabe)

    HADOOP-9757. Har metadata cache can grow without limit (Cristina Abad via daryn)

    HADOOP-9857. Tests block and sometimes timeout on Windows due to invalid
    entropy source. (cnauroth)

    HADOOP-9381. Document dfs cp -f option. (Keegan Witt, suresh via suresh)

    HADOOP-9868. Server must not advertise kerberos realm. (daryn via kihwal)

    HADOOP-9880. SASL changes from HADOOP-9421 breaks Secure HA NN. (daryn via
    jing9)

    HADOOP-9887. globStatus does not correctly handle paths starting with a drive
    spec on Windows. (Chuan Liu via cnauroth)

    HADOOP-9894.  Race condition in Shell leads to logged error stream handling
    exceptions (Arpit Agarwal)

    HADOOP-9774. RawLocalFileSystem.listStatus() return absolute paths when
    input path is relative on Windows. (Shanyu Zhao via ivanmi)

    HADOOP-9924. FileUtil.createJarWithClassPath() does not generate relative
    classpath correctly. (Shanyu Zhao via ivanmi)

    HADOOP-9932. Improper synchronization in RetryCache. (kihwal)

    HADOOP-9958. Add old constructor back to DelegationTokenInformation to
    unbreak downstream builds. (Andrew Wang)

    HADOOP-9960. Upgrade Jersey version to 1.9. (Karthik Kambatla via atm)

    HADOOP-9557. hadoop-client excludes commons-httpclient. (Lohit Vijayarenu via
    cnauroth)

    HADOOP-9961. versions of a few transitive dependencies diverged between hadoop 
    subprojects. (rvs via tucu)

    HADOOP-9977. Hadoop services won't start with different keypass and
    keystorepass when https is enabled. (cnauroth)

    HADOOP-10005. No need to check INFO severity level is enabled or not.
    (Jackie Chang via suresh)

Release 2.1.0-beta - 2013-08-22

  INCOMPATIBLE CHANGES

    HADOOP-8886. Remove KFS support. (eli)

    HADOOP-9163. [RPC v9] The rpc msg in ProtobufRpcEngine.proto should be moved out to
    avoid an extra copy (Sanjay Radia)

    HADOOP-9151. [RPC v9] Include RPC error info in RpcResponseHeader instead of sending
    it separately (sanjay Radia)

    HADOOP-9380. [RPC v9] Add totalLength to rpc response  (sanjay Radia)

    HADOOP-9425. [RPC v9] Add error codes to rpc-response (sanjay Radia)

    HADOOP-9194. [RPC v9] RPC support for QoS. (Junping Du via llu)

    HADOOP-9630. [RPC v9] Remove IpcSerializationType. (Junping Du via llu)

    HADOOP-9421. [RPC v9] Convert SASL to use ProtoBuf and provide
    negotiation capabilities (daryn)

    HADOOP-9688. Add globally unique Client ID to RPC requests. (suresh)

    HADOOP-9683. [RPC v9] Wrap IpcConnectionContext in RPC headers (daryn)

    HADOOP-9698. [RPC v9] Client must honor server's SASL negotiate response (daryn)

    HADOOP-9832. [RPC v9] Add RPC header to client ping (daryn)

    HADOOP-9820. [RPC v9] Wire protocol is insufficient to support multiplexing. (daryn via jitendra)

  NEW FEATURES

    HADOOP-9283. Add support for running the Hadoop client on AIX. (atm)

    HADOOP-8415. Add getDouble() and setDouble() in 
    org.apache.hadoop.conf.Configuration (Jan van der Lugt via harsh)

    HADOOP-9338. FsShell Copy Commands Should Optionally Preserve File
    Attributes. (Nick White via atm)

    HADOOP-8562. Enhancements to support Hadoop on Windows Server and Windows
    Azure environments. (See breakdown of tasks below for subtasks and
    contributors)

    HADOOP-8469. Make NetworkTopology class pluggable.  (Junping Du via
    szetszwo)

    HADOOP-8470. Add NetworkTopologyWithNodeGroup, a 4-layer implementation
    of NetworkTopology.  (Junping Du via szetszwo)

    HADOOP-9763. Extends LightWeightGSet to support eviction of expired 
    elements. (Tsz Wo (Nicholas) SZE via jing9)

    HADOOP-9762. RetryCache utility for implementing RPC retries. 
    (Suresh Srinivas via jing9)

    HADOOP-9792. Retry the methods that are tagged @AtMostOnce along 
    with @Idempotent. (suresh)

    HADOOP-9509. Implement ONCRPC and XDR. (brandonli)

    HADOOP-9515. Add general interface for NFS and Mount. (brandonli)

  IMPROVEMENTS

    HADOOP-9164. Print paths of loaded native libraries in
    NativeLibraryChecker. (Binglin Chang via llu)

    HADOOP-9253. Capture ulimit info in the logs at service start time.
    (Arpit Gupta via suresh)

    HADOOP-8924. Add maven plugin alternative to shell script to save
    package-info.java. (Chris Nauroth via suresh)

    HADOOP-9117. replace protoc ant plugin exec with a maven plugin. (tucu)

    HADOOP-9279. Document the need to build hadoop-maven-plugins for
    eclipse and separate project builds. (Tsuyoshi Ozawa via suresh)

    HADOOP-9334. Upgrade netty version. (Nicolas Liochon via suresh)

    HADOOP-9343. Allow additional exceptions through the RPC layer. (sseth)

    HADOOP-9318. When exiting on a signal, print the signal name first. (Colin
    Patrick McCabe via atm)

    HADOOP-9358. "Auth failed" log should include exception string (todd)

    HADOOP-9401. CodecPool: Add counters for number of (de)compressors 
    leased out. (kkambatl via tucu)

    HADOOP-9450. HADOOP_USER_CLASSPATH_FIRST is not honored; CLASSPATH
    is PREpended instead of APpended. (Chris Nauroth and harsh via harsh)

    HADOOP-9503. Remove sleep between IPC client connect timeouts.
    (Varun Sharma via szetszwo)

    HADOOP-9322. LdapGroupsMapping doesn't seem to set a timeout for
    its directory search. (harsh)

    HADOOP-9523. Provide a generic IBM java vendor flag in PlatformName.java
    to support non-Sun JREs. (Tian Hong Wang via suresh)

    HADOOP-9511. Adding support for additional input streams (FSDataInputStream
    and RandomAccessFile) in SecureIOUtils so as to help YARN-578. (Omkar Vinit
    Joshi via vinodkv)

    HADOOP-9560. metrics2#JvmMetrics should have max memory size of JVM.
    (Tsuyoshi Ozawa via suresh)

    HADOOP-9140 Cleanup rpc PB protos (sanjay Radia)

    HADOOP-9218 Document the Rpc-wrappers used internally (sanjay Radia)

    HADOOP-9574. Added new methods in AbstractDelegationTokenSecretManager for
    helping YARN ResourceManager to reuse code for RM restart. (Jian He via
    vinodkv)

    HADOOP-7391 Document Interface Classification from HADOOP-5073 (sanjay Radia)

    HADOOP-9287. Parallel-testing hadoop-common (Andrey Klochkov via jlowe)

    HADOOP-9604. Javadoc of FSDataOutputStream is slightly inaccurate. (Jingguo
    Yao via atm)
    
    HADOOP-9625. HADOOP_OPTS not picked up by hadoop command.
    (Paul Han via arpit)

    HADOOP-9649. Promoted YARN service life-cycle libraries into Hadoop Common
    for usage across all Hadoop projects. (Zhijie Shen via vinodkv)

    HADOOP-9517. Documented various aspects of compatibility for Apache
    Hadoop. (Karthik Kambatla via acmurthy)

    HADOOP-8608. Add Configuration API for parsing time durations. (cdouglas)

    HADOOP-9619 Mark stability of .proto files (sanjay Radia)

    HADOOP-9676.  Make maximum RPC buffer size configurable (Colin Patrick
    McCabe)

    HADOOP-9691. RPC clients can generate call ID using AtomicInteger instead of
    synchronizing on the Client instance. (cnauroth)

    HADOOP-9661. Allow metrics sources to be extended. (sandyr via tucu)

    HADOOP-9370.  Write FSWrapper class to wrap FileSystem and FileContext for
    better test coverage.  (Andrew Wang via Colin Patrick McCabe)

    HADOOP-9355.  Abstract symlink tests to use either FileContext or
    FileSystem.  (Andrew Wang via Colin Patrick McCabe)

    HADOOP-9673.  NetworkTopology: when a node can't be added, print out its
    location for diagnostic purposes.  (Colin Patrick McCabe)

    HADOOP-9414.  Refactor out FSLinkResolver and relevant helper methods.
    (Andrew Wang via Colin Patrick McCabe)

    HADOOP-9416.  Add new symlink resolution methods in FileSystem and
    FileSystemLinkResolver.  (Andrew Wang via Colin Patrick McCabe)

    HADOOP-9720. Rename Client#uuid to Client#clientId. (Arpit Agarwal via
    suresh)

    HADOOP-9734. Common protobuf definitions for GetUserMappingsProtocol,
    RefreshAuthorizationPolicyProtocol and RefreshUserMappingsProtocol (jlowe)

    HADOOP-9716. Rpc retries should use the same call ID as the original call.
    (szetszwo)

    HADOOP-9717. Add retry attempt count to the RPC requests. (jing9)

    HADOOP-9751. Add clientId and retryCount to RpcResponseHeaderProto.
    (szetszwo)

    HADOOP-9754. Remove unnecessary "throws IOException/InterruptedException",
    and fix generic and other javac warnings.  (szetszwo)

    HADOOP-9760. Move GSet and related classes to common from HDFS.
    (suresh)

    HADOOP-9756. Remove the deprecated getServer(..) methods from RPC.
    (Junping Du via szetszwo)

    HADOOP-9770. Make RetryCache#state non volatile. (suresh)

    HADOOP-9786. RetryInvocationHandler#isRpcInvocation should support 
    ProtocolTranslator. (suresh and jing9)

  OPTIMIZATIONS

    HADOOP-9150. Avoid unnecessary DNS resolution attempts for logical URIs
    (todd)

    HADOOP-9845. Update protobuf to 2.5 from 2.4.x. (tucu)

    HADOOP-9872. Improve protoc version handling and detection. (tucu)

  BUG FIXES

    HADOOP-9294. GetGroupsTestBase fails on Windows. (Chris Nauroth via suresh)

    HADOOP-9305. Add support for running the Hadoop client on 64-bit AIX. (atm)

    HADOOP-9245. mvn clean without running mvn install before fails.
    (Karthik Kambatla via suresh)

    HADOOP-9246 Execution phase for hadoop-maven-plugin should be
    process-resources (Karthik Kambatla and Chris Nauroth via jlowe)

    HADOOP-9297. remove old record IO generation and tests. (tucu)

    HADOOP-9154. SortedMapWritable#putAll() doesn't add key/value classes to
    the map. (Karthik Kambatla via tomwhite)

    HADOOP-9304. remove addition of avro genreated-sources dirs to build. (tucu)

    HADOOP-9267. hadoop -help, -h, --help should show usage instructions.
    (Andrew Wang via atm)

    HADOOP-8569. CMakeLists.txt: define _GNU_SOURCE and _LARGEFILE_SOURCE.
    (Colin Patrick McCabe via atm)

    HADOOP-9323. Fix typos in API documentation. (suresh)

    HADOOP-7487. DF should throw a more reasonable exception when mount cannot
    be determined. (Andrew Wang via atm)

    HADOOP-8917. add LOCALE.US to toLowerCase in SecurityUtil.replacePattern.
    (Arpit Gupta via suresh)

    HADOOP-9342. Remove jline from distribution. (thw via tucu)

    HADOOP-9230. TestUniformSizeInputFormat fails intermittently. 
    (kkambatl via tucu)

    HADOOP-9349. Confusing output when running hadoop version from one hadoop 
    installation when HADOOP_HOME points to another. (sandyr via tucu)

    HADOOP-9337. org.apache.hadoop.fs.DF.getMount() does not work on Mac OS.
    (Ivan A. Veselovsky via atm)

    HADOOP-9369. DNS#reverseDns() can return hostname with . appended at the
    end. (Karthik Kambatla via atm)

    HADOOP-9379. capture the ulimit info after printing the log to the 
    console. (Arpit Gupta via suresh)

    HADOOP-9399. protoc maven plugin doesn't work on mvn 3.0.2 (todd)

    HADOOP-9407. commons-daemon 1.0.3 dependency has bad group id causing
    build issues. (Sangjin Lee via suresh)

    HADOOP-9405. TestGridmixSummary#testExecutionSummarizer is broken. (Andrew
    Wang via atm)

    HADOOP-9430. TestSSLFactory fails on IBM JVM. (Amir Sanjar via suresh)

    HADOOP-9125. LdapGroupsMapping threw CommunicationException after some
    idle time. (Kai Zheng via atm)

    HADOOP-9429. TestConfiguration fails with IBM JAVA. (Amir Sanjar via
    suresh)

    HADOOP-9222. Cover package with org.apache.hadoop.io.lz4 unit tests (Vadim 
    Bondarev via jlowe)

    HADOOP-9233. Cover package org.apache.hadoop.io.compress.zlib with unit
    tests (Vadim Bondarev via jlowe)

    HADOOP-9211. Set default max heap size in HADOOP_CLIENT_OPTS to 512m
    in order to avoid OOME. (Plamen Jeliazkov via shv)

    HADOOP-9473. Typo in FileUtil copy() method. (Glen Mazza via suresh)

    HADOOP-9504. MetricsDynamicMBeanBase has concurrency issues in
    createMBeanInfo (Liang Xie via jlowe)

    HADOOP-9455. HADOOP_CLIENT_OPTS appended twice causes JVM failures.
    (Chris Nauroth via suresh)

    HADOOP-9550. Remove aspectj dependency. (kkambatl via tucu)

    HADOOP-9549. WebHdfsFileSystem hangs on close(). (daryn via kihwal)

    HADOOP-9485. No default value in the code for
    hadoop.rpc.socket.factory.class.default. (Colin Patrick McCabe via atm)

    HADOOP-9459. ActiveStandbyElector can join election even before
    Service HEALTHY, and results in null data at ActiveBreadCrumb.
    (Vinay and todd via todd)

    HADOOP-9307. BufferedFSInputStream.read returns wrong results
    after certain seeks. (todd)

    HADOOP-9220. Unnecessary transition to standby in ActiveStandbyElector.
    (tom and todd via todd)

    HADOOP-9563. Fix incompatibility introduced by HADOOP-9523.
    (Tian Hong Wang via suresh)

    HADOOP-9566. Performing direct read using libhdfs sometimes raises SIGPIPE
    (which in turn throws SIGABRT) causing client crashes. (Colin Patrick
    McCabe via atm)

    HADOOP-9481. Broken conditional logic with HADOOP_SNAPPY_LIBRARY. (Vadim
    Bondarev via atm)

    HADOOP-9593. stack trace printed at ERROR for all yarn clients without
    hadoop.home set (stevel)

    HADOOP-8957. AbstractFileSystem#IsValidName should be overridden for
    embedded file systems like ViewFs (Chris Nauroth via Sanjay Radia)

    HADOOP-9607. Fixes in Javadoc build (Timothy St. Clair via cos)

    HADOOP-9605. Update junit dependency. (Timothy St. Clair via cos)

    HADOOP-9581. hadoop --config non-existent directory should result in error
    (Ashwin Shankar via jlowe)

    HADOOP-9638. Parallel test changes caused invalid test path for several HDFS
    tests on Windows (Andrey Klochkov via cnauroth)

    HADOOP-9632. TestShellCommandFencer will fail if there is a 'host' machine in
    the network. (Chuan Liu via cnauroth)

    HADOOP-9624. TestFSMainOperationsLocalFileSystem failed when the Hadoop test
    root path has "X" in its name. (Xi Fang via cnauroth)

    HADOOP-9439.  JniBasedUnixGroupsMapping: fix some crash bugs (Colin Patrick
    McCabe)

    HADOOP-9656. Gridmix unit tests fail on Windows and Linux. (Chuan Liu via
    cnauroth)

    HADOOP-9707. Fix register lists for crc32c inline assembly. (todd via
    kihwal)

    HADOOP-9738. TestDistCh fails. (jing9 via kihwal)

    HADOOP-9759. Add support for NativeCodeLoader#getLibraryName on Windows.
    (Chuan Liu via cnauroth)

    HADOOP-9773. TestLightWeightCache should not set size limit to zero when
    testing it.  (szetszwo)

    HADOOP-9507. LocalFileSystem rename() is broken in some cases when
    destination exists. (cnauroth)

    HADOOP-9816. RPC Sasl QOP is broken (daryn)

    HADOOP-9850. RPC kerberos errors don't trigger relogin. (daryn via kihwal)

  BREAKDOWN OF HADOOP-8562 SUBTASKS AND RELATED JIRAS

    HADOOP-8924. Hadoop Common creating package-info.java must not depend on
    sh. (Chris Nauroth via suresh)

    HADOOP-8945. Merge winutils from branch-1-win to branch-trunk-win.
    (Bikas Saha, Chuan Liu, Giridharan Kesavan, Ivan Mitic, and Steve Maine
    ported by Chris Nauroth via suresh)

    HADOOP-8946. winutils: compile codebase during Maven build on 
    branch-trunk-win. (Chris Nauroth via suresh)

    HADOOP-8947. Merge FileUtil and Shell changes from branch-1-win to 
    branch-trunk-win to enable initial test pass. (Raja Aluri, Davio Lao, 
    Sumadhur Reddy Bolli, Ahmed El Baz, Kanna Karanam, Chuan Liu, 
    Ivan Mitic, Chris Nauroth, and Bikas Saha via suresh)

    HADOOP-8954. "stat" executable not found on Windows. (Bikas Saha, Ivan Mitic
    ported by Chris Narouth via suresh)

    HADOOP-8959. TestUserGroupInformation fails on Windows due to "id" executable
    not found. (Bikas Saha, Ivan Mitic, ported by Chris Narouth via suresh)

    HADOOP-8955. "chmod" executable not found on Windows.
    (Chris Nauroth via suresh)

    HADOOP-8960. TestMetricsServlet fails on Windows. (Ivan Mitic via suresh)

    HADOOP-8961. GenericOptionsParser URI parsing failure on Windows.
    (Ivan Mitic via suresh)

    HADOOP-8949. Remove FileUtil.CygPathCommand dead code. (Chris Nauroth via 
    suresh)

    HADOOP-8956. FileSystem.primitiveMkdir failures on Windows cause multiple
    test suites to fail. (Chris Nauroth via suresh)

    HADOOP-8978. TestTrash fails on Windows. (Chris Nauroth via suresh)

    HADOOP-8979. TestHttpServer fails on Windows. (Chris Nauroth via suresh)

    HADOOP-8953. Shell PathData parsing failures on Windows. (Arpit Agarwal via
    suresh)

    HADOOP-8975. TestFileContextResolveAfs fails on Windows. (Chris Nauroth via
    suresh)

    HADOOP-8977. Multiple FsShell test failures on Windows. (Chris Nauroth via
    suresh)

    HADOOP-9005. Merge hadoop cmd line scripts from branch-1-win. (David Lao, 
    Bikas Saha, Lauren Yang, Chuan Liu, Thejas M Nair and Ivan Mitic via suresh)

    HADOOP-9008. Building hadoop tarball fails on Windows. (Chris Nauroth via
    suresh)

    HADOOP-9011. saveVersion.py does not include branch in version annotation.
    (Chris Nauroth via suresh)

    HADOOP-9110. winutils ls off-by-one error indexing MONTHS array can cause 
    access violation. (Chris Nauroth via suresh)

    HADOOP-9056. Build native library on Windows. (Chuan Liu, Arpit Agarwal via
    suresh)

    HADOOP-9144. Fix findbugs warnings. (Chris Nauroth via suresh)

    HADOOP-9081. Add TestWinUtils. (Chuan Liu, Ivan Mitic, Chris Nauroth, 
    and Bikas Saha via suresh)

    HADOOP-9146. Fix sticky bit regression on branch-trunk-win.
    (Chris Nauroth via suresh)

    HADOOP-9266. Fix javac, findbugs, and release audit warnings on
    branch-trunk-win. (Chris Nauroth via suresh)

    HADOOP-9270. Remove a stale java comment from FileUtil. (Chris Nauroth via
    szetszwo)

    HADOOP-9271. Revert Python build scripts from branch-trunk-win.
    (Chris Nauroth via suresh)

    HADOOP-9313. Remove spurious mkdir from hadoop-config.cmd.
    (Ivan Mitic via suresh)

    HADOOP-9309. Test failures on Windows due to UnsatisfiedLinkError
    in NativeCodeLoader#buildSupportsSnappy. (Arpit Agarwal via suresh)

    HADOOP-9347. Add instructions to BUILDING.txt describing how to
    build on Windows. (Chris Nauroth via suresh)

    HADOOP-9348. Address TODO in winutils to add more command line usage
    and examples. (Chris Nauroth via suresh)

    HADOOP-9354. Windows native project files missing license headers.
    (Chris Nauroth via suresh)

    HADOOP-9356. Remove remaining references to cygwin/cygpath from scripts.
    (Chris Nauroth via suresh)

    HADOOP-9232. JniBasedUnixGroupsMappingWithFallback fails on Windows
    with UnsatisfiedLinkError. (Ivan Mitic via suresh)

    HADOOP-9368. Add timeouts to new tests in branch-trunk-win.
    (Arpit Agarwal via suresh)

    HADOOP-9373. Merge CHANGES.branch-trunk-win.txt to CHANGES.txt.
    (suresh)

    HADOOP-9372. Fix bad timeout annotations on tests.
    (Arpit Agarwal via suresh)

    HADOOP-9376. TestProxyUserFromEnv fails on a Windows domain joined machine.
    (Ivan Mitic via suresh)

    HADOOP-9365. TestHAZKUtil fails on Windows. (Ivan Mitic via suresh)

    HADOOP-9364. PathData#expandAsGlob does not return correct results for
    absolute paths on Windows. (Ivan Mitic via suresh)

    HADOOP-8973. DiskChecker cannot reliably detect an inaccessible disk on
    Windows with NTFS ACLs. (Chris Nauroth via suresh)

    HADOOP-9388. TestFsShellCopy fails on Windows. (Ivan Mitic via suresh)

    HADOOP-9387. Fix DF so that it won't execute a shell command on Windows
    to compute the file system/mount point.  (Ivan Mitic via szetszwo)

    HADOOP-9353. Activate native-win maven profile by default on Windows.
    (Arpit Agarwal via szetszwo)

    HADOOP-9437. TestNativeIO#testRenameTo fails on Windows due to assumption
    that POSIX errno is embedded in NativeIOException. (Chris Nauroth via
    suresh)

    HADOOP-9443. Port winutils static code analysis change to trunk.
    (Chuan Liu via suresh)

    HADOOP-9290. Some tests cannot load native library on windows.
    (Chris Nauroth via suresh)

    HADOOP-9500. TestUserGroupInformation#testGetServerSideGroups fails on 
    Windows due to failure to find winutils.exe. (Chris Nauroth via suresh)

    HADOOP-9490. LocalFileSystem#reportChecksumFailure not closing the 
    checksum file handle before rename. (Ivan Mitic via suresh)

    HADOOP-9524. Fix ShellCommandFencer to work on Windows.
    (Arpit Agarwal via suresh)

    HADOOP-9413. Add common utils for File#setReadable/Writable/Executable &
    File#canRead/Write/Execute that work cross-platform. (Ivan Mitic via suresh)

    HADOOP-9532. HADOOP_CLIENT_OPTS is appended twice by Windows cmd scripts.
    (Chris Nauroth via suresh)

    HADOOP-9043. Disallow in winutils creating symlinks with forwards slashes.
    (Chris Nauroth and Arpit Agarwal via suresh)

    HADOOP-9483. winutils support for readlink command.
    (Arpit Agarwal via suresh)
    
    HADOOP-9488. FileUtil#createJarWithClassPath only substitutes environment
    variables from current process environment/does not support overriding
    when launching new process (Chris Nauroth via bikas)

    HADOOP-9556. disable HA tests on Windows that fail due to ZooKeeper client
    connection management bug. (Chris Nauroth via suresh)

    HADOOP-9553. TestAuthenticationToken fails on Windows.
    (Arpit Agarwal via suresh)

    HADOOP-9397. Incremental dist tar build fails. (Chris Nauroth via jlowe)

    HADOOP-9131. Turn off TestLocalFileSystem#testListStatusWithColons on
    Windows. (Chris Nauroth via suresh)

    HADOOP-9526. TestShellCommandFencer and TestShell fail on Windows.
    (Arpit Agarwal via suresh)

    HADOOP-8982. TestSocketIOWithTimeout fails on Windows.
    (Chris Nauroth via suresh)

    HADOOP-8958. ViewFs:Non absolute mount name failures when running 
    multiple tests on Windows. (Chris Nauroth via suresh)

    HADOOP-9599. hadoop-config.cmd doesn't set JAVA_LIBRARY_PATH correctly.
    (Mostafa Elhemali via ivanmi)

    HADOOP-9637. Adding Native Fstat for Windows as needed by YARN. (Chuan Liu
    via cnauroth)

    HADOOP-9264. Port change to use Java untar API on Windows from 
    branch-1-win to trunk. (Chris Nauroth via suresh)

    HADOOP-9678. TestRPC#testStopsAllThreads intermittently fails on Windows.
    (Ivan Mitic via cnauroth)

    HADOOP-9681. FileUtil.unTarUsingJava() should close the InputStream upon
    finishing. (Chuan Liu via cnauroth)

    HADOOP-9665. Fixed BlockDecompressorStream#decompress to return -1 rather
    than throw EOF at end of file. (Zhijie Shen via acmurthy)

    HADOOP-8440. HarFileSystem.decodeHarURI fails for URIs whose host contains
    numbers. (Ivan Mitic via cnauroth)

    HADOOP-9643. org.apache.hadoop.security.SecurityUtil calls 
    toUpperCase(Locale.getDefault()) as well as toLowerCase(Locale.getDefault()) 
    on hadoop.security.authentication value. (markrmiller@gmail.com via tucu)

    HADOOP-9701. mvn site ambiguous links in hadoop-common. (kkambatl via tucu)

Release 2.0.6-alpha - 08/22/2013

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

Release 2.0.5-alpha - 06/06/2013

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

  HADOOP-9407. commons-daemon 1.0.3 dependency has bad group id causing
  build issues. (Sangjin Lee via suresh)

Release 2.0.4-alpha - 2013-04-25

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9467. Metrics2 record filter should check name as well as tags.
    (Chris Nauroth and Ganeshan Iyler via llu)

    HADOOP-9406. hadoop-client leaks dependency on JDK tools jar. (tucu)

    HADOOP-9301. hadoop client servlet/jsp/jetty/tomcat JARs creating
    conflicts in Oozie & HttpFS. (tucu)

    HADOOP-9299.  kerberos name resolution is kicking in even when kerberos
    is not configured (daryn)

    HADOOP-9408. misleading description for net.topology.table.file.name
    property in core-default.xml. (rajeshbabu via suresh)

    HADOOP-9444. Modify hadoop-policy.xml to replace unexpanded variables to a
    default value of '*'. (Roman Shaposhnik via vinodkv)

    HADOOP-9471. hadoop-client wrongfully excludes jetty-util JAR, 
    breaking webhdfs. (tucu)

Release 2.0.3-alpha - 2013-02-06 

  INCOMPATIBLE CHANGES

    HADOOP-8999. SASL negotiation is flawed (daryn)

  NEW FEATURES

    HADOOP-8561. Introduce HADOOP_PROXY_USER for secure impersonation in child
    hadoop client processes. (Yu Gao via llu)

    HADOOP-8597. Permit FsShell's text command to read Avro files.
    (Ivan Vladimirov Ivanov via cutting)

    HADOOP-9020. Add a SASL PLAIN server (daryn via bobby)

    HADOOP-9090. Support on-demand publish of metrics. (Mostafa Elhemali via
    suresh)

    HADOOP-9054. Add AuthenticationHandler that uses Kerberos but allows for 
    an alternate form of authentication for browsers. (rkanter via tucu)

  IMPROVEMENTS

    HADOOP-8789. Tests setLevel(Level.OFF) should be Level.ERROR.
    (Andy Isaacson via eli)

    HADOOP-8755. Print thread dump when tests fail due to timeout. (Andrey
    Klochkov via atm)

    HADOOP-8806. libhadoop.so: dlopen should be better at locating
    libsnappy.so, etc. (Colin Patrick McCabe via eli)

    HADOOP-8812. ExitUtil#terminate should print Exception#toString. (eli)

    HADOOP-8736. Add Builder for building RPC server. (Brandon Li via Suresh)

    HDFS-3957. Change MutableQuantiles to use a shared thread for rolling
    over metrics. (Andrew Wang via todd)

    HADOOP-8851. Use -XX:+HeapDumpOnOutOfMemoryError JVM option in the forked
    tests. (Ivan A. Veselovsky via atm)

    HADOOP-8783. Improve RPC.Server's digest auth (daryn)

    HADOOP-8889. Upgrade to Surefire 2.12.3 (todd)

    HADOOP-8804. Improve Web UIs when the wildcard address is used.
    (Senthil Kumar via eli)

    HADOOP-8894. GenericTestUtils.waitFor should dump thread stacks on timeout
    (todd)

    HADOOP-8909. Hadoop Common Maven protoc calls must not depend on external
    sh script. (Chris Nauroth via suresh)

    HADOOP-8911. CRLF characters in source and text files.
    (Raja Aluri via suresh)

    HADOOP-8912. Add .gitattributes file to prevent CRLF and LF mismatches
    for source and text files. (Raja Aluri via suresh)

    HADOOP-8784. Improve IPC.Client's token use (daryn)

    HADOOP-8929. Add toString, other improvements for SampleQuantiles (todd)

    HADOOP-8922. Provide alternate JSONP output for JMXJsonServlet to allow
    javascript in browser (Damien Hardy via bobby)

    HADOOP-8931. Add Java version to startup message. (eli)

    HADOOP-8925. Remove the packaging. (eli)

    HADOOP-8985. Add namespace declarations in .proto files for languages 
    other than java. (Binglin Chan via suresh)

    HADOOP-9009. Add SecurityUtil methods to get/set authentication method
    (daryn via bobby)

    HADOOP-9010. Map UGI authenticationMethod to RPC authMethod (daryn via
    bobby)

    HADOOP-9013. UGI should not hardcode loginUser's authenticationType (daryn
    via bobby)

    HADOOP-9014. Standardize creation of SaslRpcClients (daryn via bobby)

    HADOOP-9015. Standardize creation of SaslRpcServers (daryn via bobby)

    HADOOP-8860. Split MapReduce and YARN sections in documentation navigation.
    (tomwhite via tucu)

    HADOOP-9021. Enforce configured SASL method on the server (daryn via
    bobby)

    HADOO-8998. set Cache-Control no-cache header on all dynamic content. (tucu)

    HADOOP-9035. Generalize setup of LoginContext (daryn via bobby)

    HADOOP-9093. Move all the Exception in PathExceptions to o.a.h.fs package.
    (suresh)

    HADOOP-9042. Add a test for umask in FileSystemContractBaseTest.
    (Colin McCabe via eli)

    HADOOP-9127. Update documentation for ZooKeeper Failover Controller.
    (Daisuke Kobayashi via atm)

    HADOOP-9004. Allow security unit tests to use external KDC. (Stephen Chu
    via suresh)

    HADOOP-9147. Add missing fields to FIleStatus.toString.
    (Jonathan Allen via suresh)

    HADOOP-8427. Convert Forrest docs to APT, incremental. (adi2 via tucu)

    HADOOP-9162. Add utility to check native library availability.
    (Binglin Chang via suresh)

    HADOOP-9173. Add security token protobuf definition to common and
    use it in hdfs. (suresh)

    HADOOP-9119. Add test to FileSystemContractBaseTest to verify integrity
    of overwritten files. (Steve Loughran via suresh)

    HADOOP-9192. Move token related request/response messages to common.
    (suresh)

    HADOOP-8712. Change default hadoop.security.group.mapping to
    JniBasedUnixGroupsNetgroupMappingWithFallback (Robert Parker via todd)

    HADOOP-9106. Allow configuration of IPC connect timeout.
    (Rober Parker via suresh)

    HADOOP-9216. CompressionCodecFactory#getCodecClasses should trim the
    result of parsing by Configuration. (Tsuyoshi Ozawa via todd)

    HADOOP-9231. Parametrize staging URL for the uniformity of
    distributionManagement. (Konstantin Boudnik via suresh)

    HADOOP-9276. Allow BoundedByteArrayOutputStream to be resettable.
    (Arun Murthy via hitesh)

    HADOOP-7688. Add servlet handler check in HttpServer.start().
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7886. Add toString to FileStatus. (SreeHari via jghoman)

  OPTIMIZATIONS

    HADOOP-8866. SampleQuantiles#query is O(N^2) instead of O(N). (Andrew Wang
    via atm)

    HADOOP-8926. hadoop.util.PureJavaCrc32 cache hit-ratio is low for static
    data (Gopal V via bobby)

  BUG FIXES

    HADOOP-9041. FsUrlStreamHandlerFactory could cause an infinite loop in
    FileSystem initialization. (Yanbo Liang and Radim Kolar via llu)

    HADOOP-8418. Update UGI Principal classes name for running with
    IBM JDK on 64 bits Windows.  (Yu Gao via eyang)

    HADOOP-8795. BASH tab completion doesn't look in PATH, assumes path to
    executable is specified. (Sean Mackrory via atm)

    HADOOP-8780. Update DeprecatedProperties apt file. (Ahmed Radwan via
    tomwhite)

    HADOOP-8833. fs -text should make sure to call inputstream.seek(0)
    before using input stream. (tomwhite and harsh)

    HADOOP-8791. Fix rm command documentation to indicte it deletes
    files and not directories. (Jing Zhao via suresh)

    HADOOP-8855. SSL-based image transfer does not work when Kerberos
    is disabled. (todd via eli)

    HADOOP-8616. ViewFS configuration requires a trailing slash. (Sandy Ryza
    via atm)

    HADOOP-8756. Fix SEGV when libsnappy is in java.library.path but
    not LD_LIBRARY_PATH. (Colin Patrick McCabe via eli)

    HADOOP-8881. FileBasedKeyStoresFactory initialization logging should
    be debug not info. (tucu)

    HADOOP-8913. hadoop-metrics2.properties should give units in comment 
    for sampling period. (Sandy Ryza via suresh)

    HADOOP-8878. Uppercase namenode hostname causes hadoop dfs calls with 
    webhdfs filesystem and fsck to fail when security is on.
    (Arpit Gupta via suresh)

    HADOOP-8901. GZip and Snappy support may not work without unversioned
    libraries (Colin Patrick McCabe via todd)

    HADOOP-8883. Anonymous fallback in KerberosAuthenticator is broken.
    (rkanter via tucu)

    HADOOP-8900. BuiltInGzipDecompressor throws IOException - stored gzip size
    doesn't match decompressed size. (Andy Isaacson via suresh)

    HADOOP-8948. TestFileUtil.testGetDU fails on Windows due to incorrect
    assumption of line separator. (Chris Nauroth via suresh)

    HADOOP-8951. RunJar to fail with user-comprehensible error 
    message if jar missing. (stevel via suresh)

    HADOOP-8713. TestRPCCompatibility fails intermittently with JDK7
    (Trevor Robinson via tgraves)

    HADOOP-9012. IPC Client sends wrong connection context (daryn via bobby)

    HADOOP-7115. Add a cache for getpwuid_r and getpwgid_r calls (tucu)

    HADOOP-6607. Add different variants of non caching HTTP headers. (tucu)

    HADOOP-9049. DelegationTokenRenewer needs to be Singleton and FileSystems
    should register/deregister to/from. (Karthik Kambatla via tomwhite)

    HADOOP-9064. Augment DelegationTokenRenewer API to cancel the tokens on 
    calls to removeRenewAction. (kkambatl via tucu)

    HADOOP-9103. UTF8 class does not properly decode Unicode characters
    outside the basic multilingual plane. (todd)

    HADOOP-9070. Kerberos SASL server cannot find kerberos key. (daryn via atm)

    HADOOP-6762. Exception while doing RPC I/O closes channel
    (Sam Rash and todd via todd)

    HADOOP-9126. FormatZK and ZKFC startup can fail due to zkclient connection
    establishment delay. (Rakesh R and todd via todd)

    HADOOP-9113. o.a.h.fs.TestDelegationTokenRenewer is failing intermittently.
    (Karthik Kambatla via eli)

    HADOOP-9135. JniBasedUnixGroupsMappingWithFallback should log at debug
    rather than info during fallback. (Colin Patrick McCabe via todd)

    HADOOP-9152. HDFS can report negative DFS Used on clusters with very small
    amounts of data. (Brock Noland via atm)

    HADOOP-9153. Support createNonRecursive in ViewFileSystem.
    (Sandy Ryza via tomwhite)

    HADOOP-9181. Set daemon flag for HttpServer's QueuedThreadPool.
    (Liang Xie via suresh)

    HADOOP-9155. FsPermission should have different default value, 777 for
    directory and 666 for file. (Binglin Chang via atm)

    HADOOP-9183. Potential deadlock in ActiveStandbyElector. (tomwhite)

    HADOOP-9203. RPCCallBenchmark should find a random available port.
    (Andrew Purtell via suresh)

    HADOOP-9178. src/main/conf is missing hadoop-policy.xml.
    (Sandy Ryza via eli)

    HADOOP-8816. HTTP Error 413 full HEAD if using kerberos authentication. 
    (moritzmoeller via tucu)
    
    HADOOP-9212. Potential deadlock in FileSystem.Cache/IPC/UGI. (tomwhite)

    HADOOP-8589 ViewFs tests fail when tests and home dirs are nested.
    (sanjay Radia)

    HADOOP-9193. hadoop script can inadvertently expand wildcard arguments
    when delegating to hdfs script. (Andy Isaacson via todd)

    HADOOP-9215. when using cmake-2.6, libhadoop.so doesn't get created
    (only libhadoop.so.1.0.0) (Colin Patrick McCabe via todd)

    HADOOP-8857. hadoop.http.authentication.signature.secret.file docs 
    should not state that secret is randomly generated. (tucu)

    HADOOP-9190. packaging docs is broken. (Andy Isaacson via tgraves)

    HADOOP-9221. Convert remaining xdocs to APT. (Andy Isaacson via atm)

    HADOOP-8981. TestMetricsSystemImpl fails on Windows. (Xuan Gong via suresh)
    
    HADOOP-9124. SortedMapWritable violates contract of Map interface for
    equals() and hashCode(). (Surenkumar Nihalani via tomwhite)

    HADOOP-9278. Fix the file handle leak in HarMetaData.parseMetaData() in
    HarFileSystem. (Chris Nauroth via szetszwo)

    HADOOP-9252. In StringUtils, humanReadableInt(..) has a race condition and
    the synchronization of limitDecimalTo2(double) can be avoided.  (szetszwo)

    HADOOP-9260. Hadoop version may be not correct when starting name node or
    data node. (Chris Nauroth via jlowe)

    HADOOP-9289. FsShell rm -f fails for non-matching globs. (Daryn Sharp via
    suresh)

Release 2.0.2-alpha - 2012-09-07 

  INCOMPATIBLE CHANGES

    HADOOP-8388. Remove unused BlockLocation serialization.
    (Colin Patrick McCabe via eli)

    HADOOP-8689. Make trash a server side configuration option. (eli)

    HADOOP-8710. Remove ability for users to easily run the trash emptire. (eli)
    
    HADOOP-8794. Rename YARN_HOME to HADOOP_YARN_HOME. (vinodkv via acmurthy)

  NEW FEATURES
 
    HDFS-3042. Automatic failover support for NameNode HA (todd)
    (see dedicated section below for breakdown of subtasks)

    HADOOP-8135. Add ByteBufferReadable interface to FSDataInputStream. (Henry
    Robinson via atm)

    HADOOP-8458. Add management hook to AuthenticationHandler to enable 
    delegation token operations support (tucu)

    HADOOP-8465. hadoop-auth should support ephemeral authentication (tucu)

    HADOOP-8644. AuthenticatedURL should be able to use SSLFactory. (tucu)

    HADOOP-8581. add support for HTTPS to the web UIs. (tucu)

    HADOOP-7754. Expose file descriptors from Hadoop-wrapped local 
    FileSystems (todd and ahmed via tucu)

    HADOOP-8240. Add a new API to allow users to specify a checksum type
    on FileSystem.create(..).  (Kihwal Lee via szetszwo)

  IMPROVEMENTS

    HADOOP-8340. SNAPSHOT build versions should compare as less than their eventual
    final release. (todd)

    HADOOP-8361. Avoid out-of-memory problems when deserializing strings.
    (Colin Patrick McCabe via eli)

    HADOOP-8224. Don't hardcode hdfs.audit.logger in the scripts.
    (Tomohiko Kinebuchi via eli)

    HADOOP-8398. Cleanup BlockLocation. (eli)

    HADOOP-8422. Deprecate FileSystem#getDefault* and getServerDefault
    methods that don't take a Path argument. (eli)

    HADOOP-8323. Add javadoc and tests for Text.clear() behavior (harsh)

    HADOOP-8358. Config-related WARN for dfs.web.ugi can be avoided. (harsh)

    HADOOP-8450. Remove src/test/system. (eli)

    HADOOP-8244. Improve comments on ByteBufferReadable.read. (Henry Robinson
    via atm)

    HADOOP-8368. Use CMake rather than autotools to build native code (ccccabe via tucu)

    HADOOP-8524. Allow users to get source of a Configuration
    parameter (harsh)

    HADOOP-8449. hadoop fs -text fails with compressed sequence files
    with the codec file extension (harsh)

    HADOOP-6802. Remove FS_CLIENT_BUFFER_DIR_KEY = "fs.client.buffer.dir"
    from CommonConfigurationKeys.java (not used, deprecated)
    (Sho Shimauchi via harsh)

    HADOOP-3450. Add tests to Local Directory Allocator for
    asserting their URI-returning capability (Sho Shimauchi via harsh)

    HADOOP-8463. hadoop.security.auth_to_local needs a key definition and doc.
    (Madhukara Phatak via eli)

    HADOOP-8533. Remove parallel call ununsed capability in RPC.
    (Brandon Li via suresh)

    HADOOP-8423. MapFile.Reader.get() crashes jvm or throws
    EOFException on Snappy or LZO block-compressed data
    (todd via harsh)

    HADOOP-8541. Better high-percentile latency metrics. (Andrew Wang via atm)

    HADOOP-8362. Improve exception message when Configuration.set() is
    called with a null key or value. (Madhukara Phatak
    and Suresh Srinivas via harsh)

    HADOOP-7818. DiskChecker#checkDir should fail if the directory is
    not executable. (Madhukara Phatak via harsh)

    HADOOP-8531. SequenceFile Writer can throw out a better error if a
    serializer or deserializer isn't available
    (Madhukara Phatak via harsh)

    HADOOP-8609. IPC server logs a useless message when shutting down socket.
    (Jon Zuanich via atm)

    HADOOP-8620. Add -Drequire.fuse and -Drequire.snappy. (Colin
    Patrick McCabe via eli)

    HADOOP-8687. Upgrade log4j to 1.2.17. (eli)

    HADOOP-8278. Make sure components declare correct set of dependencies.
    (tomwhite)

    HADOOP-8700.  Use enum to define the checksum constants in DataChecksum.
    (szetszwo)

    HADOOP-8686. Fix warnings in native code. (Colin Patrick McCabe via eli)

    HADOOP-8239. Add subclasses of MD5MD5CRC32FileChecksum to support file
    checksum with CRC32C.  (Kihwal Lee via szetszwo)

    HADOOP-8619. WritableComparator must implement no-arg constructor.
    (Chris Douglas via Suresh)

    HADOOP-8075. Lower native-hadoop library log from info to debug.
    (Hızır Sefa İrken via eli)

    HADOOP-8748. Refactor DFSClient retry utility methods to a new class
    in org.apache.hadoop.io.retry.  (Arun C Murthy via szetszwo)

    HADOOP-8754. Deprecate all the RPC.getServer() variants.  (Brandon Li
    via szetszwo)

    HADOOP-8801. ExitUtil#terminate should capture the exception stack trace. (eli)

    HADOOP-8819. Incorrectly & is used instead of && in some file system 
    implementations. (Brandon Li via suresh)

    HADOOP-7808. Port HADOOP-7510 - Add configurable option to use original 
    hostname in token instead of IP to allow server IP change. 
    (Daryn Sharp via suresh)

    HADOOP-8367 Improve documentation of declaringClassProtocolName in 
    rpc headers. (Sanjay Radia)

    HADOOP-8624. ProtobufRpcEngine should log all RPCs if TRACE logging is
    enabled (todd)

  BUG FIXES

    HADOOP-8372. NetUtils.normalizeHostName() incorrectly handles hostname
    starting with a numeric character. (Junping Du via suresh)

    HADOOP-8393. hadoop-config.sh missing variable exports, causes Yarn jobs 
    to fail with ClassNotFoundException MRAppMaster. (phunt via tucu)

    HADOOP-8316. Audit logging should be disabled by default. (eli)

    HADOOP-8400. All commands warn "Kerberos krb5 configuration not found" 
    when security is not enabled. (tucu)

    HADOOP-8406. CompressionCodecFactory.CODEC_PROVIDERS iteration is
    thread-unsafe (todd)

    HADOOP-8287. etc/hadoop is missing hadoop-env.sh (eli)

    HADOOP-8408. MR doesn't work with a non-default ViewFS mount table
    and security enabled. (atm via eli)

    HADOOP-8329. Build fails with Java 7. (eli)

    HADOOP-8268. A few pom.xml across Hadoop project
    may fail XML validation. (Radim Kolar via harsh)

    HADOOP-8444. Fix the tests FSMainOperationsBaseTest.java and
    FileContextMainOperationsBaseTest.java to avoid potential
    test failure (Madhukara Phatak via harsh)

    HADOOP-8452. DN logs backtrace when running under jsvc and /jmx is loaded 
    (Andy Isaacson via bobby)

    HADOOP-8460. Document proper setting of HADOOP_PID_DIR and 
    HADOOP_SECURE_DN_PID_DIR (bobby)

    HADOOP-8466. hadoop-client POM incorrectly excludes avro. (bmahe via tucu)

    HADOOP-8481. update BUILDING.txt to talk about cmake rather than autotools.
    (Colin Patrick McCabe via eli)

    HADOOP-8485. Don't hardcode "Apache Hadoop 0.23" in the docs. (eli)

    HADOOP-8488. test-patch.sh gives +1 even if the native build fails.
    (Colin Patrick McCabe via eli)

    HADOOP-8507. Avoid OOM while deserializing DelegationTokenIdentifer.
    (Colin Patrick McCabe via eli)

    HADOOP-8433. Don't set HADOOP_LOG_DIR in hadoop-env.sh.
    (Brahma Reddy Battula via eli)

    HADOOP-8509. JarFinder duplicate entry: META-INF/MANIFEST.MF exception (tucu)

    HADOOP-8512. AuthenticatedURL should reset the Token when the server returns 
    other than OK on authentication (tucu)

    HADOOP-8168. empty-string owners or groups causes {{MissingFormatWidthException}} 
    in o.a.h.fs.shell.Ls.ProcessPath() (ekoontz via tucu)

    HADOOP-8438. hadoop-validate-setup.sh refers to examples jar file which doesn't exist
    (Devaraj K via umamahesh)

    HADOOP-8538. CMake builds fail on ARM. (Trevor Robinson via eli)

    HADOOP-8547. Package hadoop-pipes examples/bin directory (again).
    (Colin Patrick McCabe via eli)

    HADOOP-8563. don't package hadoop-pipes examples/bin
    (Colin Patrick McCabe via tgraves)

    HADOOP-8566. AvroReflectSerializer.accept(Class) throws a NPE if the class has no 
    package (primitive types and arrays). (tucu)

    HADOOP-8586. Fixup a bunch of SPNEGO misspellings. (eli)

    HADOOP-3886. Error in javadoc of Reporter, Mapper and Progressable
    (Jingguo Yao via harsh)

    HADOOP-8587. HarFileSystem access of harMetaCache isn't threadsafe. (eli)

    HADOOP-8585. Fix initialization circularity between UserGroupInformation
    and HadoopConfiguration. (Colin Patrick McCabe via atm)

    HADOOP-8552. Conflict: Same security.log.file for multiple users. 
    (kkambatl via tucu)

    HADOOP-8537. Fix TFile tests to pass even when native zlib support is not
    compiled. (todd)

    HADOOP-8626. Typo in default setting for
    hadoop.security.group.mapping.ldap.search.filter.user. (Jonathan Natkins
    via atm)

    HADOOP-8480. The native build should honor -DskipTests.
    (Colin Patrick McCabe via eli)

    HADOOP-8659. Native libraries must build with soft-float ABI for Oracle JVM
    on ARM. (Trevor Robinson via todd)

    HADOOP-8654. TextInputFormat delimiter bug (Gelesh and Jason Lowe via
    bobby)

    HADOOP-8614. IOUtils#skipFully hangs forever on EOF. 
    (Colin Patrick McCabe via eli)

    HADOOP-8720. TestLocalFileSystem should use test root subdirectory.
    (Vlad Rozov via eli)

    HADOOP-8721. ZKFC should not retry 45 times when attempting a graceful
    fence during a failover. (Vinayakumar B via atm)

    HADOOP-8632. Configuration leaking class-loaders (Costin Leau via bobby)

    HADOOP-4572. Can not access user logs - Jetty is not configured by default 
    to serve aliases/symlinks (ahmed via tucu)

    HADOOP-8660. TestPseudoAuthenticator failing with NPE. (tucu)

    HADOOP-8699. some common testcases create core-site.xml in test-classes
    making other testcases to fail. (tucu)

    HADOOP-8031. Configuration class fails to find embedded .jar resources; 
    should use URL.openStream() (genman via tucu)

    HADOOP-8737. cmake: always use JAVA_HOME to find libjvm.so, jni.h, jni_md.h.
    (Colin Patrick McCabe via eli)

    HADOOP-8747. Syntax error on cmake version 2.6 patch 2 in JNIFlags.cmake. (cmccabe via tucu)

    HADOOP-8722. Update BUILDING.txt with latest snappy info.
    (Colin Patrick McCabe via eli)

    HADOOP-8764. CMake: HADOOP-8737 broke ARM build. (Trevor Robinson via eli)

    HADOOP-8770. NN should not RPC to self to find trash defaults. (eli)

    HADOOP-8648. libhadoop: native CRC32 validation crashes when
    io.bytes.per.checksum=1. (Colin Patrick McCabe via eli)

    HADOOP-8766. FileContextMainOperationsBaseTest should randomize the root
    dir. (Colin Patrick McCabe via atm)

    HADOOP-8749. HADOOP-8031 changed the way in which relative xincludes are handled in 
    Configuration. (ahmed via tucu)

    HADOOP-8431. Running distcp wo args throws IllegalArgumentException.
    (Sandy Ryza via eli)

    HADOOP-8775. MR2 distcp permits non-positive value to -bandwidth option
    which causes job never to complete. (Sandy Ryza via atm)

    HADOOP-8781. hadoop-config.sh should add JAVA_LIBRARY_PATH to LD_LIBRARY_PATH. (tucu)

  BREAKDOWN OF HDFS-3042 SUBTASKS

    HADOOP-8220. ZKFailoverController doesn't handle failure to become active
    correctly (todd)

    HADOOP-8228. Auto HA: Refactor tests and add stress tests. (todd)
    
    HADOOP-8215. Security support for ZK Failover controller (todd)
    
    HADOOP-8245. Fix flakiness in TestZKFailoverController (todd)
    
    HADOOP-8257. TestZKFailoverControllerStress occasionally fails with Mockito
    error (todd)
    
    HADOOP-8260. Replace ClientBaseWithFixes with our own modified copy of the
    class (todd)
    
    HADOOP-8246. Auto-HA: automatically scope znode by nameservice ID (todd)
    
    HADOOP-8247. Add a config to enable auto-HA, which disables manual
    FailoverController (todd)
    
    HADOOP-8306. ZKFC: improve error message when ZK is not running. (todd)
    
    HADOOP-8279. Allow manual failover to be invoked when auto-failover is
    enabled. (todd)
    
    HADOOP-8276. Auto-HA: add config for java options to pass to zkfc daemon
    (todd via eli)
    
    HADOOP-8405. ZKFC tests leak ZK instances. (todd)

Release 2.0.0-alpha - 05-23-2012

  INCOMPATIBLE CHANGES

    HADOOP-7920. Remove Avro Rpc. (suresh)

  NEW FEATURES

    HADOOP-7773. Add support for protocol buffer based RPC engine.
    (suresh)

    HADOOP-7875. Add helper class to unwrap protobuf ServiceException.
    (suresh)

    HADOOP-7454. Common side of High Availability Framework (HDFS-1623)
    Contributed by Todd Lipcon, Aaron T. Myers, Eli Collins, Uma Maheswara Rao G,
    Bikas Saha, Suresh Srinivas, Jitendra Nath Pandey, Hari Mankude, Brandon Li,
    Sanjay Radia, Mingjie Lai, and Gregory Chanan

    HADOOP-8121. Active Directory Group Mapping Service. (Jonathan Natkins via
    atm)

    HADOOP-7030. Add TableMapping topology implementation to read host to rack
    mapping from a file. (Patrick Angeles and tomwhite via tomwhite)

    HADOOP-8206. Common portion of a ZK-based failover controller (todd)

    HADOOP-8210. Common side of HDFS-3148: The client should be able
    to use multiple local interfaces for data transfer. (eli)

    HADOOP-8343. Allow configuration of authorization for JmxJsonServlet and 
    MetricsServlet (tucu)

  IMPROVEMENTS

    HADOOP-7524. Change RPC to allow multiple protocols including multuple
    versions of the same protocol (sanjay Radia)

    HADOOP-7607. Simplify the RPC proxy cleanup process. (atm)

    HADOOP-7687. Make getProtocolSignature public  (sanjay)

    HADOOP-7693. Enhance AvroRpcEngine to support the new #addProtocol
    interface introduced in HADOOP-7524.  (cutting)

    HADOOP-7716. RPC protocol registration on SS does not log the protocol name
    (only the class which may be different) (sanjay)

    HADOOP-7776. Make the Ipc-Header in a RPC-Payload an explicit header.
    (sanjay)

    HADOOP-7862. Move the support for multiple protocols to lower layer so
    that Writable, PB and Avro can all use it (Sanjay)

    HADOOP-7876. Provided access to encoded key in DelegationKey for
    use in protobuf based RPCs. (suresh)

    HADOOP-7899. Generate proto java files as part of the build. (tucu)

    HADOOP-7957. Classes deriving GetGroupsBase should be able to override 
    proxy creation. (jitendra)

    HADOOP-7965. Support for protocol version and signature in PB. (jitendra)

    HADOOP-8070. Add a standalone benchmark for RPC call performance. (todd)

    HADOOP-8084. Updates ProtoBufRpc engine to not do an unnecessary copy 
    for RPC request/response. (ddas)

    HADOOP-8085. Add RPC metrics to ProtobufRpcEngine. (Hari Mankude via
    suresh)

    HADOOP-8098. KerberosAuthenticatorHandler should use _HOST replacement to 
    resolve principal name (tucu)

    HADOOP-8118.  In metrics2.util.MBeans, change log level to trace for the
    stack trace of InstanceAlreadyExistsException.  (szetszwo)

    HADOOP-8125. make hadoop-client set of curated jars available in a
    distribution tarball (rvs via tucu)

    HADOOP-7717. Move handling of concurrent client fail-overs to
    RetryInvocationHandler (atm)

    HADOOP-7728. Enable task memory management to be configurable in hadoop
    config setup script. (ramya)

    HADOOP-7358. Improve log levels when exceptions caught in RPC handler
    (Todd Lipcon via shv)

    HADOOP-7557 Make IPC header be extensible (sanjay radia)

    HADOOP-7806. Support binding to sub-interfaces (eli)

    HADOOP-6941. Adds support for building Hadoop with IBM's JDK 
    (Stephen Watt, Eli and ddas)

    HADOOP-8183. Stop using "mapred.used.genericoptions.parser" (harsh)

    HADOOP-6924. Adds a directory to the list of directories to search
    for the libjvm.so file. The new directory is found by running a 'find'
    command and the first output is taken. This was done to handle the 
    build of Hadoop with IBM's JDK. (Stephen Watt, Guillermo Cabrera and ddas)

    HADOOP-8200. Remove HADOOP_[JOBTRACKER|TASKTRACKER]_OPTS. (eli)

    HADOOP-8184.  ProtoBuf RPC engine uses the IPC layer reply packet.
    (Sanjay Radia via szetszwo)

    HADOOP-8163. Improve ActiveStandbyElector to provide hooks for
    fencing old active. (todd)

    HADOOP-8193. Refactor FailoverController/HAAdmin code to add an abstract
    class for "target" services. (todd)

    HADOOP-8212. Improve ActiveStandbyElector's behavior when session expires
    (todd)

    HADOOP-8216. Address log4j.properties inconsistencies btw main and
    template dirs. (Patrick Hunt via eli)

    HADOOP-8149. Cap space usage of default log4j rolling policy.
    (Patrick Hunt via eli)

    HADOOP-8211. Update commons-net version to 3.1. (eli)

    HADOOP-8236. haadmin should have configurable timeouts for failover
    commands. (todd)

    HADOOP-8242. AbstractDelegationTokenIdentifier: add getter methods
    for owner and realuser. (Colin Patrick McCabe via eli)

    HADOOP-8007. Use substitution tokens for fencing argument (todd)

    HADOOP-8077. HA: fencing method should be able to be configured on
    a per-NN or per-NS basis (todd)

    HADOOP-8086. KerberosName silently sets defaultRealm to "" if the 
    Kerberos config is not found, it should log a WARN (tucu)

    HADOOP-8280. Move VersionUtil/TestVersionUtil and GenericTestUtils from
    HDFS into Common. (Ahmed Radwan via atm)

    HADOOP-8117. Upgrade test build to Surefire 2.12 (todd)

    HADOOP-8152. Expand public APIs for security library classes. (atm via eli)

    HADOOP-7549. Use JDK ServiceLoader mechanism to find FileSystem implementations. (tucu)

    HADOOP-8185. Update namenode -format documentation and add -nonInteractive
    and -force. (Arpit Gupta via atm)

    HADOOP-8214. make hadoop script recognize a full set of deprecated commands (rvs via tucu)

    HADOOP-8347. Hadoop Common logs misspell 'successful'.
    (Philip Zeyliger via eli)

    HADOOP-8350. Improve NetUtils.getInputStream to return a stream which has
    a tunable timeout. (todd)

    HADOOP-8356. FileSystem service loading mechanism should print the FileSystem 
    impl it is failing to load (tucu)

    HADOOP-8353. hadoop-daemon.sh and yarn-daemon.sh can be misleading on stop.
    (Roman Shaposhnik via atm)

    HADOOP-8113. Correction to BUILDING.txt: HDFS needs ProtocolBuffer, too
    (not just MapReduce). Contributed by Eugene Koontz.

    HADOOP-8285 Use ProtoBuf for RpcPayLoadHeader (sanjay radia)

    HADOOP-8366 Use ProtoBuf for RpcResponseHeader (sanjay radia)

    HADOOP-7729. Send back valid HTTP response if user hits IPC port with
    HTTP GET. (todd)

    HADOOP-7987. Support setting the run-as user in unsecure mode. (jitendra)

    HADOOP-7994. Remove getProtocolVersion and getProtocolSignature from the 
    client side translator and server side implementation. (jitendra)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-8199. Fix issues in start-all.sh and stop-all.sh (Devaraj K via umamahesh)
    
    HADOOP-7635. RetryInvocationHandler should release underlying resources on
    close. (atm)

    HADOOP-7695. RPC.stopProxy can throw unintended exception while logging
    error. (atm)

    HADOOP-7833. Fix findbugs warnings in protobuf generated code.
    (John Lee via suresh)

    HADOOP-7897. ProtobufRpcEngine client side exception mechanism is not
    consistent with WritableRpcEngine. (suresh)

    HADOOP-7913. Fix bug in ProtoBufRpcEngine.  (sanjay)

    HADOOP-7892. IPC logs too verbose after "RpcKind" introduction. (todd)

    HADOOP-7968. Errant println left in RPC.getHighestSupportedProtocol. (Sho
    Shimauchi via harsh)

    HADOOP-7931. o.a.h.ipc.WritableRpcEngine should have a way to force
    initialization. (atm)

    HADOOP-8104. Inconsistent Jackson versions (tucu)

    HADOOP-8119. Fix javac warnings in TestAuthenticationFilter in hadoop-auth.
    (szetszwo)

    HADOOP-7888. TestFailoverProxy fails intermittently on trunk. (Jason Lowe
    via atm)

    HADOOP-8154. DNS#getIPs shouldn't silently return the local host
    IP for bogus interface names. (eli)

    HADOOP-8169.  javadoc generation fails with java.lang.OutOfMemoryError:
    Java heap space (tgraves via bobby)

    HADOOP-8167. Configuration deprecation logic breaks backwards compatibility (tucu)

    HADOOP-8189. LdapGroupsMapping shouldn't throw away IOException. (Jonathan Natkins via atm)

    HADOOP-8191. SshFenceByTcpPort uses netcat incorrectly (todd)

    HADOOP-8157. Fix race condition in Configuration that could cause spurious
    ClassNotFoundExceptions after a GC. (todd)

    HADOOP-8197. Configuration logs WARNs on every use of a deprecated key (tucu)

    HADOOP-8159. NetworkTopology: getLeaf should check for invalid topologies.
    (Colin Patrick McCabe via eli)

    HADOOP-8204. TestHealthMonitor fails occasionally (todd)

    HADOOP-8202. RPC stopProxy() does not close the proxy correctly.
    (Hari Mankude via suresh)

    HADOOP-8218. RPC.closeProxy shouldn't throw error when closing a mock
    (todd)

    HADOOP-8238. NetUtils#getHostNameOfIP blows up if given ip:port
    string w/o port. (eli)

    HADOOP-8243. Security support broken in CLI (manual) failover controller
    (todd)

    HADOOP-8251. Fix SecurityUtil.fetchServiceTicket after HADOOP-6941 (todd)

    HADOOP-8249. invalid hadoop-auth cookies should trigger authentication 
    if info is avail before returning HTTP 401 (tucu)

    HADOOP-8261. Har file system doesn't deal with FS URIs with a host but no
    port. (atm)

    HADOOP-8263. Stringification of IPC calls not useful (todd)

    HADOOP-8264. Remove irritating double double quotes in front of hostname
    (Bernd Fondermann via bobby)

    HADOOP-8270. hadoop-daemon.sh stop action should return 0 for an
    already stopped service. (Roman Shaposhnik via eli)

    HADOOP-8144. pseudoSortByDistance in NetworkTopology doesn't work
    properly if no local node and first node is local rack node.
    (Junping Du)

    HADOOP-8282. start-all.sh refers incorrectly start-dfs.sh
    existence for starting start-yarn.sh. (Devaraj K via eli)

    HADOOP-7350. Use ServiceLoader to discover compression codec classes.
    (tomwhite)

    HADOOP-8284. clover integration broken, also mapreduce poms are pulling
    in clover as a dependency. (phunt via tucu)

    HADOOP-8309. Pseudo & Kerberos AuthenticationHandler should use 
    getType() to create token (tucu)

    HADOOP-8314. HttpServer#hasAdminAccess should return false if 
    authorization is enabled but user is not authenticated. (tucu)

    HADOOP-8296. hadoop/yarn daemonlog usage wrong (Devaraj K via tgraves)

    HADOOP-8310. FileContext#checkPath should handle URIs with no port. (atm)

    HADOOP-8321. TestUrlStreamHandler fails. (tucu)

    HADOOP-8325. Add a ShutdownHookManager to be used by different
    components instead of the JVM shutdownhook (tucu)

    HADOOP-8275. Range check DelegationKey length.
    (Colin Patrick McCabe via eli)

    HADOOP-8342. HDFS command fails with exception following merge of 
    HADOOP-8325 (tucu)

    HADOOP-8346. Makes oid changes to make SPNEGO work. Was broken due
    to fixes introduced by the IBM JDK compatibility patch. (ddas)

    HADOOP-8355. SPNEGO filter throws/logs exception when authentication fails (tucu)

    HADOOP-8349. ViewFS doesn't work when the root of a file system is mounted. (atm)

    HADOOP-8328. Duplicate FileSystem Statistics object for 'file' scheme.
    (tomwhite)

    HADOOP-8359. Fix javadoc warnings in Configuration.  (Anupam Seth via
    szetszwo)

    HADOOP-7988. Upper case in hostname part of the principals doesn't work with
    kerberos. (jitendra)

  BREAKDOWN OF HADOOP-7454 SUBTASKS

    HADOOP-7455. HA: Introduce HA Service Protocol Interface. (suresh)
    
    HADOOP-7774. HA: Administrative CLI to control HA daemons. (todd)
    
    HADOOP-7896. HA: if both NNs are in Standby mode, client needs to try failing
    back and forth several times with sleeps. (atm)
    
    HADOOP-7922. Improve some logging for client IPC failovers and
    StandbyExceptions (todd)
    
    HADOOP-7921. StandbyException should extend IOException (todd)
    
    HADOOP-7928. HA: Client failover policy is incorrectly trying to fail over all
    IOExceptions (atm)
    
    HADOOP-7925. Add interface and update CLI to query current state to
    HAServiceProtocol (eli via todd)
    
    HADOOP-7932. Make client connection retries on socket time outs configurable.
    (Uma Maheswara Rao G via todd)
    
    HADOOP-7924. FailoverController for client-based configuration (eli)
    
    HADOOP-7961. Move HA fencing to common. (eli)
    
    HADOOP-7970. HAServiceProtocol methods must throw IOException.  (Hari Mankude
    via suresh).
    
    HADOOP-7992. Add ZKClient library to facilitate leader election.  (Bikas Saha
    via suresh).
    
    HADOOP-7983. HA: failover should be able to pass args to fencers. (eli)
    
    HADOOP-7938. HA: the FailoverController should optionally fence the active
    during failover. (eli)
    
    HADOOP-7991. HA: the FailoverController should check the standby is ready
    before failing over. (eli)
    
    HADOOP-8038. Add 'ipc.client.connect.max.retries.on.timeouts' entry in
    core-default.xml file. (Uma Maheswara Rao G via atm)
    
    HADOOP-8041. Log a warning when a failover is first attempted (todd)
    
    HADOOP-8068. void methods can swallow exceptions when going through failover
    path (todd)
    
    HADOOP-8116. RetriableCommand is using RetryPolicy incorrectly after
    HADOOP-7896. (atm)

    HADOOP-8317. Update maven-assembly-plugin to 2.3 - fix build on FreeBSD
    (Radim Kolar via bobby)

    HADOOP-8172. Configuration no longer sets all keys in a deprecated key 
    list. (Anupam Seth via bobby)

    HADOOP-7868. Hadoop native fails to compile when default linker
    option is -Wl,--as-needed. (Trevor Robinson via eli)

    HADOOP-8655. Fix TextInputFormat for large deliminators. (Gelesh via
    bobby) 

    HADOOP-7900. LocalDirAllocator confChanged() accesses conf.get() twice
    (Ravi Gummadi via Uma Maheswara Rao G)

    HADOOP-8146.  FsShell commands cannot be interrupted
    (Daryn Sharp via Uma Maheswara Rao G)

    HADOOP-8018.  Hudson auto test for HDFS has started throwing javadoc
    (Jon Eagles via bobby)

    HADOOP-8001  ChecksumFileSystem's rename doesn't correctly handle checksum
    files. (Daryn Sharp via bobby)

    HADOOP-8006  TestFSInputChecker is failing in trunk.
    (Daryn Sharp via bobby)

    HADOOP-7998. CheckFileSystem does not correctly honor setVerifyChecksum
    (Daryn Sharp via bobby)

    HADOOP-7606. Upgrade Jackson to version 1.7.1 to match the version required
    by Jersey (Alejandro Abdelnur via atm)

Release 0.23.11 - UNRELEASED

  INCOMPATIBLE CHANGES

  NEW FEATURES
    
  IMPROVEMENTS
    
  OPTIMIZATIONS

  BUG FIXES

    HADOOP-10129. Distcp may succeed when it fails (daryn)

    HADOOP-10332. HttpServer's jetty audit log always logs 200 OK (jeagles)

    HADOOP-8826. Docs still refer to 0.20.205 as stable line (Mit Desai via
    jeagles)

Release 0.23.10 - UNRELEASED

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-9686. Easy access to final parameters in Configuration (Jason Lowe
    via jeagles)

    HADOOP-8704. add request logging to jetty/httpserver (jeagles)

  OPTIMIZATIONS

    HADOOP-9956. RPC listener inefficiently assigns connections to readers (daryn)

    HADOOP-9955. RPC idle connection closing is extremely inefficient (daryn)

  BUG FIXES

Release 0.23.9 - 2013-07-08

  INCOMPATIBLE CHANGES

  NEW FEATURES
    
  IMPROVEMENTS
    
  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9581. hadoop --config non-existent directory should result in error
    (Ashwin Shankar via jlowe)

    HADOOP-9582. Non-existent file to "hadoop fs -conf" doesn't throw error
    (Ashwin Shankar via jlowe)

Release 0.23.8 - 2013-06-05

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9222. Cover package with org.apache.hadoop.io.lz4 unit tests (Vadim 
    Bondarev via jlowe)

    HADOOP-9233. Cover package org.apache.hadoop.io.compress.zlib with unit
    tests (Vadim Bondarev via jlowe)

    HADOOP-9469. mapreduce/yarn source jars not included in dist tarball
    (Robert Parker via tgraves)

    HADOOP-9504. MetricsDynamicMBeanBase has concurrency issues in
    createMBeanInfo (Liang Xie via jlowe)

    HADOOP-9614. smart-test-patch.sh hangs for new version of patch (2.7.1)
    (Ravi Prakash via jeagles)

Release 0.23.7 - 2013-04-18

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-8849. FileUtil#fullyDelete should grant the target directories +rwx
    permissions (Ivan A. Veselovsky via bobby)

    HADOOP-9067. provide test for LocalFileSystem.reportChecksumFailure
    (Ivan A. Veselovsky via bobby)

    HADOOP-9336. Allow UGI of current connection to be queried. (Daryn Sharp
    via kihwal)

    HADOOP-9352. Expose UGI.setLoginUser for tests (daryn)

    HADOOP-9209. Add shell command to dump file checksums (Todd Lipcon via
    jeagles)

    HADOOP-9374. Add tokens from -tokenCacheFile into UGI (daryn)

    HADOOP-8711. IPC Server supports adding exceptions for which
    the message is printed and the stack trace is not printed to avoid chatter.
    (Brandon Li via Suresh)

  OPTIMIZATIONS

    HADOOP-8462. Native-code implementation of bzip2 codec. (Govind Kamat via
    jlowe)

  BUG FIXES

    HADOOP-9302. HDFS docs not linked from top level (Andy Isaacson via
    tgraves)

    HADOOP-9303. command manual dfsadmin missing entry for restoreFailedStorage
    option (Andy Isaacson via tgraves)

    HADOOP-9339. IPC.Server incorrectly sets UGI auth type (Daryn Sharp via 
    kihwal)

Release 0.23.6 - 2013-02-06

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS
    HADOOP-9217. Print thread dumps when hadoop-common tests fail.
    (Andrey Klochkov via suresh)

    HADOOP-9242. Duplicate surefire plugin config in hadoop-common.
    (Andrey Klochkov via suresh)

    HADOOP-9247. Parametrize Clover "generateXxx" properties to make them
    re-definable via -D in mvn calls. (Ivan A. Veselovsky via suresh)


  OPTIMIZATIONS

  BUG FIXES

    HADOOP-9072. Hadoop-Common-0.23-Build Fails to build in Jenkins 
    (Robert Parker via tgraves)

    HADOOP-8992. Enhance unit-test coverage of class HarFileSystem (Ivan A.
    Veselovsky via bobby)

    HADOOP-9038. unit-tests for AllocatorPerContext.PathIterator (Ivan A.
    Veselovsky via bobby)

    HADOOP-9105. FsShell -moveFromLocal erroneously fails (daryn via bobby)

    HADOOP-9097. Maven RAT plugin is not checking all source files (tgraves)

    HADOOP-9255. relnotes.py missing last jira (tgraves)

Release 0.23.5 - 2012-11-28


  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-8932. JNI-based user-group mapping modules can be too chatty on 
    lookup failures. (Kihwal Lee via suresh)

    HADOOP-8930. Cumulative code coverage calculation (Andrey Klochkov via
    bobby)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-8906. paths with multiple globs are unreliable. (Daryn Sharp via
    jlowe)

    HADOOP-8811. Compile hadoop native library in FreeBSD (Radim Kolar via
    bobby)

    HADOOP-8962. RawLocalFileSystem.listStatus fails when a child filename
    contains a colon (jlowe via bobby)

    HADOOP-8986. Server$Call object is never released after it is sent (bobby)

    HADOOP-9022. Hadoop distcp tool fails to copy file if -m 0 specified
    (Jonathan Eagles vai bobby)

    HADOOP-9025. org.apache.hadoop.tools.TestCopyListing failing (Jonathan
    Eagles via jlowe)

Release 0.23.4

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-8822. relnotes.py was deleted post mavenization (bobby)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-8843. Old trash directories are never deleted on upgrade
    from 1.x (jlowe)

Release 0.23.3

  INCOMPATIBLE CHANGES

    HADOOP-7967. Need generalized multi-token filesystem support (daryn)

  NEW FEATURES

  IMPROVEMENTS

    HADOOP-8108. Move method getHostPortString() from NameNode to NetUtils.
    (Brandon Li via jitendra)

    HADOOP-8288. Remove references of mapred.child.ulimit etc. since they are
    not being used any more (Ravi Prakash via bobby)

    HADOOP-8535. Cut hadoop build times in half (Job Eagles via bobby)

    HADOOP-8525. Provide Improved Traceability for Configuration (bobby)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-8088. User-group mapping cache incorrectly does negative caching on
    transient failures (Khiwal Lee via bobby)

    HADOOP-8179. risk of NPE in CopyCommands processArguments() (Daryn Sharp
    via bobby)

    HADOOP-6963. In FileUtil.getDU(..), neither include the size of directories
    nor follow symbolic links.  (Ravi Prakash via szetszwo)

    HADOOP-8180. Remove hsqldb since its not needed from pom.xml (Ravi Prakash
    via tgraves)

    HADOOP-8014. ViewFileSystem does not correctly implement getDefaultBlockSize,
    getDefaultReplication, getContentSummary (John George via bobby)

    HADOOP-7510. Tokens should use original hostname provided instead of ip
    (Daryn Sharp via bobby)

    HADOOP-8283. Allow tests to control token service value (Daryn Sharp via
    bobby)

    HADOOP-8286. Simplify getting a socket address from conf (Daryn Sharp via
    bobby)

    HADOOP-8227. Allow RPC to limit ephemeral port range. (bobby)

    HADOOP-8305. distcp over viewfs is broken (John George via bobby)

    HADOOP-8334. HttpServer sometimes returns incorrect port (Daryn Sharp via
    bobby)

    HADOOP-8330. Update TestSequenceFile.testCreateUsesFsArg() for HADOOP-8305.
    (John George via szetszwo)

    HADOOP-8335. Improve Configuration's address handling (Daryn Sharp via
    bobby)

    HADOOP-8327. distcpv2 and distcpv1 jars should not coexist (Dave Thompson
    via bobby)

    HADOOP-8341. Fix or filter findbugs issues in hadoop-tools (bobby)

    HADOOP-8373. Port RPC.getServerAddress to 0.23 (Daryn Sharp via bobby)

    HADOOP-8495. Update Netty to avoid leaking file descriptors during shuffle
    (Jason Lowe via tgraves)

    HADOOP-8129. ViewFileSystemTestSetup setupForViewFileSystem is erring
    (Ahmed Radwan and Ravi Prakash via bobby)

    HADOOP-8573. Configuration tries to read from an inputstream resource 
    multiple times (Robert Evans via tgraves)

    HADOOP-8599. Non empty response from FileSystem.getFileBlockLocations when
    asking for data beyond the end of file. (Andrey Klochkov via todd)

    HADOOP-8606. FileSystem.get may return the wrong filesystem (Daryn Sharp
    via bobby)

    HADOOP-8551. fs -mkdir creates parent directories without the -p option
    (John George via bobby)

    HADOOP-8613. AbstractDelegationTokenIdentifier#getUser() should set token
    auth type. (daryn)

    HADOOP-8627. FS deleteOnExit may delete the wrong path (daryn via bobby)

    HADOOP-8634. Ensure FileSystem#close doesn't squawk for deleteOnExit paths 
    (daryn via bobby)

    HADOOP-8550. hadoop fs -touchz automatically created parent directories
    (John George via bobby)

    HADOOP-8635. Cannot cancel paths registered deleteOnExit (daryn via bobby)

    HADOOP-8637. FilterFileSystem#setWriteChecksum is broken (daryn via bobby)

    HADOOP-8370. Native build failure: javah: class file for 
    org.apache.hadoop.classification.InterfaceAudience not found  (Trevor
    Robinson via tgraves)

    HADOOP-8633. Interrupted FsShell copies may leave tmp files (Daryn Sharp
    via tgraves)

    HADOOP-8703. distcpV2: turn CRC checking off for 0 byte size (Dave
    Thompson via bobby)

    HADOOP-8390. TestFileSystemCanonicalization fails with JDK7  (Trevor
    Robinson via tgraves)

    HADOOP-8692. TestLocalDirAllocator fails intermittently with JDK7 
    (Trevor Robinson via tgraves)

    HADOOP-8693. TestSecurityUtil fails intermittently with JDK7 (Trevor
    Robinson via tgraves)

    HADOOP-8697. TestWritableName fails intermittently with JDK7 (Trevor
    Robinson via tgraves)

    HADOOP-8695. TestPathData fails intermittently with JDK7 (Trevor
    Robinson via tgraves)

    HADOOP-8611. Allow fall-back to the shell-based implementation when 
    JNI-based users-group mapping fails (Robert Parker via bobby) 

    HADOOP-8225. DistCp fails when invoked by Oozie (daryn via bobby)

    HADOOP-8709. globStatus changed behavior from 0.20/1.x (Jason Lowe via
    bobby)

    HADOOP-8725. MR is broken when security is off (daryn via bobby)

    HADOOP-8726. The Secrets in Credentials are not available to MR tasks
    (daryn and Benoy Antony via bobby)

    HADOOP-8727. Gracefully deprecate dfs.umaskmode in 2.x onwards (Harsh J
    via bobby)

Release 0.23.2 - UNRELEASED 

  INCOMPATIBLE CHANGES

  NEW FEATURES                                                                    
  
  IMPROVEMENTS

    HADOOP-8048. Allow merging of Credentials (Daryn Sharp via tgraves)
 
    HADOOP-8032. mvn site:stage-deploy should be able to use the scp protocol
    to stage documents (Ravi Prakash via tgraves)

    HADOOP-7923. Automate the updating of version numbers in the doc system.
    (szetszwo)

    HADOOP-8137. Added links to CLI manuals to the site. (tgraves via
    acmurthy)  

  OPTIMIZATIONS
    HADOOP-8071. Avoid an extra packet in client code when nagling is
    disabled. (todd)

    HADOOP-6502. Improve the performance of Configuration.getClassByName when
    the class is not found by caching negative results.
    (sharad, todd via todd)

  BUG FIXES

    HADOOP-7660. Maven generated .classpath doesnot includes 
    "target/generated-test-source/java" as source directory.
    (Laxman via bobby)

    HADOOP-8042  When copying a file out of HDFS, modifying it, and uploading
    it back into HDFS, the put fails due to a CRC mismatch
    (Daryn Sharp via bobby)

    HADOOP-8035 Hadoop Maven site is inefficient and runs phases redundantly
    (abayer via tucu)

    HADOOP-8051 HttpFS documentation it is not wired to the generated site (tucu)

    HADOOP-8055. Hadoop tarball distribution lacks a core-site.xml (harsh)

    HADOOP-8052. Hadoop Metrics2 should emit Float.MAX_VALUE (instead of 
    Double.MAX_VALUE) to avoid making Ganglia's gmetad core. (Varun Kapoor
    via mattf)

    HADOOP-8074. Small bug in hadoop error message for unknown commands.
    (Colin Patrick McCabe via eli)

    HADOOP-8082 add hadoop-client and hadoop-minicluster to the 
    dependency-management section. (tucu)

    HADOOP-8066 The full docs build intermittently fails (abayer via tucu)

    HADOOP-8083 javadoc generation for some modules is not done under target/ (tucu)

    HADOOP-8036. TestViewFsTrash assumes the user's home directory is
    2 levels deep. (Colin Patrick McCabe via eli)

    HADOOP-8046 Revert StaticMapping semantics to the existing ones, add DNS
    mapping diagnostics in progress (stevel)

    HADOOP-8057 hadoop-setup-conf.sh not working because of some extra spaces.
    (Vinayakumar B via stevel)

    HADOOP-7680 TestHardLink fails on Mac OS X, when gnu stat is in path.
    (Milind Bhandarkar via stevel)

    HADOOP-8050. Deadlock in metrics. (Kihwal Lee via mattf)

    HADOOP-8131. FsShell put doesn't correctly handle a non-existent dir
    (Daryn Sharp via bobby)

    HADOOP-8123. Use java.home rather than env.JAVA_HOME for java in the
    project. (Jonathan Eagles via acmurthy) 

    HADOOP-8064. Remove unnecessary dependency on w3c.org in document processing
    (Khiwal Lee via bobby)

    HADOOP-8140. dfs -getmerge should process its argments better (Daryn Sharp
    via bobby)

    HADOOP-8164. Back slash as path separator is handled for Windows only.
    (Daryn Sharp via suresh)

    HADOOP-8173. FsShell needs to handle quoted metachars.  (Daryn Sharp via
    szetszwo)

    HADOOP-8175. Add -p option to mkdir in FsShell.  (Daryn Sharp via szetszwo)

    HADOOP-8176.  Disambiguate the destination of FsShell copies (Daryn Sharp
    via bobby)

    HADOOP-8208. Disallow self failover. (eli)

Release 0.23.1 - 2012-02-17 

  INCOMPATIBLE CHANGES

  NEW FEATURES

    HADOOP-7777 Implement a base class for DNSToSwitchMapping implementations 
    that can offer extra topology information. (stevel)

    HADOOP-7657. Add support for LZ4 compression. (Binglin Chang via todd)

    HADOOP-7910. Add Configuration.getLongBytes to handle human readable byte size values. (Sho Shimauchi via harsh)


  IMPROVEMENTS

    HADOOP-7801. HADOOP_PREFIX cannot be overriden. (Bruno Mahé via tomwhite)

    HADOOP-7802. Hadoop scripts unconditionally source
    "$bin"/../libexec/hadoop-config.sh. (Bruno Mahé via tomwhite)

    HADOOP-7858. Drop some info logging to DEBUG level in IPC,
    metrics, and HTTP. (todd via eli)

    HADOOP-7424. Log an error if the topology script doesn't handle multiple args.
    (Uma Maheswara Rao G via eli)

    HADOOP-7804. Enable hadoop config generator to set configurations to enable
    short circuit read. (Arpit Gupta via jitendra)

    HADOOP-7877. Update balancer CLI usage documentation to include the new
    -policy option.  (szetszwo)

    HADOOP-6840. Support non-recursive create() in FileSystem and 
    SequenceFile.Writer. (jitendra and eli via eli)

    HADOOP-6886. LocalFileSystem Needs createNonRecursive API.
    (Nicolas Spiegelberg and eli via eli)

    HADOOP-7912. test-patch should run eclipse:eclipse to verify that it does
    not break again. (Robert Joseph Evans via tomwhite)

    HADOOP-7890. Redirect hadoop script's deprecation message to stderr.
    (Koji Knoguchi via mahadev)

    HADOOP-7504. Add the missing Ganglia31 opts to hadoop-metrics.properties as a comment. (harsh)

    HADOOP-7933. Add a getDelegationTokens api to FileSystem which checks
    for known tokens in the passed Credentials object. (sseth)

    HADOOP-7737. normalize hadoop-mapreduce & hadoop-dist dist/tar build with 
    common/hdfs. (tucu)

    HADOOP-7743. Add Maven profile to create a full source tarball. (tucu)

    HADOOP-7758. Make GlobFilter class public. (tucu)

    HADOOP-7590. Mavenize streaming and MR examples. (tucu)

    HADOOP-7934. Normalize dependencies versions across all modules. (tucu)

    HADOOP-7348. Change 'addnl' in getmerge util to be a flag '-nl' instead.
    (XieXianshan via harsh)

    HADOOP-7975. Add LZ4 as an entry in the default codec list, missed by HADOOP-7657 (harsh)

    HADOOP-4515. Configuration#getBoolean must not be case sensitive. (Sho Shimauchi via harsh)

    HADOOP-6490. Use StringUtils over String#replace in Path#normalizePath.
    (Uma Maheswara Rao G via harsh)

    HADOOP-7574. Improve FSShell -stat, add user/group elements.
    (XieXianshan via harsh)

    HADOOP-7736. Remove duplicate Path#normalizePath call. (harsh)

    HADOOP-7919. Remove the unused hadoop.logfile.* properties from the 
    core-default.xml file. (harsh)

    HADOOP-7939. Improve Hadoop subcomponent integration in Hadoop 0.23. (rvs via tucu)

    HADOOP-8002. SecurityUtil acquired token message should be a debug rather than info.
    (Arpit Gupta via mahadev)

    HADOOP-8009. Create hadoop-client and hadoop-minicluster artifacts for downstream 
    projects. (tucu)

    HADOOP-7470. Move up to Jackson 1.8.8.  (Enis Soztutar via szetszwo)

    HADOOP-8027. Visiting /jmx on the daemon web interfaces may print
    unnecessary error in logs. (atm)

    HADOOP-7792. Add verifyToken method to AbstractDelegationTokenSecretManager.
    (jitendra)


  OPTIMIZATIONS

  BUG FIXES
   
   HADOOP-7811. TestUserGroupInformation#testGetServerSideGroups test fails in chroot.
   (Jonathan Eagles via mahadev)

   HADOOP-7813. Fix test-patch to use proper numerical comparison when checking
   javadoc and findbugs warning counts. (Jonathan Eagles via tlipcon)

   HADOOP-7841. Run tests with non-secure random. (tlipcon)

    HADOOP-7851. Configuration.getClasses() never returns the default value. 
                 (Uma Maheswara Rao G via amarrk)

   HADOOP-7787. Make source tarball use conventional name.
   (Bruno Mahé via tomwhite)

   HADOOP-6614. RunJar should provide more diags when it can't create
   a temp file. (Jonathan Hsieh via eli)

   HADOOP-7859. TestViewFsHdfs.testgetFileLinkStatus is failing an assert. (eli)

   HADOOP-7864. Building mvn site with Maven < 3.0.2 causes OOM errors.
   (Andrew Bayer via eli)

   HADOOP-7854. UGI getCurrentUser is not synchronized. (Daryn Sharp via jitendra)

   HADOOP-7870. fix SequenceFile#createWriter with boolean
   createParent arg to respect createParent. (Jon Hsieh via eli)

   HADOOP-7898. Fix javadoc warnings in AuthenticationToken.java. (suresh)

   HADOOP-7878  Regression: HADOOP-7777 switch changes break HDFS tests when the
   isSingleSwitch() predicate is used. (stevel)

   HADOOP-7914. Remove the duplicated declaration of hadoop-hdfs test-jar in
   hadoop-project/pom.xml.  (szetszwo)

   HADOOP-7837. no NullAppender in the log4j config. (eli)

   HADOOP-7948. Shell scripts created by hadoop-dist/pom.xml to build tar do not 
   properly propagate failure. (cim_michajlomatijkiw via tucu)

   HADOOP-7949. Updated maxIdleTime default in the code to match
   core-default.xml (eli)

   HADOOP-7853. multiple javax security configurations cause conflicts. 
   (daryn via tucu)

   HDFS-2614. hadoop dist tarball is missing hdfs headers. (tucu)

   HADOOP-7874. native libs should be under lib/native/ dir. (tucu)

   HADOOP-7887. KerberosAuthenticatorHandler is not setting
   KerberosName name rules from configuration. (tucu)

   HADOOP-7902. skipping name rules setting (if already set) should be done 
   on UGI initialization only. (tucu)

   HADOOP-7810. move hadoop archive to core from tools. (tucu)

   HADOOP_7917. compilation of protobuf files fails in windows/cygwin. (tucu)

   HADOOP-7907. hadoop-tools JARs are not part of the distro. (tucu)

   HADOOP-7936. There's a Hoop README in the root dir of the tarball. (tucu)

   HADOOP-7963. Fix ViewFS to catch a null canonical service-name and pass
   tests TestViewFileSystem* (Siddharth Seth via vinodkv)

   HADOOP-7964. Deadlock in NetUtils and SecurityUtil class initialization.
   (Daryn Sharp via suresh)

   HADOOP-7974. TestViewFsTrash incorrectly determines the user's home
   directory. (harsh via eli)

   HADOOP-7971. Adding back job/pipes/queue commands to bin/hadoop for
   backward compatibility. (Prashath Sharma via acmurthy) 

   HADOOP-7982. UserGroupInformation fails to login if thread's context
   classloader can't load HadoopLoginModule. (todd)

   HADOOP-7986. Adding config for MapReduce History Server protocol in
   hadoop-policy.xml for service level authorization. (Mahadev Konar via vinodkv)

   HADOOP-7981. Improve documentation for org.apache.hadoop.io.compress.
   Decompressor.getRemaining (Jonathan Eagles via mahadev)

   HADOOP-7997. SequenceFile.createWriter(...createParent...) no
   longer works on existing file. (Gregory Chanan via eli)

   HADOOP-7993. Hadoop ignores old-style config options for enabling compressed 
   output. (Anupam Seth via mahadev)

   HADOOP-8000. fetchdt command not available in bin/hadoop.
   (Arpit Gupta via mahadev)

   HADOOP-7999. "hadoop archive" fails with ClassNotFoundException.
   (Jason Lowe via mahadev)

   HADOOP-8012. hadoop-daemon.sh and yarn-daemon.sh are trying to mkdir
   and chown log/pid dirs which can fail. (Roman Shaposhnik via eli)

   HADOOP-8013. ViewFileSystem does not honor setVerifyChecksum
   (Daryn Sharp via bobby)

   HADOOP-8054 NPE with FilterFileSystem (Daryn Sharp via bobby)

Release 0.23.0 - 2011-11-01 

  INCOMPATIBLE CHANGES

   HADOOP-6904. Support method based RPC compatiblity. (hairong)

   HADOOP-6432. Add Statistics support in FileContext. (jitendra)

   HADOOP-7136. Remove failmon contrib component. (nigel)

  NEW FEATURES

    HADOOP-7324. Ganglia plugins for metrics v2. (Priyo Mustafi via llu)

    HADOOP-7342. Add an utility API in FileUtil for JDK File.list
    avoid NPEs on File.list() (Bharath Mundlapudi via mattf)

    HADOOP-7322. Adding a util method in FileUtil for directory listing,
    avoid NPEs on File.listFiles() (Bharath Mundlapudi via mattf)

    HADOOP-7023. Add listCorruptFileBlocks to Filesysem. (Patrick Kling
    via hairong)

    HADOOP-7096. Allow setting of end-of-record delimiter for TextInputFormat
    (Ahmed Radwan via todd)

    HADOOP-6994. Api to get delegation token in AbstractFileSystem. (jitendra)

    HADOOP-7171. Support UGI in FileContext API. (jitendra)

    HADOOP-7257 Client side mount tables (sanjay)

    HADOOP-6919. New metrics2 framework. (Luke Lu via acmurthy) 

    HADOOP-6920. Metrics instrumentation to move new metrics2 framework.
    (Luke Lu via suresh)

    HADOOP-7214. Add Common functionality necessary to provide an equivalent
    of /usr/bin/groups for Hadoop. (Aaron T. Myers via todd)

    HADOOP-6832. Add an authentication plugin using a configurable static user
    for the web UI. (Owen O'Malley and Todd Lipcon via cdouglas)

    HADOOP-7144. Expose JMX metrics via JSON servlet. (Robert Joseph Evans via
    cdouglas)

    HADOOP-7379. Add the ability to serialize and deserialize protocol buffers
    in ObjectWritable. (todd)

    HADOOP-7206. Support Snappy compression. (Issei Yoshida and
    Alejandro Abdelnur via eli)

    HADOOP-7329. Add the capability of getting invividual attribute of a mbean
    using JMXProxyServlet. (tanping)

    HADOOP-7380. Add client failover functionality to o.a.h.io.(ipc|retry).
    (atm via eli)

    HADOOP-7460. Support pluggable trash policies. (Usman Masoon via suresh)

    HADOOP-6385. dfs should support -rmdir (was HDFS-639). (Daryn Sharp
    via mattf)

    HADOOP-7119. add Kerberos HTTP SPNEGO authentication support to Hadoop
    JT/NN/DN/TT web-consoles. (Alejandro Abdelnur via atm)

  IMPROVEMENTS

    HADOOP-7655. Provide a small validation script that smoke tests the installed
    cluster. (Arpit Gupta via mattf)

    HADOOP-7042. Updates to test-patch.sh to include failed test names and
    improve other messaging. (nigel)

    HADOOP-7001.  Configuration changes can occur via the Reconfigurable
    interface. (Patrick Kling via dhruba)

    HADOOP-6764. Add number of reader threads and queue length as
    configuration parameters in RPC.getServer. (Dmytro Molkov via hairong)

    HADOOP-7049. TestReconfiguration should be junit v4.
    (Patrick Kling via eli)

    HADOOP-7054 Change NN LoadGenerator to use FileContext APIs
	  (Sanjay Radia)

    HADOOP-7060. A more elegant FileSystem#listCorruptFileBlocks API.
    (Patrick Kling via hairong)

    HADOOP-7058. Expose number of bytes in FSOutputSummer buffer to
    implementatins. (Todd Lipcon via hairong)

    HADOOP-7061. unprecise javadoc for CompressionCodec. (Jingguo Yao via eli)

    HADOOP-7059. Remove "unused" warning in native code.  (Noah Watkins via eli)

    HADOOP-6864. Provide a JNI-based implementation of
     ShellBasedUnixGroupsNetgroupMapping
    (implementation of GroupMappingServiceProvider) (Erik Seffl via boryas)

    HADOOP-7078. Improve javadocs for RawComparator interface.
    (Harsh J Chouraria via todd)

    HADOOP-6995. Allow wildcards to be used in ProxyUsers configurations.
    (todd)

    HADOOP-6376. Add a comment header to conf/slaves that specifies the file
    format. (Kay Kay via todd)

    HADOOP-7151. Document need for stable hashCode() in WritableComparable.
    (Dmitriy V. Ryaboy via todd)

    HADOOP-7112. Issue a warning when GenericOptionsParser libjars are not on
    local filesystem. (tomwhite)

    HADOOP-7114. FsShell should dump all exceptions at DEBUG level.
    (todd via tomwhite)

    HADOOP-7159. RPC server should log the client hostname when read exception
    happened. (Scott Chen via todd)

    HADOOP-7167. Allow using a file to exclude certain tests from build. (todd)

    HADOOP-7133. Batch the calls in DataStorage to FileUtil.createHardLink().
    (Matt Foley via jghoman)

    HADOOP-7166. Add DaemonFactory to common. (Erik Steffl & jitendra)

    HADOOP-7175. Add isEnabled() to Trash.  (Daryn Sharp via szetszwo)

    HADOOP-7180. Better support on CommandFormat on the API and exceptions.
    (Daryn Sharp via szetszwo)

    HADOOP-7202. Improve shell Command base class.  (Daryn Sharp via szetszwo)

    HADOOP-7224. Add CommandFactory to shell.  (Daryn Sharp via szetszwo)

    HADOOP-7014. Generalize CLITest structure and interfaces to facilitate
    upstream adoption (e.g. for web testing). (cos)

    HADOOP-7230. Move "fs -help" shell command tests from HDFS to COMMOM; see
    also HDFS-1844.  (Daryn Sharp via szetszwo)

    HADOOP-7233. Refactor ls to conform to new FsCommand class.  (Daryn Sharp
    via szetszwo)

    HADOOP-7235. Refactor the tail command to conform to new FsCommand class.
    (Daryn Sharp via szetszwo)

    HADOOP-7179. Federation: Improve HDFS startup scripts. (Erik Steffl
    and Tanping Wang via suresh)

    HADOOP-7227. Remove protocol version check at proxy creation in Hadoop
    RPC. (jitendra)

    HADOOP-7236. Refactor the mkdir command to conform to new FsCommand class.
    (Daryn Sharp via szetszwo)

    HADOOP-7250. Refactor the setrep command to conform to new FsCommand class.
    (Daryn Sharp via szetszwo)

    HADOOP-7249. Refactor the chmod/chown/chgrp command to conform to new
    FsCommand class.  (Daryn Sharp via szetszwo)

    HADOOP-7251. Refactor the getmerge command to conform to new FsCommand
    class.  (Daryn Sharp via szetszwo)

    HADOOP-7265. Keep track of relative paths in PathData.  (Daryn Sharp
    via szetszwo)

    HADOOP-7238. Refactor the cat and text commands to conform to new FsCommand
    class.  (Daryn Sharp via szetszwo)

    HADOOP-7271. Standardize shell command error messages.  (Daryn Sharp
    via szetszwo)

    HADOOP-7272. Remove unnecessary security related info logs. (suresh)

    HADOOP-7275. Refactor the stat command to conform to new FsCommand
    class.  (Daryn Sharp via szetszwo)

    HADOOP-7237. Refactor the touchz command to conform to new FsCommand
    class.  (Daryn Sharp via szetszwo)

    HADOOP-7267. Refactor the rm/rmr/expunge commands to conform to new
    FsCommand class.  (Daryn Sharp via szetszwo)

    HADOOP-7285. Refactor the test command to conform to new FsCommand
    class. (Daryn Sharp via todd)

    HADOOP-7289. In ivy.xml, test conf should not extend common conf.
    (Eric Yang via szetszwo)

    HADOOP-7291. Update Hudson job not to run test-contrib. (Nigel Daley via eli)

    HADOOP-7286. Refactor the du/dus/df commands to conform to new FsCommand
    class. (Daryn Sharp via todd)

    HADOOP-7301. FSDataInputStream should expose a getWrappedStream method.
    (Jonathan Hsieh via eli)

    HADOOP-7306. Start metrics system even if config files are missing
    (Luke Lu via todd)

    HADOOP-7302. webinterface.private.actions should be renamed and moved to
    the MapReduce project. (Ari Rabkin via todd)

    HADOOP-7329. Improve help message for "df" to include "-h" flag.
    (Xie Xianshan via todd)

    HADOOP-7320. Refactor the copy and move commands to conform to new
    FsCommand class. (Daryn Sharp via todd)

    HADOOP-7312. Update value of hadoop.common.configuration.version.
    (Harsh J Chouraria via todd)

    HADOOP-7337. Change PureJavaCrc32 annotations to public stable.  (szetszwo)

    HADOOP-7331. Make hadoop-daemon.sh return exit code 1 if daemon processes
    did not get started. (Tanping Wang via todd)

    HADOOP-7316. Add public javadocs to FSDataInputStream and
    FSDataOutputStream. (eli)

    HADOOP-7323. Add capability to resolve compression codec based on codec
    name. (Alejandro Abdelnur via tomwhite)

    HADOOP-1886. Undocumented parameters in FilesSystem. (Frank Conrad via eli)

    HADOOP-7375. Add resolvePath method to FileContext. (Sanjay Radia via eli)

    HADOOP-7383. HDFS needs to export protobuf library dependency in pom.
    (todd via eli)

    HADOOP-7374. Don't add tools.jar to the classpath when running Hadoop.
    (eli)

    HADOOP-7106. Reorganize project SVN layout to "unsplit" the projects.
    (todd, nigel)

    HADOOP-6605. Add JAVA_HOME detection to hadoop-config. (eli)

    HADOOP-7384. Allow test-patch to be more flexible about patch format. (todd)

    HADOOP-6929. RPC should have a way to pass Security information other than 
    protocol annotations. (sharad and omalley via mahadev)

    HADOOP-7385. Remove StringUtils.stringifyException(ie) in logger functions.
    (Bharath Mundlapudi via Tanping Wang).

    HADOOP-310. Additional constructor requested in BytesWritable. (Brock
    Noland via atm)

    HADOOP-7429. Add another IOUtils#copyBytes method. (eli)

    HADOOP-7451. Generalize StringUtils#join. (Chris Douglas via mattf)

    HADOOP-7449. Add Data(In,Out)putByteBuffer to work with ByteBuffer similar 
    to Data(In,Out)putBuffer for byte[].  Merge from yahoo-merge branch,
    -r 1079163.  Fix missing Apache license headers. (Chris Douglas via mattf)

    HADOOP-7361. Provide an option, -overwrite/-f, in put and copyFromLocal
    shell commands.  (Uma Maheswara Rao G via szetszwo)

    HADOOP-7430. Improve error message when moving to trash fails due to 
    quota issue. (Ravi Prakash via mattf)

    HADOOP-7444. Add Checksum API to verify and calculate checksums "in bulk"
    (todd)

    HADOOP-7443. Add CRC32C as another DataChecksum implementation (todd)

    HADOOP-7305. Eclipse project files are incomplete. (Niels Basjes via eli)

    HADOOP-7314. Add support for throwing UnknownHostException when a host doesn't 
    resolve. (Jeffrey Naisbitt via jitendra)

    HADOOP-7465. A several tiny improvements for the LOG format.
    (Xie Xianshan via eli)

    HADOOP-7434. Display error when using "daemonlog -setlevel" with
    illegal level. (yanjinshuang via eli)

    HADOOP-7463. Adding a configuration parameter to SecurityInfo interface.
    (mahadev)

    HADOOP-7298. Add test utility for writing multi-threaded tests. (todd and
    Harsh J Chouraria via todd)

    HADOOP-7485. Add -h option to ls to list file sizes in human readable
    format. (XieXianshan via suresh)

    HADOOP-7378. Add -d option to ls to not expand directories.
    (Daryn Sharp via suresh)

    HADOOP-7474. Refactor ClientCache out of WritableRpcEngine. (jitendra)

    HADOOP-7491. hadoop command should respect HADOOP_OPTS when given
    a class name. (eli)

    HADOOP-7178. Add a parameter, useRawLocalFileSystem, to copyToLocalFile(..)
    in FileSystem.  (Uma Maheswara Rao G via szetszwo)

    HADOOP-6671. Use maven for hadoop common builds. (Alejandro Abdelnur
    via tomwhite)

    HADOOP-7502. Make generated sources IDE friendly.
    (Alejandro Abdelnur via llu)

    HADOOP-7501. Publish Hadoop Common artifacts (post HADOOP-6671) to Apache
    SNAPSHOTs repo. (Alejandro Abdelnur via tomwhite)

    HADOOP-7525. Make arguments to test-patch optional. (tomwhite)

    HADOOP-7472. RPC client should deal with IP address change.
    (Kihwal Lee via suresh)
  
    HADOOP-7499. Add method for doing a sanity check on hostnames in NetUtils.
    (Jeffrey Naisbit via mahadev)

    HADOOP-6158. Move CyclicIteration to HDFS. (eli)

    HADOOP-7526. Add TestPath tests for URI conversion and reserved
    characters. (eli)

    HADOOP-7531. Add servlet util methods for handling paths in requests. (eli)

    HADOOP-7493. Add ShortWritable.  (Uma Maheswara Rao G via szetszwo)

    HADOOP-7555. Add a eclipse-generated files to .gitignore. (atm)

    HADOOP-7264. Bump avro version to at least 1.4.1. (Alejandro Abdelnur via
    tomwhite)

    HADOOP-7498. Remove legacy TAR layout creation. (Alejandro Abdelnur via
    tomwhite)

    HADOOP-7496. Break Maven TAR & bintar profiles into just LAYOUT & TAR proper.
    (Alejandro Abdelnur via tomwhite)

    HADOOP-7561. Make test-patch only run tests for changed modules. (tomwhite)

    HADOOP-7547. Add generic type in WritableComparable subclasses.
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7579. Rename package names from alfredo to auth.
    (Alejandro Abdelnur via szetszwo)

    HADOOP-7594. Support HTTP REST in HttpServer.  (szetszwo)

    HADOOP-7552. FileUtil#fullyDelete doesn't throw IOE but lists it
    in the throws clause. (eli)

    HADOOP-7580. Add a version of getLocalPathForWrite to LocalDirAllocator
    which doesn't create dirs. (Chris Douglas & Siddharth Seth via acmurthy) 

    HADOOP-7507. Allow ganglia metrics to include the metrics system tags
                 in the gmetric names. (Alejandro Abdelnur via todd)

    HADOOP-7612. Change test-patch to run tests for all nested modules.
    (tomwhite)

    HADOOP-7599. Script improvements to setup a secure Hadoop cluster
    (Eric Yang via ddas)

    HADOOP-7639. Enhance HttpServer to allow passing path-specs for filtering,
    so that servers like Yarn WebApp can get filtered the paths served by
    their own injected servlets. (Thomas Graves via vinodkv)

    HADOOP-7575. Enhanced LocalDirAllocator to support fully-qualified
    paths. (Jonathan Eagles via vinodkv)

    HADOOP-7469  Add a standard handler for socket connection problems which
                 improves diagnostics (Uma Maheswara Rao G  and stevel via stevel)

    HADOOP-7710. Added hadoop-setup-application.sh for creating 
    application directory (Arpit Gupta via Eric Yang)

    HADOOP-7707. Added toggle for dfs.support.append, webhdfs and hadoop proxy
    user to setup config script. (Arpit Gupta via Eric Yang)

    HADOOP-7720. Added parameter for HBase user to setup config script.
    (Arpit Gupta via Eric Yang)

    HADOOP-7624. Set things up for a top level hadoop-tools module. (tucu)

    HADOOP-7627. Improve MetricsAsserts to give more understandable output
    on failure. (todd)

    HADOOP-7642. create hadoop-dist module where TAR stitching would happen.
    (Thomas White via tucu)

    HADOOP-7709. Running a set of methods in a Single Test Class. 
    (Jonathan Eagles via mahadev)

    HADOOP-7705. Add a log4j back end that can push out JSON data,
    one per line. (stevel)

    HADOOP-7749. Add a NetUtils createSocketAddr call which provides more
    help in exception messages. (todd)

    HADOOP-7762. Common side of MR-2736. (eli)

    HADOOP-7668. Add a NetUtils method that can tell if an InetAddress 
    belongs to local host. (suresh)

    HADOOP-7509. Improve exception message thrown when Authentication is 
    required. (Ravi Prakash via suresh)

    HADOOP-7745. Fix wrong variable name in exception message introduced
    in HADOOP-7509. (Ravi Prakash via suresh)

    MAPREDUCE-2764. Fix renewal of dfs delegation tokens. (Owen via jitendra)

    HADOOP-7360. Preserve relative paths that do not contain globs in FsShell.
    (Daryn Sharp and Kihwal Lee via szetszwo)

    HADOOP-7771. FsShell -copyToLocal, -get, etc. commands throw NPE if the
    destination directory does not exist.  (John George and Daryn Sharp
    via szetszwo)

    HADOOP-7782. Aggregate project javadocs. (tomwhite)

    HADOOP-7789. Improvements to site navigation. (acmurthy) 

  OPTIMIZATIONS
  
    HADOOP-7333. Performance improvement in PureJavaCrc32. (Eric Caspole
    via todd)

    HADOOP-7445. Implement bulk checksum verification using efficient native
    code. (todd)

    HADOOP-7753. Support fadvise and sync_file_range in NativeIO. Add
    ReadaheadPool infrastructure for use in HDFS and MR. (todd)

    HADOOP-7446. Implement CRC32C native code using SSE4.2 instructions.
    (Kihwal Lee and todd via todd)

    HADOOP-7763. Add top-level navigation to APT docs. (tomwhite)

    HADOOP-7785. Add equals, hashcode, toString to DataChecksum (todd)

  BUG FIXES

    HADOOP-7740. Fixed security audit logger configuration. (Arpit Gupta via Eric Yang)

    HADOOP-7630. hadoop-metrics2.properties should have a property *.period 
    set to a default value for metrics. (Eric Yang via mattf)

    HADOOP-7327. FileSystem.listStatus() throws NullPointerException instead of
    IOException upon access permission failure. (mattf)

    HADOOP-7015. RawLocalFileSystem#listStatus does not deal with a directory
    whose entries are changing (e.g. in a multi-thread or multi-process
    environment). (Sanjay Radia via eli)

    HADOOP-7045. TestDU fails on systems with local file systems with 
    extended attributes. (eli)

    HADOOP-6939. Inconsistent lock ordering in
    AbstractDelegationTokenSecretManager. (Todd Lipcon via tomwhite)

    HADOOP-7129. Fix typo in method name getProtocolSigature (todd)

    HADOOP-7048.  Wrong description of Block-Compressed SequenceFile Format in
    SequenceFile's javadoc.  (Jingguo Yao via tomwhite)

    HADOOP-7153. MapWritable violates contract of Map interface for equals()
    and hashCode(). (Nicholas Telford via todd)

    HADOOP-6754. DefaultCodec.createOutputStream() leaks memory.
    (Aaron Kimball via tomwhite)

    HADOOP-7098. Tasktracker property not set in conf/hadoop-env.sh.
    (Bernd Fondermann via tomwhite)

    HADOOP-7131. Exceptions thrown by Text methods should include the causing
    exception. (Uma Maheswara Rao G via todd)

    HADOOP-6912. Guard against NPE when calling UGI.isLoginKeytabBased().
    (Kan Zhang via jitendra)

    HADOOP-7204. remove local unused fs variable from CmdHandler 
    and FsShellPermissions.changePermissions (boryas)

    HADOOP-7210. Chown command is not working from FSShell
    (Uma Maheswara Rao G via todd)

    HADOOP-7215. RPC clients must use network interface corresponding to 
    the host in the client's kerberos principal key. (suresh)

    HADOOP-7019. Refactor build targets to enable faster cross project dev
    cycles. (Luke Lu via cos)

    HADOOP-7216. Add FsCommand.runAll() with deprecated annotation for the
    transition of Command base class improvement.  (Daryn Sharp via szetszwo)

    HADOOP-7207. fs member of FSShell is not really needed (boryas)

    HADOOP-7223. FileContext createFlag combinations are not clearly defined.
    (suresh)

    HADOOP-7231. Fix synopsis for -count. (Daryn Sharp via eli).

    HADOOP-7261. Disable IPV6 for junit tests. (suresh)

    HADOOP-7268. FileContext.getLocalFSFileContext() behavior needs to be fixed
    w.r.t tokens. (jitendra)

    HADOOP-7290. Unit test failure in 
    TestUserGroupInformation.testGetServerSideGroups. (Trevor Robison via eli)

    HADOOP-7292. Fix racy test case TestSinkQueue. (Luke Lu via todd)

    HADOOP-7282. ipc.Server.getRemoteIp() may return null.  (John George
    via szetszwo)

    HADOOP-7208. Fix implementation of equals() and hashCode() in
    StandardSocketFactory. (Uma Maheswara Rao G via todd)

    HADOOP-7336. TestFileContextResolveAfs will fail with default 
    test.build.data property. (jitendra)

    HADOOP-7284 Trash and shell's rm does not work for viewfs (Sanjay Radia)

    HADOOP-7341. Fix options parsing in CommandFormat (Daryn Sharp via todd)

    HADOOP-7353. Cleanup FsShell and prevent masking of RTE stack traces.
    (Daryn Sharp via todd)

    HADOOP-7356. RPM packages broke bin/hadoop script in developer environment.
    (Eric Yang via todd)

    HADOOP-7389. Use of TestingGroups by tests causes subsequent tests to fail.
    (atm via tomwhite)

    HADOOP-7377. Fix command name handling affecting DFSAdmin. (Daryn Sharp
    via mattf)

    HADOOP-7402. TestConfiguration doesn't clean up after itself. (atm via eli)

    HADOOP-7428. IPC connection is orphaned with null 'out' member.
    (todd via eli)

    HADOOP-7437. IOUtils.copybytes will suppress the stream closure exceptions.
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7090. Fix resource leaks in s3.INode, BloomMapFile, WritableUtils
    and CBZip2OutputStream.  (Uma Maheswara Rao G via szetszwo)

    HADOOP-7440. HttpServer.getParameterValues throws NPE for missing
    parameters. (Uma Maheswara Rao G and todd via todd)

    HADOOP-7442. Docs in core-default.xml still reference deprecated config
    "topology.script.file.name" (atm)

    HADOOP-7419. new hadoop-config.sh doesn't manage classpath for
    HADOOP_CONF_DIR correctly. (Bing Zheng and todd via todd)

    HADOOP-7448. merge from yahoo-merge branch (via mattf):
    -r 1079157: Fix content type for /stacks servlet to be 
    plain text (Luke Lu)
    -r 1079164: No need to escape plain text (Luke Lu)

    HADOOP-7471. The saveVersion.sh script sometimes fails to extract SVN URL.
    (Alejandro Abdelnur via eli)

    HADOOP-2081. Configuration getInt, getLong, and getFloat replace
    invalid numbers with the default value. (Harsh J via eli)

    HADOOP-7111. Several TFile tests failing when native libraries are
    present. (atm)

    HADOOP-7438. Fix deprecated warnings from hadoop-daemon.sh script.
    (Ravi Prakash via suresh)

    HADOOP-7468 hadoop-core JAR contains a log4j.properties file.
    (Jolly Chen)

    HADOOP-7508. Compiled nativelib is in wrong directory and it is not picked
    up by surefire setup. (Alejandro Abdelnur via tomwhite)
   
    HADOOP-7520. Fix to add distribution management info to hadoop-main
    (Alejandro Abdelnur via gkesavan)

    HADOOP-7515. test-patch reports the wrong number of javadoc warnings.
    (tomwhite)

    HADOOP-7523. Test org.apache.hadoop.fs.TestFilterFileSystem fails due to
    java.lang.NoSuchMethodException. (John Lee via tomwhite)

    HADOOP-7528. Maven build fails in Windows. (Alejandro Abdelnur via
    tomwhite)

    HADOOP-7533. Allow test-patch to be run from any subproject directory.
    (tomwhite)

    HADOOP-7512. Fix example mistake in WritableComparable javadocs.
    (Harsh J via eli)

    HADOOP-7357. hadoop.io.compress.TestCodec#main() should exit with
    non-zero exit code if test failed. (Philip Zeyliger via eli)

    HADOOP-6622. Token should not print the password in toString. (eli)

    HADOOP-7529. Fix lock cycles in metrics system. (llu)

    HADOOP-7545. Common -tests JAR should not include properties and configs.
    (todd)

    HADOOP-7536. Correct the dependency version regressions introduced in
    HADOOP-6671. (Alejandro Abdelnur via tomwhite)

    HADOOP-7566. MR tests are failing webapps/hdfs not found in CLASSPATH.
    (Alejandro Abdelnur via mahadev)

    HADOOP-7567. 'mvn eclipse:eclipse' fails for hadoop-alfredo (auth).
    (Alejandro Abdelnur via tomwhite)

    HADOOP-7563. Setup HADOOP_HDFS_HOME, HADOOP_MAPRED_HOME and classpath
    correction. (Eric Yang via acmurthy) 

    HADOOP-7560. Change src layout to be heirarchical. (Alejandro Abdelnur
    via acmurthy)

    HADOOP-7576. Fix findbugs warnings and javac warnings in hadoop-auth.
    (szetszwo)

    HADOOP-7593. Fix AssertionError in TestHttpServer.testMaxThreads().
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7598. Fix smart-apply-patch.sh to handle patching from a sub
    directory correctly. (Robert Evans via acmurthy) 

    HADOOP-7328. When a serializer class is missing, return null, not throw
    an NPE. (Harsh J Chouraria via todd)

    HADOOP-7626. Bugfix for a config generator (Eric Yang via ddas)

    HADOOP-7629. Allow immutable FsPermission objects to be used as IPC
    parameters. (todd)

    HADOOP-7608. SnappyCodec check for Hadoop native lib is wrong
    (Alejandro Abdelnur via todd)

    HADOOP-7637. Fix to include FairScheduler configuration file in
    RPM. (Eric Yang via ddas)

    HADOOP-7633. Adds log4j.properties to the hadoop-conf dir on
    deploy (Eric Yang via ddas)

    HADOOP-7631. Fixes a config problem to do with running streaming jobs
    (Eric Yang via ddas)

    HADOOP-7662. Fixed logs servlet to use the pathspec '/*' instead of '/'
    for correct filtering. (Thomas Graves via vinodkv)

    HADOOP-7691. Fixed conflict uid for install packages. (Eric Yang)

    HADOOP-7603. Set hdfs, mapred uid, and hadoop uid to fixed numbers. 
    (Eric Yang)

    HADOOP-7658. Fixed HADOOP_SECURE_DN_USER environment variable in 
    hadoop-evn.sh (Eric Yang)

    HADOOP-7684. Added init.d script for jobhistory server and
    secondary namenode. (Eric Yang)

    HADOOP-7715. Removed unnecessary security logger configuration. (Eric Yang)

    HADOOP-7685. Improved directory ownership check function in 
    hadoop-setup-conf.sh. (Eric Yang)

    HADOOP-7711. Fixed recursive sourcing of HADOOP_OPTS environment
    variables (Arpit Gupta via Eric Yang)

    HADOOP-7681. Fixed security and hdfs audit log4j properties
    (Arpit Gupta via Eric Yang)

    HADOOP-7708. Fixed hadoop-setup-conf.sh to handle config files
    consistently.  (Eric Yang)

    HADOOP-7724. Fixed hadoop-setup-conf.sh to put proxy user in
    core-site.xml.  (Arpit Gupta via Eric Yang)

    HADOOP-7755. Detect MapReduce PreCommit Trunk builds silently failing
    when running test-patch.sh. (Jonathan Eagles via tomwhite)

    HADOOP-7744. Ensure failed tests exit with proper error code. (Jonathan
    Eagles via acmurthy) 

    HADOOP-7764. Allow HttpServer to set both ACL list and path spec filters. 
    (Jonathan Eagles via acmurthy)

    HADOOP-7766. The auth to local mappings are not being respected, with webhdfs 
    and security enabled. (jitendra)

    HADOOP-7721. Add log before login in KerberosAuthenticationHandler. 
    (jitendra)

    HADOOP-7778. FindBugs warning in Token.getKind(). (tomwhite)

    HADOOP-7798. Add support gpg signatures for maven release artifacts.
    (cutting via acmurthy) 

    HADOOP-7797. Fix top-level pom.xml to refer to correct staging maven
    repository. (omalley via acmurthy) 

    HADOOP-7101. UserGroupInformation.getCurrentUser() fails when called from
    non-Hadoop JAAS context. (todd)

Release 0.22.1 - Unreleased

  INCOMPATIBLE CHANGES

  NEW FEATURES

  IMPROVEMENTS

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-7937. Forward port SequenceFile#syncFs and friends from Hadoop 1.x.
    (tomwhite)

Release 0.22.0 - 2011-11-29

  INCOMPATIBLE CHANGES

    HADOOP-7137. Remove hod contrib. (nigel via eli)

  NEW FEATURES

    HADOOP-6791.  Refresh for proxy superuser config
    (common part for HDFS-1096) (boryas)

    HADOOP-6581. Add authenticated TokenIdentifiers to UGI so that 
    they can be used for authorization (Kan Zhang and Jitendra Pandey 
    via jghoman)

    HADOOP-6584. Provide Kerberized SSL encryption for webservices.
    (jghoman and Kan Zhang via jghoman)

    HADOOP-6853. Common component of HDFS-1045. (jghoman)

    HADOOP-6859 - Introduce additional statistics to FileSystem to track 
    file system operations (suresh)

    HADOOP-6870. Add a new API getFiles to FileSystem and FileContext that
    lists all files under the input path or the subtree rooted at the
    input path if recursive is true. Block locations are returned together
    with each file's status. (hairong)

    HADOOP-6888. Add a new FileSystem API closeAllForUGI(..) for closing all
    file systems associated with a particular UGI.  (Devaraj Das and Kan Zhang
    via szetszwo)

    HADOOP-6892. Common component of HDFS-1150 (Verify datanodes' identities 
    to clients in secure clusters) (jghoman)

    HADOOP-6889. Make RPC to have an option to timeout. (hairong)

    HADOOP-6996. Allow CodecFactory to return a codec object given a codec'
    class name. (hairong)

    HADOOP-7013. Add boolean field isCorrupt to BlockLocation. 
    (Patrick Kling via hairong)

    HADOOP-6978. Adds support for NativeIO using JNI. 
    (Todd Lipcon, Devaraj Das & Owen O'Malley via ddas)

    HADOOP-7134. configure files that are generated as part of the released
    tarball need to have executable bit set. (Roman Shaposhnik via cos)

  IMPROVEMENTS

    HADOOP-6644. util.Shell getGROUPS_FOR_USER_COMMAND method name 
    - should use common naming convention (boryas)

    HADOOP-6778. add isRunning() method to 
    AbstractDelegationTokenSecretManager (for HDFS-1044) (boryas)

    HADOOP-6633. normalize property names for JT/NN kerberos principal 
    names in configuration (boryas)

    HADOOP-6627. "Bad Connection to FS" message in FSShell should print 
    message from the exception (boryas)

    HADOOP-6600. mechanism for authorization check for inter-server 
    protocols. (boryas)

    HADOOP-6623. Add StringUtils.split for non-escaped single-character
    separator. (Todd Lipcon via tomwhite)

    HADOOP-6761. The Trash Emptier has the ability to run more frequently.
    (Dmytro Molkov via dhruba)

    HADOOP-6714. Resolve compressed files using CodecFactory in FsShell::text.
    (Patrick Angeles via cdouglas)

    HADOOP-6661. User document for UserGroupInformation.doAs. 
    (Jitendra Pandey via jghoman)

    HADOOP-6674. Makes use of the SASL authentication options in the
    SASL RPC. (Jitendra Pandey via ddas)

    HADOOP-6526. Need mapping from long principal names to local OS 
    user names. (boryas)

    HADOOP-6814. Adds an API in UserGroupInformation to get the real
    authentication method of a passed UGI. (Jitendra Pandey via ddas)

    HADOOP-6756. Documentation for common configuration keys.
    (Erik Steffl via shv)

    HADOOP-6835. Add support for concatenated gzip input. (Greg Roelofs via
    cdouglas)

    HADOOP-6845. Renames the TokenStorage class to Credentials. 
    (Jitendra Pandey via ddas)

    HADOOP-6826. FileStatus needs unit tests. (Rodrigo Schmidt via Eli
    Collins)

    HADOOP-6905. add buildDTServiceName method to SecurityUtil 
    (as part of MAPREDUCE-1718)  (boryas)

    HADOOP-6632. Adds support for using different keytabs for different
    servers in a Hadoop cluster. In the earier implementation, all servers 
    of a certain type (like TaskTracker), would have the same keytab and the
    same principal. Now the principal name is a pattern that has _HOST in it.
    (Kan Zhang & Jitendra Pandey via ddas)

    HADOOP-6861. Adds new non-static methods in Credentials to read and 
    write token storage file. (Jitendra Pandey & Owen O'Malley via ddas)

    HADOOP-6877. Common part of HDFS-1178 (NameNode servlets should communicate
    with NameNode directrly). (Kan Zhang via jghoman)
    
    HADOOP-6475. Adding some javadoc to Server.RpcMetrics, UGI. 
    (Jitendra Pandey and borya via jghoman)

    HADOOP-6656. Adds a thread in the UserGroupInformation to renew TGTs 
    periodically. (Owen O'Malley and ddas via ddas)

    HADOOP-6890. Improve listFiles API introduced by HADOOP-6870. (hairong)

    HADOOP-6862. Adds api to add/remove user and group to AccessControlList
    (amareshwari)

    HADOOP-6911. doc update for DelegationTokenFetcher (boryas)

    HADOOP-6900. Make the iterator returned by FileSystem#listLocatedStatus to 
    throw IOException rather than RuntimeException when there is an IO error
    fetching the next file. (hairong)

    HADOOP-6905. Better logging messages when a delegation token is invalid.
    (Kan Zhang via jghoman)

    HADOOP-6693. Add metrics to track kerberol login activity. (suresh)

    HADOOP-6803. Add native gzip read/write coverage to TestCodec.
    (Eli Collins via tomwhite)

    HADOOP-6950. Suggest that HADOOP_CLASSPATH should be preserved in 
    hadoop-env.sh.template. (Philip Zeyliger via Eli Collins)

    HADOOP-6922. Make AccessControlList a writable and update documentation
    for Job ACLs.  (Ravi Gummadi via vinodkv)

    HADOOP-6965. Introduces checks for whether the original tgt is valid 
    in the reloginFromKeytab method.

    HADOOP-6856. Simplify constructors for SequenceFile, and MapFile. (omalley)

    HADOOP-6987. Use JUnit Rule to optionally fail test cases that run more
    than 10 seconds (jghoman)

    HADOOP-7005. Update test-patch.sh to remove callback to Hudson. (nigel)

    HADOOP-6985. Suggest that HADOOP_OPTS be preserved in
    hadoop-env.sh.template. (Ramkumar Vadali via cutting)

    HADOOP-7007. Update the hudson-test-patch ant target to work with the
    latest test-patch.sh script (gkesavan)

    HADOOP-7010. Typo in FileSystem.java. (Jingguo Yao via eli)

    HADOOP-7009. MD5Hash provides a public factory method that creates an
    instance of thread local MessageDigest. (hairong)

    HADOOP-7008. Enable test-patch.sh to have a configured number of 
    acceptable findbugs and javadoc warnings. (nigel and gkesavan)

    HADOOP-6818. Provides a JNI implementation of group resolution. (ddas)

    HADOOP-6943. The GroupMappingServiceProvider interface should be public.
    (Aaron T. Myers via tomwhite)

    HADOOP-4675. Current Ganglia metrics implementation is incompatible with
    Ganglia 3.1. (Brian Bockelman via tomwhite)

    HADOOP-6977. Herriot daemon clients should vend statistics (cos)

    HADOOP-7024. Create a test method for adding file systems during tests.
    (Kan Zhang via jghoman)

    HADOOP-6903. Make AbstractFSileSystem methods and some FileContext methods
    to be public. (Sanjay Radia)

    HADOOP-7034. Add TestPath tests to cover dot, dot dot, and slash 
    normalization. (eli)

    HADOOP-7032. Assert type constraints in the FileStatus constructor. (eli)

    HADOOP-6562. FileContextSymlinkBaseTest should use FileContextTestHelper. 
    (eli)

    HADOOP-7028. ant eclipse does not include requisite ant.jar in the 
    classpath. (Patrick Angeles via eli)

    HADOOP-6298. Add copyBytes to Text and BytesWritable. (omalley)
  
    HADOOP-6578. Configuration should trim whitespace around a lot of value
    types. (Michele Catasta via eli)

    HADOOP-6811. Remove EC2 bash scripts. They are replaced by Apache Whirr
    (incubating, http://incubator.apache.org/whirr). (tomwhite)

    HADOOP-7102. Remove "fs.ramfs.impl" field from core-deafult.xml (shv)

    HADOOP-7104. Remove unnecessary DNS reverse lookups from RPC layer
    (Kan Zhang via todd)

    HADOOP-6056. Use java.net.preferIPv4Stack to force IPv4.
    (Michele Catasta via shv)

    HADOOP-7110. Implement chmod with JNI. (todd)

    HADOOP-6812. Change documentation for correct placement of configuration
    variables: mapreduce.reduce.input.buffer.percent, 
    mapreduce.task.io.sort.factor, mapreduce.task.io.sort.mb
    (Chris Douglas via shv)

    HADOOP-6436. Remove auto-generated native build files. (rvs via eli)

    HADOOP-6970. SecurityAuth.audit should be generated under /build. (boryas)

    HADOOP-7154. Should set MALLOC_ARENA_MAX in hadoop-env.sh (todd)

    HADOOP-7187. Fix socket leak in GangliaContext.  (Uma Maheswara Rao G
    via szetszwo)

    HADOOP-7241. fix typo of command 'hadoop fs -help tail'. 
    (Wei Yongjun via eli)

    HADOOP-7244. Documentation change for updated configuration keys.
    (tomwhite via eli)

    HADOOP-7189. Add ability to enable 'debug' property in JAAS configuration.
    (Ted Yu via todd)

    HADOOP-7192. Update fs -stat docs to reflect the format features. (Harsh
    J Chouraria via todd)

    HADOOP-7355  Add audience and stability annotations to HttpServer class
                 (stack)

    HADOOP-7346. Send back nicer error message to clients using outdated IPC
    version. (todd)

    HADOOP-7335. Force entropy to come from non-true random for tests.
    (todd via eli)

    HADOOP-7325. The hadoop command should not accept class names starting with
    a hyphen. (Brock Noland via todd)

    HADOOP-7772. javadoc the topology classes (stevel)

    HADOOP-7786. Remove HDFS-specific config keys defined in FsConfig. (eli)

    HADOOP-7861. changes2html.pl generates links to HADOOP, HDFS, and MAPREDUCE
    jiras. (shv)

  OPTIMIZATIONS

    HADOOP-6884. Add LOG.isDebugEnabled() guard for each LOG.debug(..).
    (Erik Steffl via szetszwo)

    HADOOP-6683. ZlibCompressor does not fully utilize the buffer.
    (Kang Xiao via eli)

    HADOOP-6949. Reduce RPC packet size of primitive arrays using
    ArrayPrimitiveWritable instead of ObjectWritable. (Matt Foley via suresh)

  BUG FIXES

    HADOOP-6638. try to relogin in a case of failed RPC connection (expired 
    tgt) only in case the subject is loginUser or proxyUgi.realUser. (boryas)

    HADOOP-6781. security audit log shouldn't have exception in it. (boryas)

    HADOOP-6612.  Protocols RefreshUserToGroupMappingsProtocol and 
    RefreshAuthorizationPolicyProtocol will fail with security enabled (boryas)

    HADOOP-6764. Remove verbose logging from the Groups class. (Boris Shkolnik)

    HADOOP-6730. Bug in FileContext#copy and provide base class for 
    FileContext tests. (Ravi Phulari via jghoman)

    HADOOP-6669. Respect compression configuration when creating DefaultCodec
    instances. (Koji Noguchi via cdouglas)

    HADOOP-6747. TestNetUtils fails on Mac OS X. (Todd Lipcon via jghoman)

    HADOOP-6787. Factor out glob pattern code from FileContext and
    Filesystem. Also fix bugs identified in HADOOP-6618 and make the
    glob pattern code less restrictive and more POSIX standard
    compliant. (Luke Lu via eli)

    HADOOP-6649.  login object in UGI should be inside the subject (jnp via 
    boryas)

    HADOOP-6687.   user object in the subject in UGI should be reused in case 
    of a relogin. (jnp via boryas)

    HADOOP-6603. Provide workaround for issue with Kerberos not resolving 
    cross-realm principal (Kan Zhang and Jitendra Pandey via jghoman)

    HADOOP-6620. NPE if renewer is passed as null in getDelegationToken.
    (Jitendra Pandey via jghoman)

    HADOOP-6613. Moves the RPC version check ahead of the AuthMethod check.
    (Kan Zhang via ddas)

    HADOOP-6682. NetUtils:normalizeHostName does not process hostnames starting
    with [a-f] correctly. (jghoman)

    HADOOP-6652. Removes the unnecessary cache from 
    ShellBasedUnixGroupsMapping. (ddas)

    HADOOP-6815. refreshSuperUserGroupsConfiguration should use server side 
    configuration for the refresh (boryas)

    HADOOP-6648. Adds a check for null tokens in Credentials.addToken api.
    (ddas)
 
    HADOOP-6647. balancer fails with "is not authorized for protocol 
    interface NamenodeProtocol" in secure environment (boryas)

    HADOOP-6834. TFile.append compares initial key against null lastKey
    (hong tang via mahadev)

    HADOOP-6670. Use the UserGroupInformation's Subject as the criteria for
    equals and hashCode. (Owen O'Malley and Kan Zhang via ddas)

    HADOOP-6536. Fixes FileUtil.fullyDelete() not to delete the contents of
    the sym-linked directory. (Ravi Gummadi via amareshwari)

    HADOOP-6873. using delegation token over hftp for long 
    running clients (boryas)

    HADOOP-6706. Improves the sasl failure handling due to expired tickets,
    and other server detected failures. (Jitendra Pandey and ddas via ddas)

    HADOOP-6715. Fixes AccessControlList.toString() to return a descriptive
    String representation of the ACL. (Ravi Gummadi via amareshwari)

    HADOOP-6885. Fix java doc warnings in Groups and 
    RefreshUserMappingsProtocol. (Eli Collins via jghoman) 

    HADOOP-6482. GenericOptionsParser constructor that takes Options and 
    String[] ignores options. (Eli Collins via jghoman)

    HADOOP-6906.  FileContext copy() utility doesn't work with recursive
    copying of directories. (vinod k v via mahadev)

    HADOOP-6453. Hadoop wrapper script shouldn't ignore an existing 
    JAVA_LIBRARY_PATH. (Chad Metcalf via jghoman)

    HADOOP-6932.  Namenode start (init) fails because of invalid kerberos 
    key, even when security set to "simple" (boryas)

    HADOOP-6913. Circular initialization between UserGroupInformation and 
    KerberosName (Kan Zhang via boryas)

    HADOOP-6907. Rpc client doesn't use the per-connection conf to figure
    out server's Kerberos principal (Kan Zhang via hairong)

    HADOOP-6938. ConnectionId.getRemotePrincipal() should check if security
    is enabled. (Kan Zhang via hairong)

    HADOOP-6930. AvroRpcEngine doesn't work with generated Avro code. 
    (sharad)

    HADOOP-6940. RawLocalFileSystem's markSupported method misnamed 
    markSupport. (Tom White via eli).

    HADOOP-6951.  Distinct minicluster services (e.g. NN and JT) overwrite each
    other's service policies.  (Aaron T. Myers via tomwhite)

    HADOOP-6879. Provide SSH based (Jsch) remote execution API for system
    tests (cos)

    HADOOP-6989. Correct the parameter for SetFile to set the value type
    for SetFile to be NullWritable instead of the key. (cdouglas via omalley)

    HADOOP-6984. Combine the compress kind and the codec in the same option
    for SequenceFiles. (cdouglas via omalley)

    HADOOP-6933. TestListFiles is flaky. (Todd Lipcon via tomwhite)

    HADOOP-6947.  Kerberos relogin should set refreshKrb5Config to true.
    (Todd Lipcon via tomwhite)

    HADOOP-7006. Fix 'fs -getmerge' command to not be a no-op.
    (Chris Nauroth via cutting)

    HADOOP-6663.  BlockDecompressorStream get EOF exception when decompressing
    the file compressed from empty file.  (Kang Xiao via tomwhite)

    HADOOP-6991.  Fix SequenceFile::Reader to honor file lengths and call
    openFile (cdouglas via omalley)

    HADOOP-7011.  Fix KerberosName.main() to not throw an NPE.
    (Aaron T. Myers via tomwhite)

    HADOOP-6975.  Integer overflow in S3InputStream for blocks > 2GB.
    (Patrick Kling via tomwhite)

    HADOOP-6758. MapFile.fix does not allow index interval definition.
    (Gianmarco De Francisci Morales via tomwhite)

    HADOOP-6926. SocketInputStream incorrectly implements read().
    (Todd Lipcon via tomwhite)

    HADOOP-6899 RawLocalFileSystem#setWorkingDir() does not work for relative names
     (Sanjay Radia)

    HADOOP-6496. HttpServer sends wrong content-type for CSS files
    (and others). (Todd Lipcon via tomwhite)

    HADOOP-7057. IOUtils.readFully and IOUtils.skipFully have typo in
    exception creation's message. (cos)

    HADOOP-7038. saveVersion script includes an additional \r while running
    whoami under windows. (Wang Xu via cos)

    HADOOP-7082. Configuration.writeXML should not hold lock while outputting
    (todd)

    HADOOP-7070. JAAS configuration should delegate unknown application names
    to pre-existing configuration. (todd)

    HADOOP-7087. SequenceFile.createWriter ignores FileSystem parameter (todd)

    HADOOP-7091. reloginFromKeytab() should happen even if TGT can't be found.
    (Kan Zhang via jghoman)

    HADOOP-7100. Fix build to not refer to contrib/ec2 removed by HADOOP-6811
    (todd)

    HADOOP-7097. JAVA_LIBRARY_PATH missing base directory. (Noah Watkins via
    todd)

    HADOOP-7093. Servlets should default to text/plain (todd)

    HADOOP-7089. Fix link resolution logic in hadoop-config.sh. (eli)

    HADOOP-7046. Fix Findbugs warning in Configuration. (Po Cheung via shv)

    HADOOP-7118. Fix NPE in Configuration.writeXml (todd)

    HADOOP-7122. Fix thread leak when shell commands time out. (todd)

    HADOOP-7126. Fix file permission setting for RawLocalFileSystem on Windows.
    (Po Cheung via shv)

    HADOOP-6642. Fix javac, javadoc, findbugs warnings related to security work. 
    (Chris Douglas, Po Cheung via shv)

    HADOOP-7140. IPC Reader threads do not stop when server stops (todd)

    HADOOP-7094. hadoop.css got lost during project split (cos)

    HADOOP-7145. Configuration.getLocalPath should trim whitespace from
    the provided directories. (todd)

    HADOOP-7156. Workaround for unsafe implementations of getpwuid_r (todd)

    HADOOP-6898. FileSystem.copyToLocal creates files with 777 permissions.
    (Aaron T. Myers via tomwhite)

    HADOOP-7229. Do not default to an absolute path for kinit in Kerberos
    auto-renewal thread. (Aaron T. Myers via todd)

    HADOOP-7172. SecureIO should not check owner on non-secure
    clusters that have no native support. (todd via eli)

    HADOOP-7184. Remove deprecated config local.cache.size from
    core-default.xml (todd)

    HADOOP-7245. FsConfig should use constants in CommonConfigurationKeys.
    (tomwhite via eli)

    HADOOP-7068. Ivy resolve force mode should be turned off by default.
    (Luke Lu via tomwhite)

    HADOOP-7296. The FsPermission(FsPermission) constructor does not use the
    sticky bit. (Siddharth Seth via tomwhite)

    HADOOP-7300. Configuration methods that return collections are inconsistent
    about mutability. (todd)

    HADOOP-7305. Eclipse project classpath should include tools.jar from JDK.
    (Niels Basjes via todd)

    HADOOP-7318. MD5Hash factory should reset the digester it returns.
    (todd via eli)

    HADOOP-7287. Configuration deprecation mechanism doesn't work properly for
    GenericOptionsParser and Tools. (Aaron T. Myers via todd)

    HADOOP-7146. RPC server leaks file descriptors (todd)

    HADOOP-7276. Hadoop native builds fail on ARM due to -m32 (Trevor Robinson
    via eli)

    HADOOP-7121. Exceptions while serializing IPC call responses are not
    handled well. (todd)

    HADOOP-7351  Regression: HttpServer#getWebAppsPath used to be protected
    so subclasses could supply alternate webapps path but it was made private
    by HADOOP-6461 (Stack)

    HADOOP-7349. HADOOP-7121 accidentally disabled some tests in TestIPC.
    (todd)

    HADOOP-7390. VersionInfo not generated properly in git after unsplit. (todd
    via atm)

    HADOOP-7568. SequenceFile should not print into stdout.
    (Plamen Jeliazkov via shv)

    HADOOP-7663. Fix TestHDFSTrash failure. (Mayank Bansal via shv)

    HADOOP-7457. Remove out-of-date Chinese language documentation.
    (Jakob Homan via eli)

    HADOOP-7783. Add more symlink tests that cover intermediate links. (eli)

Release 0.21.1 - Unreleased

  IMPROVEMENTS

    HADOOP-6934. Test for ByteWritable comparator.
    (Johannes Zillmann via Eli Collins)

    HADOOP-6786. test-patch needs to verify Herriot integrity (cos)

    HADOOP-7177. CodecPool should report which compressor it is using.
    (Allen Wittenauer via eli)

  BUG FIXES

    HADOOP-6925. BZip2Codec incorrectly implements read(). 
    (Todd Lipcon via Eli Collins)

    HADOOP-6833. IPC leaks call parameters when exceptions thrown.
    (Todd Lipcon via Eli Collins)

    HADOOP-6971. Clover build doesn't generate per-test coverage (cos)

    HADOOP-6993. Broken link on cluster setup page of docs. (eli)

    HADOOP-6944. [Herriot] Implement a functionality for getting proxy users
    definitions like groups and hosts. (Vinay Thota via cos)

    HADOOP-6954.  Sources JARs are not correctly published to the Maven
    repository. (tomwhite)

    HADOOP-7052. misspelling of threshold in conf/log4j.properties.
    (Jingguo Yao via eli)

    HADOOP-7053. wrong FSNamesystem Audit logging setting in 
    conf/log4j.properties. (Jingguo Yao via eli)

    HADOOP-7120. Fix a syntax error in test-patch.sh.  (szetszwo)

    HADOOP-7162. Rmove a duplicated call FileSystem.listStatus(..) in FsShell.
    (Alexey Diomin via szetszwo)

    HADOOP-7117. Remove fs.checkpoint.* from core-default.xml and replace
    fs.checkpoint.* with dfs.namenode.checkpoint.* in documentations.
    (Harsh J Chouraria via szetszwo)

    HADOOP-7193. Correct the "fs -touchz" command help message.
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7174. Null is displayed in the "fs -copyToLocal" command.
    (Uma Maheswara Rao G via szetszwo)

    HADOOP-7194. Fix resource leak in IOUtils.copyBytes(..).
    (Devaraj K via szetszwo)

    HADOOP-7183. WritableComparator.get should not cache comparator objects.
    (tomwhite via eli)

Release 0.21.0 - 2010-08-13

  INCOMPATIBLE CHANGES

    HADOOP-4895. Remove deprecated methods DFSClient.getHints(..) and
    DFSClient.isDirectory(..).  (szetszwo)

    HADOOP-4941. Remove deprecated FileSystem methods: getBlockSize(Path f),
    getLength(Path f) and getReplication(Path src).  (szetszwo)

    HADOOP-4648. Remove obsolete, deprecated InMemoryFileSystem and
    ChecksumDistributedFileSystem.  (cdouglas via szetszwo)

    HADOOP-4940. Remove a deprecated method FileSystem.delete(Path f).  (Enis
    Soztutar via szetszwo)

    HADOOP-4010. Change semantics for LineRecordReader to read an additional
    line per split- rather than moving back one character in the stream- to
    work with splittable compression codecs. (Abdul Qadeer via cdouglas)

    HADOOP-5094. Show hostname and separate live/dead datanodes in DFSAdmin
    report.  (Jakob Homan via szetszwo)

    HADOOP-4942. Remove deprecated FileSystem methods getName() and
    getNamed(String name, Configuration conf).  (Jakob Homan via szetszwo)

    HADOOP-5486. Removes the CLASSPATH string from the command line and instead
    exports it in the environment. (Amareshwari Sriramadasu via ddas)

    HADOOP-2827. Remove deprecated NetUtils::getServerAddress. (cdouglas)

    HADOOP-5681. Change examples RandomWriter and RandomTextWriter to 
    use new mapreduce API. (Amareshwari Sriramadasu via sharad)

    HADOOP-5680. Change org.apache.hadoop.examples.SleepJob to use new 
    mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5699. Change org.apache.hadoop.examples.PiEstimator to use 
    new mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5720. Introduces new task types - JOB_SETUP, JOB_CLEANUP
    and TASK_CLEANUP. Removes the isMap methods from TaskID/TaskAttemptID
    classes. (ddas)

    HADOOP-5668. Change TotalOrderPartitioner to use new API. (Amareshwari
    Sriramadasu via cdouglas)

    HADOOP-5738. Split "waiting_tasks" JobTracker metric into waiting maps and
    waiting reduces. (Sreekanth Ramakrishnan via cdouglas)

    HADOOP-5679. Resolve findbugs warnings in core/streaming/pipes/examples. 
    (Jothi Padmanabhan via sharad)

    HADOOP-4359. Support for data access authorization checking on Datanodes.
    (Kan Zhang via rangadi)

    HADOOP-5690. Change org.apache.hadoop.examples.DBCountPageView to use 
    new mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5694. Change org.apache.hadoop.examples.dancing to use new 
    mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5696. Change org.apache.hadoop.examples.Sort to use new 
    mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5698. Change org.apache.hadoop.examples.MultiFileWordCount to 
    use new mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5913. Provide ability to an administrator to stop and start
    job queues. (Rahul Kumar Singh and Hemanth Yamijala via yhemanth)

    MAPREDUCE-711. Removed Distributed Cache from Common, to move it
    under Map/Reduce. (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-6201. Change FileSystem::listStatus contract to throw
    FileNotFoundException if the directory does not exist, rather than letting
    this be implementation-specific. (Jakob Homan via cdouglas)

    HADOOP-6230. Moved process tree and memory calculator related classes
    from Common to Map/Reduce. (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-6203. FsShell rm/rmr error message indicates exceeding Trash quota
    and suggests using -skpTrash, when moving to trash fails.
    (Boris Shkolnik via suresh)

    HADOOP-6303. Eclipse .classpath template has outdated jar files and is
    missing some new ones.  (cos)

    HADOOP-6396. Fix uninformative exception message when unable to parse
    umask. (jghoman)

    HADOOP-6299. Reimplement the UserGroupInformation to use the OS
    specific and Kerberos JAAS login. (omalley)

    HADOOP-6686. Remove redundant exception class name from the exception
    message for the exceptions thrown at RPC client. (suresh)

    HADOOP-6701. Fix incorrect exit codes returned from chmod, chown and chgrp
    commands from FsShell. (Ravi Phulari via suresh)

  NEW FEATURES

    HADOOP-6332. Large-scale Automated Test Framework. (sharad, Sreekanth
    Ramakrishnan, at all via cos)

    HADOOP-4268. Change fsck to use ClientProtocol methods so that the
    corresponding permission requirement for running the ClientProtocol
    methods will be enforced.  (szetszwo)

    HADOOP-3953. Implement sticky bit for directories in HDFS. (Jakob Homan
    via szetszwo)

    HADOOP-4368. Implement df in FsShell to show the status of a FileSystem.
    (Craig Macdonald via szetszwo)

    HADOOP-3741. Add a web ui to the SecondaryNameNode for showing its status.
    (szetszwo)

    HADOOP-5018. Add pipelined writers to Chukwa. (Ari Rabkin via cdouglas)

    HADOOP-5052. Add an example computing exact digits of pi using the
    Bailey-Borwein-Plouffe algorithm. (Tsz Wo (Nicholas), SZE via cdouglas)

    HADOOP-4927. Adds a generic wrapper around outputformat to allow creation of
    output on demand (Jothi Padmanabhan via ddas)

    HADOOP-5144. Add a new DFSAdmin command for changing the setting of restore
    failed storage replicas in namenode. (Boris Shkolnik via szetszwo)

    HADOOP-5258. Add a new DFSAdmin command to print a tree of the rack and
    datanode topology as seen by the namenode.  (Jakob Homan via szetszwo)
    
    HADOOP-4756. A command line tool to access JMX properties on NameNode
    and DataNode. (Boris Shkolnik via rangadi)

    HADOOP-4539. Introduce backup node and checkpoint node. (shv)

    HADOOP-5363. Add support for proxying connections to multiple clusters with
    different versions to hdfsproxy. (Zhiyong Zhang via cdouglas)

    HADOOP-5528. Add a configurable hash partitioner operating on ranges of
    BinaryComparable keys. (Klaas Bosteels via shv)

    HADOOP-5257. HDFS servers may start and stop external components through
    a plugin interface. (Carlos Valiente via dhruba)

    HADOOP-5450. Add application-specific data types to streaming's typed bytes
    interface. (Klaas Bosteels via omalley)

    HADOOP-5518. Add contrib/mrunit, a MapReduce unit test framework.
    (Aaron Kimball via cutting)

    HADOOP-5469.  Add /metrics servlet to daemons, providing metrics
    over HTTP as either text or JSON.  (Philip Zeyliger via cutting)

    HADOOP-5467. Introduce offline fsimage image viewer. (Jakob Homan via shv)

    HADOOP-5752. Add a new hdfs image processor, Delimited, to oiv. (Jakob
    Homan via szetszwo)

    HADOOP-5266. Adds the capability to do mark/reset of the reduce values 
    iterator in the Context object API. (Jothi Padmanabhan via ddas)

    HADOOP-5745. Allow setting the default value of maxRunningJobs for all
    pools. (dhruba via matei)

    HADOOP-5643. Adds a way to decommission TaskTrackers while the JobTracker
    is running. (Amar Kamat via ddas)

    HADOOP-4829. Allow FileSystem shutdown hook to be disabled.
    (Todd Lipcon via tomwhite)

    HADOOP-5815. Sqoop: A database import tool for Hadoop.
    (Aaron Kimball via tomwhite)

    HADOOP-4861. Add disk usage with human-readable size (-duh).
    (Todd Lipcon via tomwhite)

    HADOOP-5844. Use mysqldump when connecting to local mysql instance in Sqoop.
    (Aaron Kimball via tomwhite)

    HADOOP-5976. Add a new command, classpath, to the hadoop script.  (Owen
    O'Malley and Gary Murry via szetszwo)

    HADOOP-6120. Add support for Avro specific and reflect data.
    (sharad via cutting)

    HADOOP-6226. Moves BoundedByteArrayOutputStream from the tfile package to
    the io package and makes it available to other users (MAPREDUCE-318). 
    (Jothi Padmanabhan via ddas)

    HADOOP-6105. Adds support for automatically handling deprecation of
    configuration keys. (V.V.Chaitanya Krishna via yhemanth)
    
    HADOOP-6235. Adds new method to FileSystem for clients to get server
    defaults. (Kan Zhang via suresh)

    HADOOP-6234. Add new option dfs.umaskmode to set umask in configuration
    to use octal or symbolic instead of decimal. (Jakob Homan via suresh)

    HADOOP-5073. Add annotation mechanism for interface classification.
    (Jakob Homan via suresh)

    HADOOP-4012. Provide splitting support for bzip2 compressed files. (Abdul
    Qadeer via cdouglas)

    HADOOP-6246. Add backward compatibility support to use deprecated decimal 
    umask from old configuration. (Jakob Homan via suresh)

    HADOOP-4952. Add new improved file system interface FileContext for the
    application writer (Sanjay Radia via suresh)

    HADOOP-6170. Add facility to tunnel Avro RPCs through Hadoop RPCs.
    This permits one to take advantage of both Avro's RPC versioning
    features and Hadoop's proven RPC scalability.  (cutting)

    HADOOP-6267. Permit building contrib modules located in external
    source trees.  (Todd Lipcon via cutting)

    HADOOP-6240. Add new FileContext rename operation that posix compliant
    that allows overwriting existing destination. (suresh)

    HADOOP-6204. Implementing aspects development and fault injeciton
    framework for Hadoop (cos)

    HADOOP-6313. Implement Syncable interface in FSDataOutputStream to expose
    flush APIs to application users. (Hairong Kuang via suresh)

    HADOOP-6284. Add a new parameter, HADOOP_JAVA_PLATFORM_OPTS, to
    hadoop-config.sh so that it allows setting java command options for
    JAVA_PLATFORM.  (Koji Noguchi via szetszwo)

    HADOOP-6337. Updates FilterInitializer class to be more visible,
    and the init of the class is made to take a Configuration argument.
    (Jakob Homan via ddas)

    Hadoop-6223. Add new file system interface AbstractFileSystem with
    implementation of some file systems that delegate to old FileSystem.
    (Sanjay Radia via suresh)

    HADOOP-6433. Introduce asychronous deletion of files via a pool of
    threads. This can be used to delete files in the Distributed
    Cache. (Zheng Shao via dhruba)

    HADOOP-6415. Adds a common token interface for both job token and 
    delegation token. (Kan Zhang via ddas)

    HADOOP-6408. Add a /conf servlet to dump running configuration.
    (Todd Lipcon via tomwhite)

    HADOOP-6520. Adds APIs to read/write Token and secret keys. Also
    adds the automatic loading of tokens into UserGroupInformation
    upon login. The tokens are read from a file specified in the
    environment variable. (ddas)

    HADOOP-6419. Adds SASL based authentication to RPC.
    (Kan Zhang via ddas)

    HADOOP-6510. Adds a way for superusers to impersonate other users
    in a secure environment. (Jitendra Nath Pandey via ddas)

    HADOOP-6421. Adds Symbolic links to FileContext, AbstractFileSystem.
    It also adds a limited implementation for the local file system
     (RawLocalFs) that allows local symlinks. (Eli Collins via Sanjay Radia)

    HADOOP-6577. Add hidden configuration option "ipc.server.max.response.size"
    to change the default 1 MB, the maximum size when large IPC handler 
    response buffer is reset. (suresh)

    HADOOP-6568. Adds authorization for the default servlets. 
    (Vinod Kumar Vavilapalli via ddas)

    HADOOP-6586. Log authentication and authorization failures and successes
    for RPC (boryas)

    HADOOP-6580. UGI should contain authentication method. (jnp via boryas)
    
    HADOOP-6657. Add a capitalization method to StringUtils for MAPREDUCE-1545.
    (Luke Lu via Steve Loughran)

    HADOOP-6692. Add FileContext#listStatus that returns an iterator.
    (hairong)

    HADOOP-6869. Functionality to create file or folder on a remote daemon
    side (Vinay Thota via cos)

  IMPROVEMENTS

    HADOOP-6798. Align Ivy version for all Hadoop subprojects. (cos)

    HADOOP-6777. Implement a functionality for suspend and resume a process.
    (Vinay Thota via cos)

    HADOOP-6772. Utilities for system tests specific. (Vinay Thota via cos)

    HADOOP-6771. Herriot's artifact id for Maven deployment should be set to
    hadoop-core-instrumented (cos)

    HADOOP-6752. Remote cluster control functionality needs JavaDocs
    improvement (Balaji Rajagopalan via cos).

    HADOOP-4565. Added CombineFileInputFormat to use data locality information
    to create splits. (dhruba via zshao)

    HADOOP-4936. Improvements to TestSafeMode. (shv)

    HADOOP-4985. Remove unnecessary "throw IOException" declarations in
    FSDirectory related methods.  (szetszwo)

    HADOOP-5017. Change NameNode.namesystem declaration to private.  (szetszwo)

    HADOOP-4794. Add branch information from the source version control into
    the version information that is compiled into Hadoop. (cdouglas via 
    omalley)

    HADOOP-5070. Increment copyright year to 2009, remove assertions of ASF
    copyright to licensed files. (Tsz Wo (Nicholas), SZE via cdouglas)

    HADOOP-5037. Deprecate static FSNamesystem.getFSNamesystem().  (szetszwo)

    HADOOP-5088. Include releaseaudit target as part of developer test-patch
    target.  (Giridharan Kesavan via nigel)

    HADOOP-2721. Uses setsid when creating new tasks so that subprocesses of 
    this process will be within this new session (and this process will be 
    the process leader for all the subprocesses). Killing the process leader,
    or the main Java task in Hadoop's case, kills the entire subtree of
    processes. (Ravi Gummadi via ddas)

    HADOOP-5097. Remove static variable JspHelper.fsn, a static reference to
    a non-singleton FSNamesystem object.  (szetszwo)

    HADOOP-3327. Improves handling of READ_TIMEOUT during map output copying.
    (Amareshwari Sriramadasu via ddas)

    HADOOP-5124. Choose datanodes randomly instead of starting from the first
    datanode for providing fairness.  (hairong via szetszwo)

    HADOOP-4930. Implement a Linux native executable that can be used to 
    launch tasks as users. (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5122. Fix format of fs.default.name value in libhdfs test conf.
    (Craig Macdonald via tomwhite)

    HADOOP-5038. Direct daemon trace to debug log instead of stdout. (Jerome
    Boulon via cdouglas)

    HADOOP-5101. Improve packaging by adding 'all-jars' target building core,
    tools, and example jars. Let findbugs depend on this rather than the 'tar'
    target. (Giridharan Kesavan via cdouglas)

    HADOOP-4868. Splits the hadoop script into three parts - bin/hadoop, 
    bin/mapred and bin/hdfs. (Sharad Agarwal via ddas)

    HADOOP-1722. Adds support for TypedBytes and RawBytes in Streaming.
    (Klaas Bosteels via ddas)

    HADOOP-4220. Changes the JobTracker restart tests so that they take much
    less time. (Amar Kamat via ddas)

    HADOOP-4885. Try to restore failed name-node storage directories at 
    checkpoint time. (Boris Shkolnik via shv)

    HADOOP-5209. Update year to 2009 for javadoc.  (szetszwo)

    HADOOP-5279. Remove unnecessary targets from test-patch.sh.
    (Giridharan Kesavan via nigel)

    HADOOP-5120. Remove the use of FSNamesystem.getFSNamesystem() from 
    UpgradeManagerNamenode and UpgradeObjectNamenode.  (szetszwo)

    HADOOP-5222. Add offset to datanode clienttrace. (Lei Xu via cdouglas)

    HADOOP-5240. Skip re-building javadoc when it is already
    up-to-date. (Aaron Kimball via cutting)

    HADOOP-5042. Add a cleanup stage to log rollover in Chukwa appender.
    (Jerome Boulon via cdouglas)

    HADOOP-5264. Removes redundant configuration object from the TaskTracker.
    (Sharad Agarwal via ddas)

    HADOOP-5232. Enable patch testing to occur on more than one host.
    (Giri Kesavan via nigel)

    HADOOP-4546. Fix DF reporting for AIX. (Bill Habermaas via cdouglas)

    HADOOP-5023. Add Tomcat support to HdfsProxy. (Zhiyong Zhang via cdouglas)
    
    HADOOP-5317. Provide documentation for LazyOutput Feature. 
    (Jothi Padmanabhan via johan)

    HADOOP-5455. Document rpc metrics context to the extent dfs, mapred, and
    jvm contexts are documented. (Philip Zeyliger via cdouglas)

    HADOOP-5358. Provide scripting functionality to the synthetic load
    generator. (Jakob Homan via hairong)

    HADOOP-5442. Paginate jobhistory display and added some search
    capabilities. (Amar Kamat via acmurthy) 

    HADOOP-4842. Streaming now allows specifiying a command for the combiner.
    (Amareshwari Sriramadasu via ddas)

    HADOOP-5196. avoiding unnecessary byte[] allocation in 
    SequenceFile.CompressedBytes and SequenceFile.UncompressedBytes.
    (hong tang via mahadev)

    HADOOP-4655. New method FileSystem.newInstance() that always returns
    a newly allocated FileSystem object. (dhruba)

    HADOOP-4788. Set Fair scheduler to assign both a map and a reduce on each
    heartbeat by default. (matei)

    HADOOP-5491.  In contrib/index, better control memory usage.
    (Ning Li via cutting)

    HADOOP-5423. Include option of preserving file metadata in
    SequenceFile::sort. (Michael Tamm via cdouglas)

    HADOOP-5331. Add support for KFS appends. (Sriram Rao via cdouglas)

    HADOOP-4365. Make Configuration::getProps protected in support of
    meaningful subclassing. (Steve Loughran via cdouglas)

    HADOOP-2413. Remove the static variable FSNamesystem.fsNamesystemObject.
    (Konstantin Shvachko via szetszwo)

    HADOOP-4584. Improve datanode block reports and associated file system
    scan to avoid interefering with normal datanode operations.
    (Suresh Srinivas via rangadi)

    HADOOP-5502. Documentation for backup and checkpoint nodes.
    (Jakob Homan via shv)

    HADOOP-5485. Mask actions in the fair scheduler's servlet UI based on
    value of webinterface.private.actions. 
    (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-5581. HDFS should throw FileNotFoundException when while opening
    a file that does not exist. (Brian Bockelman via rangadi)

    HADOOP-5509. PendingReplicationBlocks does not start monitor in the
    constructor. (shv)

    HADOOP-5494. Modify sorted map output merger to lazily read values,
    rather than buffering at least one record for each segment. (Devaraj Das
    via cdouglas)

    HADOOP-5396. Provide ability to refresh queue ACLs in the JobTracker
    without having to restart the daemon.
    (Sreekanth Ramakrishnan and Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-4490. Provide ability to run tasks as job owners.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5697. Change org.apache.hadoop.examples.Grep to use new 
    mapreduce api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5625. Add operation duration to clienttrace. (Lei Xu via cdouglas)

    HADOOP-5705. Improve TotalOrderPartitioner efficiency by updating the trie
    construction. (Dick King via cdouglas)

    HADOOP-5589. Eliminate source limit of 64 for map-side joins imposed by
    TupleWritable encoding. (Jingkei Ly via cdouglas)

    HADOOP-5734. Correct block placement policy description in HDFS
    Design document. (Konstantin Boudnik via shv)

    HADOOP-5657. Validate data in TestReduceFetch to improve merge test
    coverage. (cdouglas)

    HADOOP-5613. Change S3Exception to checked exception.
    (Andrew Hitchcock via tomwhite)

    HADOOP-5717. Create public enum class for the Framework counters in 
    org.apache.hadoop.mapreduce. (Amareshwari Sriramadasu via sharad)

    HADOOP-5217. Split AllTestDriver for core, hdfs and mapred. (sharad)

    HADOOP-5364. Add certificate expiration warning to HsftpFileSystem and HDFS
    proxy. (Zhiyong Zhang via cdouglas)

    HADOOP-5733. Add map/reduce slot capacity and blacklisted capacity to
    JobTracker metrics. (Sreekanth Ramakrishnan via cdouglas)

    HADOOP-5596. Add EnumSetWritable. (He Yongqiang via szetszwo)

    HADOOP-5727. Simplify hashcode for ID types. (Shevek via cdouglas)

    HADOOP-5500. In DBOutputFormat, where field names are absent permit the
    number of fields to be sufficient to construct the select query. (Enis
    Soztutar via cdouglas)

    HADOOP-5081. Split TestCLI into HDFS, Mapred and Core tests. (sharad)

    HADOOP-5015. Separate block management code from FSNamesystem.  (Suresh
    Srinivas via szetszwo)

    HADOOP-5080. Add new test cases to TestMRCLI and TestHDFSCLI
    (V.Karthikeyan via nigel)

    HADOOP-5135. Splits the tests into different directories based on the 
    package. Four new test targets have been defined - run-test-core, 
    run-test-mapred, run-test-hdfs and run-test-hdfs-with-mr.
    (Sharad Agarwal via ddas)

    HADOOP-5771. Implements unit tests for LinuxTaskController.
    (Sreekanth Ramakrishnan and Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-5419. Provide a facility to query the Queue ACLs for the
    current user.
    (Rahul Kumar Singh via yhemanth)

    HADOOP-5780. Improve per block message prited by "-metaSave" in HDFS.
    (Raghu Angadi)

    HADOOP-5823. Added a new class DeprecatedUTF8 to help with removing
    UTF8 related javac warnings. These warnings are removed in 
    FSEditLog.java as a use case. (Raghu Angadi)

    HADOOP-5824. Deprecate DataTransferProtocol.OP_READ_METADATA and remove
    the corresponding unused codes.  (Kan Zhang via szetszwo)

    HADOOP-5721. Factor out EditLogFileInputStream and EditLogFileOutputStream
    into independent classes. (Luca Telloli & Flavio Junqueira via shv)

    HADOOP-5838. Fix a few javac warnings in HDFS. (Raghu Angadi)

    HADOOP-5854. Fix a few "Inconsistent Synchronization" warnings in HDFS.
    (Raghu Angadi)

    HADOOP-5369. Small tweaks to reduce MapFile index size. (Ben Maurer 
    via sharad)

    HADOOP-5858. Eliminate UTF8 and fix warnings in test/hdfs-with-mr package.
    (shv)

    HADOOP-5866. Move DeprecatedUTF8 from o.a.h.io to o.a.h.hdfs since it may
    not be used outside hdfs. (Raghu Angadi)

    HADOOP-5857. Move normal java methods from hdfs .jsp files to .java files.
    (szetszwo)

    HADOOP-5873. Remove deprecated methods randomDataNode() and
    getDatanodeByIndex(..) in FSNamesystem.  (szetszwo)

    HADOOP-5572. Improves the progress reporting for the sort phase for both
    maps and reduces. (Ravi Gummadi via ddas)

    HADOOP-5839. Fix EC2 scripts to allow remote job submission.
    (Joydeep Sen Sarma via tomwhite)

    HADOOP-5877. Fix javac warnings in TestHDFSServerPorts, TestCheckpoint, 
    TestNameEditsConfig, TestStartup and TestStorageRestore.
    (Jakob Homan via shv)

    HADOOP-5438. Provide a single FileSystem method to create or 
    open-for-append to a file.  (He Yongqiang via dhruba)

    HADOOP-5472. Change DistCp to support globbing of input paths.  (Dhruba
    Borthakur and Rodrigo Schmidt via szetszwo)

    HADOOP-5175. Don't unpack libjars on classpath. (Todd Lipcon via tomwhite)

    HADOOP-5620. Add an option to DistCp for preserving modification and access
    times.  (Rodrigo Schmidt via szetszwo)

    HADOOP-5664. Change map serialization so a lock is obtained only where
    contention is possible, rather than for each write. (cdouglas)

    HADOOP-5896. Remove the dependency of GenericOptionsParser on 
    Option.withArgPattern. (Giridharan Kesavan and Sharad Agarwal via 
    sharad)

    HADOOP-5784. Makes the number of heartbeats that should arrive a second
    at the JobTracker configurable. (Amareshwari Sriramadasu via ddas)

    HADOOP-5955. Changes TestFileOuputFormat so that is uses LOCAL_MR
    instead of CLUSTER_MR. (Jothi Padmanabhan via das)

    HADOOP-5948. Changes TestJavaSerialization to use LocalJobRunner 
    instead of MiniMR/DFS cluster. (Jothi Padmanabhan via das)

    HADOOP-2838. Add mapred.child.env to pass environment variables to 
    tasktracker's child processes. (Amar Kamat via sharad)

    HADOOP-5961. DataNode process understand generic hadoop command line
    options (like -Ddfs.property=value). (Raghu Angadi)

    HADOOP-5938. Change org.apache.hadoop.mapred.jobcontrol to use new
    api. (Amareshwari Sriramadasu via sharad)

    HADOOP-2141. Improves the speculative execution heuristic. The heuristic
    is currently based on the progress-rates of tasks and the expected time
    to complete. Also, statistics about trackers are collected, and speculative
    tasks are not given to the ones deduced to be slow. 
    (Andy Konwinski and ddas)

    HADOOP-5952. Change "-1 tests included" wording in test-patch.sh.
    (Gary Murry via szetszwo)

    HADOOP-6106. Provides an option in ShellCommandExecutor to timeout 
    commands that do not complete within a certain amount of time.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5925. EC2 scripts should exit on error. (tomwhite)

    HADOOP-6109. Change Text to grow its internal buffer exponentially, rather
    than the max of the current length and the proposed length to improve
    performance reading large values. (thushara wijeratna via cdouglas)

    HADOOP-2366. Support trimmed strings in Configuration.  (Michele Catasta
    via szetszwo)

    HADOOP-6099. The RPC module can be configured to not send period pings.
    The default behaviour of sending periodic pings remain unchanged. (dhruba)

    HADOOP-6142. Update documentation and use of harchives for relative paths
    added in MAPREDUCE-739. (Mahadev Konar via cdouglas)

    HADOOP-6148. Implement a fast, pure Java CRC32 calculator which outperforms
    java.util.zip.CRC32.  (Todd Lipcon and Scott Carey via szetszwo)

    HADOOP-6146. Upgrade to JetS3t version 0.7.1. (tomwhite)

    HADOOP-6161. Add get/setEnum methods to Configuration. (cdouglas)

    HADOOP-6160. Fix releaseaudit target to run on specific directories.
    (gkesavan)
    
    HADOOP-6169. Removing deprecated method calls in TFile. (hong tang via 
    mahadev)

    HADOOP-6176. Add a couple package private methods to AccessTokenHandler
    for testing.  (Kan Zhang via szetszwo)

    HADOOP-6182. Fix ReleaseAudit warnings (Giridharan Kesavan and Lee Tucker
    via gkesavan)

    HADOOP-6173. Change src/native/packageNativeHadoop.sh to package all
    native library files.  (Hong Tang via szetszwo)

    HADOOP-6184. Provide an API to dump Configuration in a JSON format.
    (V.V.Chaitanya Krishna via yhemanth)

    HADOOP-6224. Add a method to WritableUtils performing a bounded read of an
    encoded String. (Jothi Padmanabhan via cdouglas)

    HADOOP-6133. Add a caching layer to Configuration::getClassByName to
    alleviate a performance regression introduced in a compatibility layer.
    (Todd Lipcon via cdouglas)

    HADOOP-6252. Provide a method to determine if a deprecated key is set in
    config file. (Jakob Homan via suresh)

    HADOOP-5879. Read compression level and strategy from Configuration for
    gzip compression. (He Yongqiang via cdouglas)

    HADOOP-6216. Support comments in host files.  (Ravi Phulari and Dmytro
    Molkov via szetszwo)

    HADOOP-6217. Update documentation for project split. (Corinne Chandel via 
    omalley)

    HADOOP-6268. Add ivy jar to .gitignore. (Todd Lipcon via cdouglas)

    HADOOP-6270. Support deleteOnExit in FileContext.  (Suresh Srinivas via
    szetszwo)

    HADOOP-6233. Rename configuration keys towards API standardization and
    backward compatibility. (Jithendra Pandey via suresh)

    HADOOP-6260. Add additional unit tests for FileContext util methods.
    (Gary Murry via suresh).

    HADOOP-6309. Change build.xml to run tests with java asserts.  (Eli
    Collins via szetszwo)

    HADOOP-6326. Hundson runs should check for AspectJ warnings and report
    failure if any is present (cos)

    HADOOP-6329. Add build-fi directory to the ignore lists.  (szetszwo)

    HADOOP-5107. Use Maven ant tasks to publish the subproject jars.
    (Giridharan Kesavan via omalley)

    HADOOP-6343. Log unexpected throwable object caught in RPC.  (Jitendra Nath
    Pandey via szetszwo)

    HADOOP-6367. Removes Access Token implementation from common.
    (Kan Zhang via ddas)

    HADOOP-6395. Upgrade some libraries to be consistent across common, hdfs,
    and mapreduce. (omalley)

    HADOOP-6398. Build is broken after HADOOP-6395 patch has been applied (cos)

    HADOOP-6413. Move TestReflectionUtils to Common. (Todd Lipcon via tomwhite)

    HADOOP-6283. Improve the exception messages thrown by
    FileUtil$HardLink.getLinkCount(..).  (szetszwo)

    HADOOP-6279. Add Runtime::maxMemory to JVM metrics. (Todd Lipcon via
    cdouglas)

    HADOOP-6305. Unify build property names to facilitate cross-projects
    modifications (cos)

    HADOOP-6312. Remove unnecessary debug logging in Configuration constructor.
    (Aaron Kimball via cdouglas)

    HADOOP-6366. Reduce ivy console output to ovservable level (cos)

    HADOOP-6400. Log errors getting Unix UGI. (Todd Lipcon via tomwhite)

    HADOOP-6346. Add support for specifying unpack pattern regex to
    RunJar.unJar. (Todd Lipcon via tomwhite)

    HADOOP-6422. Make RPC backend plugable, protocol-by-protocol, to
    ease evolution towards Avro.  (cutting)

    HADOOP-5958. Use JDK 1.6 File APIs in DF.java wherever possible.
    (Aaron Kimball via tomwhite)

    HADOOP-6222. Core doesn't have TestCommonCLI facility. (cos)

    HADOOP-6394. Add a helper class to simplify FileContext related tests and
    improve code reusability. (Jitendra Nath Pandey via suresh)

    HADOOP-4656. Add a user to groups mapping service. (boryas, acmurthy)

    HADOOP-6435. Make RPC.waitForProxy with timeout public. (Steve Loughran
    via tomwhite)
  
    HADOOP-6472. add tokenCache option to GenericOptionsParser for passing
     file with secret keys to a map reduce job. (boryas)

    HADOOP-3205. Read multiple chunks directly from FSInputChecker subclass
    into user buffers. (Todd Lipcon via tomwhite)

    HADOOP-6479. TestUTF8 assertions could fail with better text.
    (Steve Loughran via tomwhite)

    HADOOP-6155. Deprecate RecordIO anticipating Avro. (Tom White via cdouglas)

    HADOOP-6492. Make some Avro serialization APIs public.
    (Aaron Kimball via cutting)

    HADOOP-6497. Add an adapter for Avro's SeekableInput interface, so
    that Avro can read FileSystem data.
    (Aaron Kimball via cutting)

    HADOOP-6495.  Identifier should be serialized after the password is
     created In Token constructor (jnp via boryas)

    HADOOP-6518. Makes the UGI honor the env var KRB5CCNAME. 
    (Owen O'Malley via ddas)

    HADOOP-6531. Enhance FileUtil with an API to delete all contents of a
    directory. (Amareshwari Sriramadasu via yhemanth)

    HADOOP-6547. Move DelegationToken into Common, so that it can be used by
    MapReduce also. (devaraj via omalley)

    HADOOP-6552. Puts renewTGT=true and useTicketCache=true for the keytab
    kerberos options. (ddas)

    HADOOP-6534. Trim whitespace from directory lists initializing
    LocalDirAllocator. (Todd Lipcon via cdouglas)

    HADOOP-6559. Makes the RPC client automatically re-login when the SASL 
    connection setup fails. This is applicable only to keytab based logins.
    (Devaraj Das)

    HADOOP-6551. Delegation token renewing and cancelling should provide
    meaningful exceptions when there are failures instead of returning 
    false. (omalley)

    HADOOP-6583. Captures authentication and authorization metrics. (ddas)

    HADOOP-6543. Allows secure clients to talk to unsecure clusters. 
    (Kan Zhang via ddas)

    HADOOP-6579. Provide a mechanism for encoding/decoding Tokens from
    a url-safe string and change the commons-code library to 1.4. (omalley)

    HADOOP-6596. Add a version field to the AbstractDelegationTokenIdentifier's
    serialized value. (omalley)

    HADOOP-6573. Support for persistent delegation tokens.
    (Jitendra Pandey via shv)

    HADOOP-6594. Provide a fetchdt tool via bin/hdfs. (jhoman via acmurthy) 

    HADOOP-6589. Provide better error messages when RPC authentication fails.
    (Kan Zhang via omalley)

    HADOOP-6599  Split existing RpcMetrics into RpcMetrics & RpcDetailedMetrics.
    (Suresh Srinivas via Sanjay Radia)

    HADOOP-6537 Declare more detailed exceptions in FileContext and 
    AbstractFileSystem (Suresh Srinivas via Sanjay Radia)

    HADOOP-6486. fix common classes to work with Avro 1.3 reflection.
    (cutting via tomwhite)

    HADOOP-6591. HarFileSystem can handle paths with the whitespace characters.
    (Rodrigo Schmidt via dhruba)

    HADOOP-6407. Have a way to automatically update Eclipse .classpath file
    when new libs are added to the classpath through Ivy. (tomwhite)

    HADOOP-3659. Patch to allow hadoop native to compile on Mac OS X.
    (Colin Evans and Allen Wittenauer via tomwhite)

    HADOOP-6471. StringBuffer -> StringBuilder - conversion of references
    as necessary. (Kay Kay via tomwhite)

    HADOOP-6646. Move HarfileSystem out of Hadoop Common. (mahadev)

    HADOOP-6566. Add methods supporting, enforcing narrower permissions on
    local daemon directories. (Arun Murthy and Luke Lu via cdouglas)

    HADOOP-6705. Fix to work with 1.5 version of jiracli
    (Giridharan Kesavan)

    HADOOP-6658. Exclude Private elements from generated Javadoc. (tomwhite)

    HADOOP-6635. Install/deploy source jars to Maven repo. 
    (Patrick Angeles via jghoman)

    HADOOP-6717. Log levels in o.a.h.security.Groups too high 
    (Todd Lipcon via jghoman)

    HADOOP-6667. RPC.waitForProxy should retry through NoRouteToHostException.
    (Todd Lipcon via tomwhite)

    HADOOP-6677. InterfaceAudience.LimitedPrivate should take a string not an
    enum. (tomwhite)

    HADOOP-678. Remove FileContext#isFile, isDirectory, and exists.
    (Eli Collins via hairong)

    HADOOP-6515. Make maximum number of http threads configurable.
    (Scott Chen via zshao)

    HADOOP-6563. Add more symlink tests to cover intermediate symlinks
    in paths. (Eli Collins via suresh)

    HADOOP-6585.  Add FileStatus#isDirectory and isFile.  (Eli Collins via
    tomwhite)

    HADOOP-6738.  Move cluster_setup.xml from MapReduce to Common.
    (Tom White via tomwhite)

    HADOOP-6794. Move configuration and script files post split. (tomwhite)

    HADOOP-6403.  Deprecate EC2 bash scripts.  (tomwhite)

    HADOOP-6769. Add an API in FileSystem to get FileSystem instances based 
    on users(ddas via boryas)

    HADOOP-6813. Add a new newInstance method in FileSystem that takes 
    a "user" as argument (ddas via boryas)

    HADOOP-6668.  Apply audience and stability annotations to classes in
    common.  (tomwhite)

    HADOOP-6821.  Document changes to memory monitoring.  (Hemanth Yamijala
    via tomwhite)

  OPTIMIZATIONS

    HADOOP-5595. NameNode does not need to run a replicator to choose a
    random DataNode. (hairong)

    HADOOP-5603. Improve NameNode's block placement performance. (hairong)

    HADOOP-5638. More improvement on block placement performance. (hairong)

    HADOOP-6180. NameNode slowed down when many files with same filename
    were moved to Trash. (Boris Shkolnik via hairong)

    HADOOP-6166. Further improve the performance of the pure-Java CRC32
    implementation. (Tsz Wo (Nicholas), SZE via cdouglas)

    HADOOP-6271. Add recursive and non recursive create and mkdir to 
    FileContext. (Sanjay Radia via suresh)

    HADOOP-6261. Add URI based tests for FileContext. 
    (Ravi Pulari via suresh).

    HADOOP-6307. Add a new SequenceFile.Reader constructor in order to support
    reading on un-closed file.  (szetszwo)

    HADOOP-6467. Improve the performance on HarFileSystem.listStatus(..).
    (mahadev via szetszwo)

    HADOOP-6569. FsShell#cat should avoid calling unecessary getFileStatus
    before opening a file to read. (hairong)

    HADOOP-6689. Add directory renaming test to existing FileContext tests.
    (Eli Collins via suresh)

    HADOOP-6713. The RPC server Listener thread is a scalability bottleneck.
    (Dmytro Molkov via hairong)

  BUG FIXES

    HADOOP-6748. Removes hadoop.cluster.administrators, cluster administrators
    acl is passed as parameter in constructor. (amareshwari) 

    HADOOP-6828. Herrior uses old way of accessing logs directories (Sreekanth
    Ramakrishnan via cos)

    HADOOP-6788. [Herriot] Exception exclusion functionality is not working
    correctly. (Vinay Thota via cos)

    HADOOP-6773. Ivy folder contains redundant files (cos)

    HADOOP-5379. CBZip2InputStream to throw IOException on data crc error.
    (Rodrigo Schmidt via zshao)

    HADOOP-5326. Fixes CBZip2OutputStream data corruption problem.
    (Rodrigo Schmidt via zshao)

    HADOOP-4963. Fixes a logging to do with getting the location of
    map output file. (Amareshwari Sriramadasu via ddas)

    HADOOP-2337. Trash should close FileSystem on exit and should not start 
    emtying thread if disabled. (shv)

    HADOOP-5072. Fix failure in TestCodec because testSequenceFileGzipCodec 
    won't pass without native gzip codec. (Zheng Shao via dhruba)

    HADOOP-5050. TestDFSShell.testFilePermissions should not assume umask
    setting.  (Jakob Homan via szetszwo)

    HADOOP-4975. Set classloader for nested mapred.join configs. (Jingkei Ly
    via cdouglas)

    HADOOP-5078. Remove invalid AMI kernel in EC2 scripts. (tomwhite)

    HADOOP-5045. FileSystem.isDirectory() should not be deprecated.  (Suresh
    Srinivas via szetszwo)

    HADOOP-4960. Use datasource time, rather than system time, during metrics
    demux. (Eric Yang via cdouglas)

    HADOOP-5032. Export conf dir set in config script. (Eric Yang via cdouglas)

    HADOOP-5176. Fix a typo in TestDFSIO.  (Ravi Phulari via szetszwo)

    HADOOP-4859. Distinguish daily rolling output dir by adding a timestamp.
    (Jerome Boulon via cdouglas)

    HADOOP-4959. Correct system metric collection from top on Redhat 5.1. (Eric
    Yang via cdouglas)

    HADOOP-5039. Fix log rolling regex to process only the relevant
    subdirectories. (Jerome Boulon via cdouglas)

    HADOOP-5095. Update Chukwa watchdog to accept config parameter. (Jerome
    Boulon via cdouglas)

    HADOOP-5147. Correct reference to agent list in Chukwa bin scripts. (Ari
    Rabkin via cdouglas)

    HADOOP-5148. Fix logic disabling watchdog timer in Chukwa daemon scripts.
    (Ari Rabkin via cdouglas)

    HADOOP-5100. Append, rather than truncate, when creating log4j metrics in
    Chukwa. (Jerome Boulon via cdouglas)

    HADOOP-5204. Fix broken trunk compilation on Hudson by letting 
    task-controller be an independent target in build.xml.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5212. Fix the path translation problem introduced by HADOOP-4868 
    running on cygwin. (Sharad Agarwal via omalley)

    HADOOP-5226. Add license headers to html and jsp files.  (szetszwo)

    HADOOP-5172. Disable misbehaving Chukwa unit test until it can be fixed.
    (Jerome Boulon via nigel)

    HADOOP-4933. Fixes a ConcurrentModificationException problem that shows up
    when the history viewer is accessed concurrently. 
    (Amar Kamat via ddas)

    HADOOP-5253. Remove duplicate call to cn-docs target. 
    (Giri Kesavan via nigel)

    HADOOP-5251. Fix classpath for contrib unit tests to include clover jar.
    (nigel)

    HADOOP-5206. Synchronize "unprotected*" methods of FSDirectory on the root.
    (Jakob Homan via shv)

    HADOOP-5292. Fix NPE in KFS::getBlockLocations. (Sriram Rao via lohit)

    HADOOP-5219. Adds a new property io.seqfile.local.dir for use by
    SequenceFile, which earlier used mapred.local.dir. (Sharad Agarwal
    via ddas)

    HADOOP-5300. Fix ant javadoc-dev target and the typo in the class name
    NameNodeActivtyMBean.  (szetszwo)

    HADOOP-5218.  libhdfs unit test failed because it was unable to 
    start namenode/datanode. Fixed. (dhruba)

    HADOOP-5273. Add license header to TestJobInProgress.java.  (Jakob Homan
    via szetszwo)
    
    HADOOP-5229. Remove duplicate version variables in build files
    (Stefan Groschupf via johan)

    HADOOP-5383. Avoid building an unused string in NameNode's 
    verifyReplication(). (Raghu Angadi)

    HADOOP-5347. Create a job output directory for the bbp examples. (szetszwo)

    HADOOP-5341. Make hadoop-daemon scripts backwards compatible with the
    changes in HADOOP-4868. (Sharad Agarwal via yhemanth)

    HADOOP-5456. Fix javadoc links to ClientProtocol#restoreFailedStorage(..).
    (Boris Shkolnik via szetszwo)

    HADOOP-5458. Remove leftover Chukwa entries from build, etc. (cdouglas)

    HADOOP-5386. Modify hdfsproxy unit test to start on a random port,
    implement clover instrumentation. (Zhiyong Zhang via cdouglas)

    HADOOP-5511. Add Apache License to EditLogBackupOutputStream. (shv)

    HADOOP-5507. Fix JMXGet javadoc warnings.  (Boris Shkolnik via szetszwo)

    HADOOP-5191. Accessing HDFS with any ip or hostname should work as long 
    as it points to the interface NameNode is listening on. (Raghu Angadi)

    HADOOP-5561. Add javadoc.maxmemory parameter to build, preventing OOM
    exceptions from javadoc-dev. (Jakob Homan via cdouglas)

    HADOOP-5149. Modify HistoryViewer to ignore unfamiliar files in the log
    directory. (Hong Tang via cdouglas)

    HADOOP-5477. Fix rare failure in TestCLI for hosts returning variations of
    'localhost'. (Jakob Homan via cdouglas)

    HADOOP-5194. Disables setsid for tasks run on cygwin. 
    (Ravi Gummadi via ddas)

    HADOOP-5322. Fix misleading/outdated comments in JobInProgress.
    (Amareshwari Sriramadasu via cdouglas)

    HADOOP-5198. Fixes a problem to do with the task PID file being absent and 
    the JvmManager trying to look for it. (Amareshwari Sriramadasu via ddas)

    HADOOP-5464. DFSClient did not treat write timeout of 0 properly.
    (Raghu Angadi)

    HADOOP-4045. Fix processing of IO errors in EditsLog.
    (Boris Shkolnik via shv)

    HADOOP-5462. Fixed a double free bug in the task-controller
    executable. (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5652. Fix a bug where in-memory segments are incorrectly retained in
    memory. (cdouglas)

    HADOOP-5533. Recovery duration shown on the jobtracker webpage is 
    inaccurate. (Amar Kamat via sharad)

    HADOOP-5647. Fix TestJobHistory to not depend on /tmp. (Ravi Gummadi 
    via sharad)

    HADOOP-5661. Fixes some findbugs warnings in o.a.h.mapred* packages and
    supresses a bunch of them. (Jothi Padmanabhan via ddas)

    HADOOP-5704. Fix compilation problems in TestFairScheduler and
    TestCapacityScheduler.  (Chris Douglas via szetszwo)

    HADOOP-5650. Fix safemode messages in the Namenode log.  (Suresh Srinivas
    via szetszwo)

    HADOOP-5488. Removes the pidfile management for the Task JVM from the
    framework and instead passes the PID back and forth between the
    TaskTracker and the Task processes. (Ravi Gummadi via ddas)

    HADOOP-5658. Fix Eclipse templates. (Philip Zeyliger via shv)

    HADOOP-5709. Remove redundant synchronization added in HADOOP-5661. (Jothi
    Padmanabhan via cdouglas)

    HADOOP-5715. Add conf/mapred-queue-acls.xml to the ignore lists.
    (szetszwo)

    HADOOP-5592. Fix typo in Streaming doc in reference to GzipCodec.
    (Corinne Chandel via tomwhite)

    HADOOP-5656. Counter for S3N Read Bytes does not work. (Ian Nowland
    via tomwhite)

    HADOOP-5406. Fix JNI binding for ZlibCompressor::setDictionary. (Lars
    Francke via cdouglas)

    HADOOP-3426. Fix/provide handling when DNS lookup fails on the loopback
    address. Also cache the result of the lookup. (Steve Loughran via cdouglas)

    HADOOP-5476. Close the underlying InputStream in SequenceFile::Reader when
    the constructor throws an exception. (Michael Tamm via cdouglas)

    HADOOP-5675. Do not launch a job if DistCp has no work to do. (Tsz Wo
    (Nicholas), SZE via cdouglas)

    HADOOP-5737. Fixes a problem in the way the JobTracker used to talk to
    other daemons like the NameNode to get the job's files. Also adds APIs
    in the JobTracker to get the FileSystem objects as per the JobTracker's
    configuration. (Amar Kamat via ddas) 

    HADOOP-5648. Not able to generate gridmix.jar on the already compiled 
    version of hadoop. (gkesavan)	

    HADOOP-5808. Fix import never used javac warnings in hdfs. (szetszwo)

    HADOOP-5203. TT's version build is too restrictive. (Rick Cox via sharad)

    HADOOP-5818. Revert the renaming from FSNamesystem.checkSuperuserPrivilege
    to checkAccess by HADOOP-5643.  (Amar Kamat via szetszwo)

    HADOOP-5820. Fix findbugs warnings for http related codes in hdfs.
    (szetszwo)

    HADOOP-5822. Fix javac warnings in several dfs tests related to unncessary
    casts.  (Jakob Homan via szetszwo)

    HADOOP-5842. Fix a few javac warnings under packages fs and util.
    (Hairong Kuang via szetszwo)

    HADOOP-5845. Build successful despite test failure on test-core target.
    (sharad)

    HADOOP-5314. Prevent unnecessary saving of the file system image during 
    name-node startup. (Jakob Homan via shv)

    HADOOP-5855. Fix javac warnings for DisallowedDatanodeException and
    UnsupportedActionException.  (szetszwo)

    HADOOP-5582. Fixes a problem in Hadoop Vaidya to do with reading
    counters from job history files. (Suhas Gogate via ddas)

    HADOOP-5829. Fix javac warnings found in ReplicationTargetChooser,
    FSImage, Checkpointer, SecondaryNameNode and a few other hdfs classes.
    (Suresh Srinivas via szetszwo)

    HADOOP-5835. Fix findbugs warnings found in Block, DataNode, NameNode and
    a few other hdfs classes.  (Suresh Srinivas via szetszwo)

    HADOOP-5853. Undeprecate HttpServer.addInternalServlet method.  (Suresh
    Srinivas via szetszwo)

    HADOOP-5801. Fixes the problem: If the hosts file is changed across restart
    then it should be refreshed upon recovery so that the excluded hosts are 
    lost and the maps are re-executed. (Amar Kamat via ddas)

    HADOOP-5841. Resolve findbugs warnings in DistributedFileSystem,
    DatanodeInfo, BlocksMap, DataNodeDescriptor.  (Jakob Homan via szetszwo)

    HADOOP-5878. Fix import and Serializable javac warnings found in hdfs jsp.
    (szetszwo)

    HADOOP-5782. Revert a few formatting changes introduced in HADOOP-5015.
    (Suresh Srinivas via rangadi)

    HADOOP-5687. NameNode throws NPE if fs.default.name is the default value.
    (Philip Zeyliger via shv)

    HADOOP-5867. Fix javac warnings found in NNBench and NNBenchWithoutMR.
    (Konstantin Boudnik via szetszwo)
    
    HADOOP-5728. Fixed FSEditLog.printStatistics IndexOutOfBoundsException.
    (Wang Xu via johan)

    HADOOP-5847. Fixed failing Streaming unit tests (gkesavan) 

    HADOOP-5252. Streaming overrides -inputformat option (Klaas Bosteels 
    via sharad)

    HADOOP-5710. Counter MAP_INPUT_BYTES missing from new mapreduce api. 
    (Amareshwari Sriramadasu via sharad)

    HADOOP-5809. Fix job submission, broken by errant directory creation.
    (Sreekanth Ramakrishnan and Jothi Padmanabhan via cdouglas)

    HADOOP-5635. Change distributed cache to work with other distributed file
    systems. (Andrew Hitchcock via tomwhite)

    HADOOP-5856. Fix "unsafe multithreaded use of DateFormat" findbugs warning
    in DataBlockScanner.  (Kan Zhang via szetszwo)

    HADOOP-4864. Fixes a problem to do with -libjars with multiple jars when
    client and cluster reside on different OSs. (Amareshwari Sriramadasu via 
    ddas)

    HADOOP-5623. Fixes a problem to do with status messages getting overwritten
    in streaming jobs. (Rick Cox and Jothi Padmanabhan via ddas)

    HADOOP-5895. Fixes computation of count of merged bytes for logging.
    (Ravi Gummadi via ddas)

    HADOOP-5805. problem using top level s3 buckets as input/output 
    directories. (Ian Nowland via tomwhite)
   
    HADOOP-5940. trunk eclipse-plugin build fails while trying to copy 
    commons-cli jar from the lib dir (Giridharan Kesavan via gkesavan)

    HADOOP-5864. Fix DMI and OBL findbugs in packages hdfs and metrics.
    (hairong)

    HADOOP-5935. Fix Hudson's release audit warnings link is broken. 
    (Giridharan Kesavan via gkesavan)

    HADOOP-5947. Delete empty TestCombineFileInputFormat.java

    HADOOP-5899. Move a log message in FSEditLog to the right place for
    avoiding unnecessary log.  (Suresh Srinivas via szetszwo)

    HADOOP-5944. Add Apache license header to BlockManager.java.  (Suresh
    Srinivas via szetszwo)

    HADOOP-5891. SecondaryNamenode is able to converse with the NameNode 
    even when the default value of dfs.http.address is not overridden.
    (Todd Lipcon via dhruba)

    HADOOP-5953. The isDirectory(..) and isFile(..) methods in KosmosFileSystem
    should not be deprecated.  (szetszwo)

    HADOOP-5954. Fix javac warnings in TestFileCreation, TestSmallBlock,
    TestFileStatus, TestDFSShellGenericOptions, TestSeekBug and
    TestDFSStartupVersions.  (szetszwo)

    HADOOP-5956. Fix ivy dependency in hdfsproxy and capacity-scheduler.
    (Giridharan Kesavan via szetszwo)

    HADOOP-5836. Bug in S3N handling of directory markers using an object with
    a trailing "/" causes jobs to fail. (Ian Nowland via tomwhite)

    HADOOP-5861. s3n files are not getting split by default. (tomwhite)

    HADOOP-5762. Fix a problem that DistCp does not copy empty directory.
    (Rodrigo Schmidt via szetszwo)

    HADOOP-5859. Fix "wait() or sleep() with locks held" findbugs warnings in
    DFSClient.  (Kan Zhang via szetszwo)
   
    HADOOP-5457. Fix to continue to run builds even if contrib test fails
    (Giridharan Kesavan via gkesavan)

    HADOOP-5963. Remove an unnecessary exception catch in NNBench.  (Boris
    Shkolnik via szetszwo)

    HADOOP-5989. Fix streaming test failure.  (gkesavan)

    HADOOP-5981. Fix a bug in HADOOP-2838 in parsing mapred.child.env.
    (Amar Kamat via sharad)

    HADOOP-5420. Fix LinuxTaskController to kill tasks using the process
    groups they are launched with.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-6031. Remove @author tags from Java source files.  (Ravi Phulari
    via szetszwo)

    HADOOP-5980. Fix LinuxTaskController so tasks get passed 
    LD_LIBRARY_PATH and other environment variables.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-4041. IsolationRunner does not work as documented.
    (Philip Zeyliger via tomwhite)

    HADOOP-6004. Fixes BlockLocation deserialization.  (Jakob Homan via
    szetszwo)

    HADOOP-6079. Serialize proxySource as DatanodeInfo in DataTransferProtocol.
    (szetszwo)

    HADOOP-6096. Fix Eclipse project and classpath files following project
    split. (tomwhite)

    HADOOP-6122. The great than operator in test-patch.sh should be "-gt" but
    not ">".  (szetszwo)

    HADOOP-6114. Fix javadoc documentation for FileStatus.getLen.
    (Dmitry Rzhevskiy via dhruba)

    HADOOP-6131. A sysproperty should not be set unless the property 
    is set on the ant command line in build.xml (hong tang via mahadev)

    HADOOP-6137. Fix project specific test-patch requirements
    (Giridharan Kesavan)

    HADOOP-6138. Eliminate the deprecated warnings introduced by H-5438.
    (He Yongqiang via szetszwo)

    HADOOP-6132. RPC client create an extra connection because of incorrect
    key for connection cache. (Kan Zhang via rangadi)

    HADOOP-6123. Add missing classpaths in hadoop-config.sh.  (Sharad Agarwal
    via szetszwo)

    HADOOP-6172. Fix jar file names in hadoop-config.sh and include 
    ${build.src} as a part of the source list in build.xml.  (Hong Tang via 
    szetszwo)

    HADOOP-6124. Fix javac warning detection in test-patch.sh.  (Giridharan
    Kesavan via szetszwo)

    HADOOP-6177. FSInputChecker.getPos() would return position greater 
    than the file size. (Hong Tang via hairong)

    HADOOP-6188. TestTrash uses java.io.File api but not hadoop FileSystem api.
    (Boris Shkolnik via szetszwo)

    HADOOP-6192. Fix Shell.getUlimitMemoryCommand to not rely on Map-Reduce
    specific configs. (acmurthy) 

    HADOOP-6103. Clones the classloader as part of Configuration clone.
    (Amareshwari Sriramadasu via ddas)

    HADOOP-6152. Fix classpath variables in bin/hadoop-config.sh and some
    other scripts.  (Aaron Kimball via szetszwo)

    HADOOP-6215. fix GenericOptionParser to deal with -D with '=' in the 
    value. (Amar Kamat via sharad)

    HADOOP-6227. Fix Configuration to allow final parameters to be set to null
    and prevent them from being overridden.
    (Amareshwari Sriramadasu via yhemanth)

    HADOOP-6199. Move io.map.skip.index property to core-default from mapred.
    (Amareshwari Sriramadasu via cdouglas)

    HADOOP-6229. Attempt to make a directory under an existing file on
    LocalFileSystem should throw an Exception. (Boris Shkolnik via tomwhite)

    HADOOP-6243. Fix a NullPointerException in processing deprecated keys.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-6009. S3N listStatus incorrectly returns null instead of empty
    array when called on empty root. (Ian Nowland via tomwhite)

    HADOOP-6181.  Fix .eclipse.templates/.classpath for avro and jets3t jar
    files.  (Carlos Valiente via szetszwo)

    HADOOP-6196. Fix a bug in SequenceFile.Reader where syncing within the
    header would cause the reader to read the sync marker as a record. (Jay
    Booth via cdouglas)

    HADOOP-6250. Modify test-patch to delete copied XML files before running
    patch build. (Rahul Kumar Singh via yhemanth)

    HADOOP-6257. Two TestFileSystem classes are confusing
    hadoop-hdfs-hdfwithmr. (Philip Zeyliger via tomwhite)

    HADOOP-6151. Added a input filter to all of the http servlets that quotes
    html characters in the parameters, to prevent cross site scripting 
    attacks. (omalley)

    HADOOP-6274. Fix TestLocalFSFileContextMainOperations test failure.
    (Gary Murry via suresh).

    HADOOP-6281. Avoid null pointer exceptions when the jsps don't have 
    paramaters (omalley)

    HADOOP-6285. Fix the result type of the getParameterMap method in the
    HttpServer.QuotingInputFilter. (omalley)

    HADOOP-6286. Fix bugs in related to URI handling in glob methods in 
    FileContext. (Boris Shkolnik via suresh)

    HADOOP-6292. Update native libraries guide. (Corinne Chandel via cdouglas)

    HADOOP-6327. FileContext tests should not use /tmp and should clean up
    files.  (Sanjay Radia via szetszwo)

    HADOOP-6318. Upgrade to Avro 1.2.0.  (cutting)

    HADOOP-6334.  Fix GenericOptionsParser to understand URI for -files,
    -libjars and -archives options and fix Path to support URI with fragment.
    (Amareshwari Sriramadasu via szetszwo)

    HADOOP-6344. Fix rm and rmr immediately delete files rather than sending 
    to trash, if a user is over-quota. (Jakob Homan via suresh)

    HADOOP-6347. run-test-core-fault-inject runs a test case twice if
    -Dtestcase is set (cos)

    HADOOP-6375. Sync documentation for FsShell du with its implementation.
    (Todd Lipcon via cdouglas)

    HADOOP-6441. Protect web ui from cross site scripting attacks (XSS) on
    the host http header and using encoded utf-7. (omalley)

    HADOOP-6451. Fix build to run contrib unit tests. (Tom White via cdouglas)

    HADOOP-6374. JUnit tests should never depend on anything in conf.
    (Anatoli Fomenko via cos)

    HADOOP-6290. Prevent duplicate slf4j-simple jar via Avro's classpath.
    (Owen O'Malley via cdouglas)

    HADOOP-6293. Fix FsShell -text to work on filesystems other than the
    default. (cdouglas)

    HADOOP-6341. Fix test-patch.sh for checkTests function. (gkesavan)

    HADOOP-6314. Fix "fs -help" for the "-count" commond.  (Ravi Phulari via
    szetszwo)

    HADOOP-6405. Update Eclipse configuration to match changes to Ivy
    configuration (Edwin Chan via cos)

    HADOOP-6411. Remove deprecated file src/test/hadoop-site.xml. (cos)

    HADOOP-6386. NameNode's HttpServer can't instantiate InetSocketAddress:
    IllegalArgumentException is thrown (cos)

    HADOOP-6254. Slow reads cause s3n to fail with SocketTimeoutException.
    (Andrew Hitchcock via tomwhite)

    HADOOP-6428. HttpServer sleeps with negative values. (cos)

    HADOOP-6414. Add command line help for -expunge command.
    (Ravi Phulari via tomwhite)

    HADOOP-6391. Classpath should not be part of command line arguments.
    (Cristian Ivascu via tomwhite)

    HADOOP-6462. Target "compile" does not exist in contrib/cloud. (tomwhite)

    HADOOP-6402. testConf.xsl is not well-formed XML. (Steve Loughran
    via tomwhite)

    HADOOP-6489. Fix 3 findbugs warnings. (Erik Steffl via suresh)

    HADOOP-6517. Fix UserGroupInformation so that tokens are saved/retrieved
    to/from the embedded Subject (Owen O'Malley & Kan Zhang via ddas)

    HADOOP-6538. Sets hadoop.security.authentication to simple by default.
    (ddas)

    HADOOP-6540. Contrib unit tests have invalid XML for core-site, etc.
    (Aaron Kimball via tomwhite)

    HADOOP-6521. User specified umask using deprecated dfs.umask must override
    server configured using new dfs.umaskmode for backward compatibility.
    (suresh)
    
    HADOOP-6522. Fix decoding of codepoint zero in UTF8. (cutting)

    HADOOP-6505. Use tr rather than sed to effect literal substitution in the
    build script. (Allen Wittenauer via cdouglas)

    HADOOP-6548. Replace mortbay imports with commons logging. (cdouglas)

    HADOOP-6560. Handle invalid har:// uri in HarFileSystem.  (szetszwo)

    HADOOP-6549. TestDoAsEffectiveUser should use ip address of the host
     for superuser ip check(jnp via boryas)

    HADOOP-6570. RPC#stopProxy throws NPE if getProxyEngine(proxy) returns
    null. (hairong)

    HADOOP-6558. Return null in HarFileSystem.getFileChecksum(..) since no
    checksum algorithm is implemented.  (szetszwo)

    HADOOP-6572. Makes sure that SASL encryption and push to responder
    queue for the RPC response happens atomically. (Kan Zhang via ddas)

    HADOOP-6545. Changes the Key for the FileSystem cache to be UGI (ddas)

    HADOOP-6609. Fixed deadlock in RPC by replacing shared static 
    DataOutputBuffer in the UTF8 class with a thread local variable. (omalley)

    HADOOP-6504. Invalid example in the documentation of
    org.apache.hadoop.util.Tool. (Benoit Sigoure via tomwhite)

    HADOOP-6546. BloomMapFile can return false negatives. (Clark Jefcoat
    via tomwhite)

    HADOOP-6593. TextRecordInputStream doesn't close SequenceFile.Reader.
    (Chase Bradford via tomwhite)

    HADOOP-6175. Incorrect version compilation with es_ES.ISO8859-15 locale
    on Solaris 10. (Urko Benito via tomwhite)

    HADOOP-6645.  Bugs on listStatus for HarFileSystem (rodrigo via mahadev)

    HADOOP-6645. Re: Bugs on listStatus for HarFileSystem (rodrigo via
    mahadev)

    HADOOP-6654. Fix code example in WritableComparable javadoc.  (Tom White
    via szetszwo)

    HADOOP-6640. FileSystem.get() does RPC retries within a static
    synchronized block. (hairong)

    HADOOP-6691. TestFileSystemCaching sometimes hangs. (hairong)

    HADOOP-6507. Hadoop Common Docs - delete 3 doc files that do not belong
    under Common. (Corinne Chandel via tomwhite)

    HADOOP-6439. Fixes handling of deprecated keys to follow order in which
    keys are defined. (V.V.Chaitanya Krishna via yhemanth)

    HADOOP-6690. FilterFileSystem correctly handles setTimes call.
    (Rodrigo Schmidt via dhruba)

    HADOOP-6703. Prevent renaming a file, directory or symbolic link to
    itself. (Eli Collins via suresh)

    HADOOP-6710. Symbolic umask for file creation is not conformant with posix.
    (suresh)
    
    HADOOP-6719. Insert all missing methods in FilterFs.
    (Rodrigo Schmidt via dhruba)

    HADOOP-6724. IPC doesn't properly handle IOEs thrown by socket factory.
    (Todd Lipcon via tomwhite)

    HADOOP-6722. NetUtils.connect should check that it hasn't connected a socket
    to itself. (Todd Lipcon via tomwhite)

    HADOOP-6634. Fix AccessControlList to use short names to verify access 
    control. (Vinod Kumar Vavilapalli via sharad)

    HADOOP-6709. Re-instate deprecated FileSystem methods that were removed
    after 0.20. (tomwhite)
 
    HADOOP-6630. hadoop-config.sh fails to get executed if hadoop wrapper
    scripts are in path. (Allen Wittenauer via tomwhite)

    HADOOP-6742. Add methods HADOOP-6709 from to TestFilterFileSystem.
    (Eli Collins via tomwhite)

    HADOOP-6727. Remove UnresolvedLinkException from public FileContext APIs.
    (Eli Collins via tomwhite)

    HADOOP-6631. Fix FileUtil.fullyDelete() to continue deleting other files 
    despite failure at any level. (Contributed by Ravi Gummadi and 
    Vinod Kumar Vavilapalli)

    HADOOP-6723.  Unchecked exceptions thrown in IPC Connection should not
    orphan clients.  (Todd Lipcon via tomwhite)

    HADOOP-6404. Rename the generated artifacts to common instead of core.
    (tomwhite)

    HADOOP-6461.  Webapps aren't located correctly post-split.
    (Todd Lipcon and Steve Loughran via tomwhite)

    HADOOP-6826.  Revert FileSystem create method that takes CreateFlags.
    (tomwhite)

    HADOOP-6800.  Harmonize JAR library versions.  (tomwhite)

    HADOOP-6847. Problem staging 0.21.0 artifacts to Apache Nexus Maven
    Repository (Giridharan Kesavan via cos)

    HADOOP-6819. [Herriot] Shell command for getting the new exceptions in
    the logs returning exitcode 1 after executing successfully. (Vinay Thota
    via cos)

    HADOOP-6839. [Herriot] Implement a functionality for getting the user list
    for creating proxy users. (Vinay Thota via cos)

    HADOOP-6836. [Herriot]: Generic method for adding/modifying the attributes
    for new configuration. (Vinay Thota via cos)

    HADOOP-6860. 'compile-fault-inject' should never be called directly.
    (Konstantin Boudnik)

    HADOOP-6790. Instrumented (Herriot) build uses too wide mask to include
    aspect files. (Konstantin Boudnik)

    HADOOP-6875. [Herriot] Cleanup of temp. configurations is needed upon
    restart of a cluster (Vinay Thota via cos)

Release 0.20.3 - Unreleased

  NEW FEATURES

    HADOOP-6637. Benchmark for establishing RPC session. (shv)

  BUG FIXES

    HADOOP-6760. WebServer shouldn't increase port number in case of negative
    port setting caused by Jetty's race (cos)
    
    HADOOP-6881. Make WritableComparator intialize classes when
    looking for their raw comparator, as classes often register raw
    comparators in initializers, which are no longer automatically run
    in Java 6 when a class is referenced. (cutting via omalley)

    HADOOP-7072. Remove java5 dependencies from build. (cos)

Release 0.20.204.0 - Unreleased

  NEW FEATURES

    HADOOP-6255. Create RPM and Debian packages for common. Changes deployment
    layout to be consistent across the binary tgz, rpm, and deb. Adds setup
    scripts for easy one node cluster configuration and user creation.
    (Eric Yang via omalley)

Release 0.20.203.0 - 2011-5-11

  BUG FIXES

    HADOOP-7258. The Gzip codec should not return null decompressors. (omalley)

Release 0.20.2 - 2010-2-16

  NEW FEATURES

    HADOOP-6218. Adds a feature where TFile can be split by Record
    Sequence number. (Hong Tang and Raghu Angadi via ddas)

  BUG FIXES

    HADOOP-6231. Allow caching of filesystem instances to be disabled on a
    per-instance basis. (tomwhite)

    HADOOP-5759. Fix for IllegalArgumentException when CombineFileInputFormat
    is used as job InputFormat. (Amareshwari Sriramadasu via dhruba)

    HADOOP-6097. Fix Path conversion in makeQualified and reset LineReader byte
    count at the start of each block in Hadoop archives. (Ben Slusky, Tom
    White, and Mahadev Konar via cdouglas)

    HADOOP-6269. Fix threading issue with defaultResource in Configuration.
    (Sreekanth Ramakrishnan via cdouglas)

    HADOOP-6460. Reinitializes buffers used for serializing responses in ipc
    server on exceeding maximum response size to free up Java heap. (suresh)

    HADOOP-6315. Avoid incorrect use of BuiltInflater/BuiltInDeflater in
    GzipCodec. (Aaron Kimball via cdouglas)

    HADOOP-6498. IPC client bug may cause rpc call hang. (Ruyue Ma and
    hairong via hairong)

  IMPROVEMENTS

    HADOOP-5611. Fix C++ libraries to build on Debian Lenny. (Todd Lipcon
    via tomwhite)

    HADOOP-5612. Some c++ scripts are not chmodded before ant execution.
    (Todd Lipcon via tomwhite)

    HADOOP-1849. Add undocumented configuration parameter for per handler 
    call queue size in IPC Server. (shv)

Release 0.20.1 - 2009-09-01

  INCOMPATIBLE CHANGES

    HADOOP-5726. Remove pre-emption from capacity scheduler code base.
    (Rahul Kumar Singh via yhemanth)

    HADOOP-5881. Simplify memory monitoring and scheduling related
    configuration. (Vinod Kumar Vavilapalli via yhemanth)

  NEW FEATURES

    HADOOP-6080. Introduce -skipTrash option to rm and rmr.
    (Jakob Homan via shv)

    HADOOP-3315. Add a new, binary file foramt, TFile. (Hong Tang via cdouglas)

  IMPROVEMENTS

    HADOOP-5711. Change Namenode file close log to info. (szetszwo)

    HADOOP-5736. Update the capacity scheduler documentation for features
    like memory based scheduling, job initialization and removal of pre-emption.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5714. Add a metric for NameNode getFileInfo operation. (Jakob Homan
    via szetszwo)

    HADOOP-4372. Improves the way history filenames are obtained and manipulated.
    (Amar Kamat via ddas)

    HADOOP-5897. Add name-node metrics to capture java heap usage.
    (Suresh Srinivas via shv)

  OPTIMIZATIONS

  BUG FIXES

    HADOOP-5691. Makes org.apache.hadoop.mapreduce.Reducer concrete class
    instead of abstract. (Amareshwari Sriramadasu via sharad)

    HADOOP-5646. Fixes a problem in TestQueueCapacities.
    (Vinod Kumar Vavilapalli via ddas)

    HADOOP-5655. TestMRServerPorts fails on java.net.BindException. (Devaraj
    Das via hairong)

    HADOOP-5654. TestReplicationPolicy.<init> fails on java.net.BindException.
    (hairong)

    HADOOP-5688. Fix HftpFileSystem checksum path construction. (Tsz Wo
    (Nicholas) Sze via cdouglas)

    HADOOP-4674. Fix fs help messages for -test, -text, -tail, -stat 
    and -touchz options.  (Ravi Phulari via szetszwo)

    HADOOP-5718. Remove the check for the default queue in capacity scheduler.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5719. Remove jobs that failed initialization from the waiting queue
    in the capacity scheduler. (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-4744. Attaching another fix to the jetty port issue. The TaskTracker
    kills itself if it ever discovers that the port to which jetty is actually
    bound is invalid (-1). (ddas)

    HADOOP-5349. Fixes a problem in LocalDirAllocator to check for the return
    path value that is returned for the case where the file we want to write
    is of an unknown size. (Vinod Kumar Vavilapalli via ddas)

    HADOOP-5636. Prevents a job from going to RUNNING state after it has been
    KILLED (this used to happen when the SetupTask would come back with a 
    success after the job has been killed). (Amar Kamat via ddas)

    HADOOP-5641. Fix a NullPointerException in capacity scheduler's memory
    based scheduling code when jobs get retired. (yhemanth)

    HADOOP-5828. Use absolute path for mapred.local.dir of JobTracker in
    MiniMRCluster. (yhemanth)

    HADOOP-4981. Fix capacity scheduler to schedule speculative tasks 
    correctly in the presence of High RAM jobs.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5210. Solves a problem in the progress report of the reduce task.
    (Ravi Gummadi via ddas)

    HADOOP-5850. Fixes a problem to do with not being able to jobs with
    0 maps/reduces. (Vinod K V via ddas)

    HADOOP-4626. Correct the API links in hdfs forrest doc so that they
    point to the same version of hadoop.  (szetszwo)

    HADOOP-5883. Fixed tasktracker memory monitoring to account for
    momentary spurts in memory usage due to java's fork() model.
    (yhemanth)

    HADOOP-5539. Fixes a problem to do with not preserving intermediate
    output compression for merged data.
    (Jothi Padmanabhan and Billy Pearson via ddas)

    HADOOP-5932. Fixes a problem in capacity scheduler in computing
    available memory on a tasktracker.
    (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-5908. Fixes a problem to do with ArithmeticException in the 
    JobTracker when there are jobs with 0 maps. (Amar Kamat via ddas)

    HADOOP-5924. Fixes a corner case problem to do with job recovery with
    empty history files. Also, after a JT restart, sends KillTaskAction to 
    tasks that report back but the corresponding job hasn't been initialized
    yet. (Amar Kamat via ddas)

    HADOOP-5882. Fixes a reducer progress update problem for new mapreduce
    api. (Amareshwari Sriramadasu via sharad)

    HADOOP-5746. Fixes a corner case problem in Streaming, where if an exception
    happens in MROutputThread after the last call to the map/reduce method, the 
    exception goes undetected. (Amar Kamat via ddas)

    HADOOP-5884. Fixes accounting in capacity scheduler so that high RAM jobs
    take more slots. (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-5937. Correct a safemode message in FSNamesystem.  (Ravi Phulari
    via szetszwo)

    HADOOP-5869. Fix bug in assignment of setup / cleanup task that was
    causing TestQueueCapacities to fail.
    (Sreekanth Ramakrishnan via yhemanth)

    HADOOP-5921. Fixes a problem in the JobTracker where it sometimes never used
    to come up due to a system file creation on JobTracker's system-dir failing. 
    This problem would sometimes show up only when the FS for the system-dir 
    (usually HDFS) is started at nearly the same time as the JobTracker. 
    (Amar Kamat via ddas)

    HADOOP-5920. Fixes a testcase failure for TestJobHistory. 
    (Amar Kamat via ddas)

    HADOOP-6139. Fix the FsShell help messages for rm and rmr.  (Jakob Homan
    via szetszwo)

    HADOOP-6145. Fix FsShell rm/rmr error messages when there is a FNFE.
    (Jakob Homan via szetszwo)

    HADOOP-6150. Users should be able to instantiate comparator using TFile
    API. (Hong Tang via rangadi)

Release 0.20.0 - 2009-04-15

  INCOMPATIBLE CHANGES

    HADOOP-4210. Fix findbugs warnings for equals implementations of mapred ID
    classes. Removed public, static ID::read and ID::forName; made ID an
    abstract class. (Suresh Srinivas via cdouglas)

    HADOOP-4253. Fix various warnings generated by findbugs. 
    Following deprecated methods in RawLocalFileSystem are removed:
  	  public String getName()
  	  public void lock(Path p, boolean shared)
  	  public void release(Path p) 
    (Suresh Srinivas via johan)

    HADOOP-4618. Move http server from FSNamesystem into NameNode.
    FSNamesystem.getNameNodeInfoPort() is removed.
    FSNamesystem.getDFSNameNodeMachine() and FSNamesystem.getDFSNameNodePort()
      replaced by FSNamesystem.getDFSNameNodeAddress().
    NameNode(bindAddress, conf) is removed.
    (shv)

    HADOOP-4567. GetFileBlockLocations returns the NetworkTopology
    information of the machines where the blocks reside. (dhruba)

    HADOOP-4435. The JobTracker WebUI displays the amount of heap memory 
    in use. (dhruba)

    HADOOP-4628. Move Hive into a standalone subproject. (omalley)

    HADOOP-4188. Removes task's dependency on concrete filesystems.
    (Sharad Agarwal via ddas)

    HADOOP-1650. Upgrade to Jetty 6. (cdouglas)

    HADOOP-3986. Remove static Configuration from JobClient. (Amareshwari
    Sriramadasu via cdouglas)
      JobClient::setCommandLineConfig is removed
      JobClient::getCommandLineConfig is removed
      JobShell, TestJobShell classes are removed

    HADOOP-4422. S3 file systems should not create bucket.
    (David Phillips via tomwhite)

    HADOOP-4035. Support memory based scheduling in capacity scheduler.
    (Vinod Kumar Vavilapalli via yhemanth)

    HADOOP-3497. Fix bug in overly restrictive file globbing with a
    PathFilter. (tomwhite)

    HADOOP-4445. Replace running task counts with running task
    percentage in capacity scheduler UI. (Sreekanth Ramakrishnan via
    yhemanth)

    HADOOP-4631. Splits the configuration into three parts - one for core,
